/*--------------------------------------------------------------------*/
/* This file contains all the I/O low level function definition used  */
/* by the Frame Library.                                              */
/*     (Code proposed by Roy Willams, Caltech) (Jun 14, 1999 version) */
/*--------------------------------------------------------------------*/
#include <fcntl.h>

struct FrIO{
#ifdef FRIOCFILE
    FILE *fp;
#else
    int fd;
#endif
};

struct FrIO *FrIOOpenR(char* filename);
struct FrIO *FrIOOpenW(char* filename);
int FrIOClose(struct FrIO *fd);
int FrIOWrite(struct FrIO *fd, char* buf, int nbyte);
int FrIORead(struct FrIO *fd, char* buf, int nbyte);
int FrIOSet(struct FrIO *frfd, long offset);
int FrIOSetFromEnd(struct FrIO *frfd, long offset);
int FrIOSetFromCur(struct FrIO *frfd, long offset);
