#define _POSIX_SOURCE 
/* *********************************************************************
******** FrMark.c ******************************* FrMark.c *************
******** FrMark.c ******************************* FrMark.c *************
********************************************************************* */
/*  by B.Mours LAPP (Annecy) August 23, 1999*/

/*--------------------------------------------------- FrAdcDataReadN--*/
struct FrAdcData *FrAdcDataReadN(struct FrFile *iFile,
                                 char *name,
                                 int runN,
                                 int frameN)
/*--------------------------------------------------------------------*/
/* reads the frame for the given frame and run number                 */
{struct FrAdcData *adc;
 struct FrDataMark *dm;
 struct FrFileMark *mark;
 unsigned short type;
 unsigned int length, i;

                 /*-------- first make sure the mark are available ---*/

 if(iFile == NULL) return(NULL);

 if(iFile->mark == NULL) 
    {FrFileMarkRead(iFile);}
 mark = iFile->mark;
 if(mark == NULL) return(NULL);

                                    /*------ find adc mark ---------*/

 dm = mark->adcMark;
 while(dm != NULL)
   {if(strcmp(name, dm->name) == 0)  break;
    dm = dm->next;}
 if(dm == NULL) return(NULL); 
                                   /*------- find frame ------------*/

 for(i=0; i<mark->nFrame; i++)
   {if(mark->frame[i] != frameN) continue;
    if(mark->run[i]   == runN)   break;} 
 
 if(i == mark->nFrame) return(NULL);

                  /*---- set the file pointer and read the data -------*/

 if(FrIOSet(iFile->frfd, dm->position[i]) == -1) {return (NULL);}
          
 iFile->relocation = FR_NO;        /*--- to avoid relloaction problems---*/
  
 FrReadInt  (iFile, (int *) &length);
 FrReadShort(iFile, (short *) &type);
 FrAdcDataRead(iFile);
 adc = (struct FrAdcData *) iFile->address;

                /*-----search for FrVect (skip type 1 or 2 records)----*/

 while(iFile->error == FR_OK)
    {FrReadInt(  iFile,(int *) &length);
     FrReadShort(iFile,(short *) &type);
     if((type != 1) && (type != 2))  break;

     FrIOSetFromCur(iFile->frfd, (long) (length-6));}

 FrVectRead(iFile);
 adc->data = (struct FrVect *) iFile->address;
 iFile->relocation = FR_YES;      

 return(adc);}
/*--------------------------------------------------- FrAdcDataReadT--*/
struct FrAdcData *FrAdcDataReadT(struct FrFile *iFile,
                                 char *name,
                                 double gtime,
                                 double dt)
/*--------------------------------------------------------------------*/
/* reads the frame for the given frame and run number                 */
{struct FrAdcData *adc;
 struct FrDataMark *dm;
 struct FrFileMark *mark;
 unsigned short type;
 unsigned int length, i, iBest;
 double d,dMin;

                 /*-------- first make sure the mark are available ---*/

 if(iFile == NULL) return(NULL);

 if(iFile->mark == NULL) 
    {FrFileMarkRead(iFile);}
 mark = iFile->mark;
 if(mark == NULL) return(NULL);

                                    /*------ find adc mark ---------*/

 dm = mark->adcMark;
 while(dm != NULL)
   {if(strcmp(name, dm->name) == 0)  break;
    dm = dm->next;}
 if(dm == NULL) return(NULL); 
                                   /*------- find frame ------------*/

 iBest = 0;
 dMin = gtime - mark->GTime[0];
 if(dMin < 0) dMin = -dMin;

 for(i=1; i<mark->nFrame; i++)
   {d = gtime - mark->GTime[i];
    if(d < 0) d = -d;
    if(d > dMin) continue;
    iBest = i;
    dMin = d;}
 if(dMin > dt) return(NULL);

                  /*---- set the file pointer and read the data -------*/

 if(FrIOSet(iFile->frfd, dm->position[iBest]) == -1) {return (NULL);}
          
 iFile->relocation = FR_NO;        /*--- to avoid relloaction problems---*/
  
 FrReadInt  (iFile, (int *) &length);
 FrReadShort(iFile, (short *) &type);
 FrAdcDataRead(iFile);
 adc = (struct FrAdcData *) iFile->address;

                /*-----search for FrVect (skip type 1 or 2 records)----*/

 while(iFile->error == FR_OK)
    {FrReadInt(  iFile,(int *) &length);
     FrReadShort(iFile,(short *) &type);
     if((type != 1) && (type != 2))  break;

     FrIOSetFromCur(iFile->frfd, (long) length-6);}

 FrVectRead(iFile);
 adc->data = (struct FrVect *) iFile->address;
 iFile->relocation = FR_YES;      

 return(adc);}

/*------------------------------------------------------- FrameReadN--*/
struct FrameH *FrameReadN(struct FrFile *iFile,
                          int runN,
                          int frameN)
/*--------------------------------------------------------------------*/
/* reads the frame for the given frame and run number                 */
{struct FrameH *frame;
 struct FrFileMark *mark;
 int i;

 if(iFile == NULL) return(NULL);

 if(iFile->mark == NULL) 
    {FrFileMarkRead(iFile);}
 mark = iFile->mark;
 if(mark == NULL) return(NULL);

 for(i=0; i<mark->nFrame; i++)
   {if(mark->frame[i] != frameN) continue;
    if(mark->run[i]   == runN)   break;} 
 
 if(i == mark->nFrame) return(NULL);

 if(FrIOSet(iFile->frfd, mark->frPos[i]) == -1) {return (NULL);}

 frame = FrameRead(iFile);

 FrFileMarkGetStatD(iFile, frame);
 
 return(frame);}
/*------------------------------------------------------- FrameReadT--*/
struct FrameH *FrameReadT(struct FrFile *iFile,
                          double gtime,
                          double dt)
/*--------------------------------------------------------------------*/
/* reads the frame for the given GPS starting time                    */
{struct FrameH *frame;
 struct FrFileMark *mark;
 int i, iBest;
 double d,dMin;

 if(iFile == NULL) return(NULL);

 if(iFile->mark == NULL) 
    {FrFileMarkRead(iFile);}
 mark = iFile->mark;
 if(mark == NULL) return(NULL);

 iBest = 0;
 dMin = gtime - mark->GTime[0];
 if(dMin < 0) dMin = -dMin;

 for(i=1; i<mark->nFrame; i++)
   {d = gtime - mark->GTime[i];
    if(d < 0) d = -d;
    if(d > dMin) continue;
    iBest = i;
    dMin = d;}
 if(dMin > dt) return(NULL);

 if(FrIOSet(iFile->frfd, mark->frPos[iBest]) == -1) {return (NULL);}

 frame = FrameRead(iFile);

 FrFileMarkGetStatD(iFile, frame);
 
 return(frame);}

/*------------------------------------------ FrStatDataReadFromMark---*/
void FrFileMarkGetStatD(struct FrFile *iFile,
                        struct FrameH *frame)
/*--------------------------------------------------------------------*/
/* This function read all the static data valid for this frame        */
{struct FrStatData *sData;
 struct FrStatMark *sm;
 struct FrDetector *detector;
 unsigned short type;
 unsigned int length, i;

  if(frame == NULL) return;

  sm = iFile->mark->statMark;
  while(sm != NULL)
    {for(i=0; i<sm->nStat; i++)
      {if(sm->tStart[i] > frame->GTimeS) continue;
       if(sm->tEnd[i]   < frame->GTimeS) continue;

             /*--- the validity range is ok, read this static data ---*/

       if(FrIOSet(iFile->frfd, sm->position[i]) == -1) {return;}

       iFile->relocation = FR_NO;   /*-to avoid relloaction problems---*/
 
       FrReadInt  (iFile, (int *) &length);
       FrReadShort(iFile, (short *) &type);
       FrStatDataRead(iFile);
       sData = (struct FrStatData *) iFile->address;

                /*-----search for FrVect (skip type 1 or 2 records)----*/

       while(iFile->error == FR_OK)
         {FrReadInt(  iFile,(int *) &length);
          FrReadShort(iFile,(short *) &type);
          if((type != 1) && (type != 2))  break;

          FrIOSetFromCur(iFile->frfd, (long) length-6);}

       FrVectRead(iFile); 
       sData->data = (struct FrVect *) iFile->address;

       iFile->relocation = FR_YES; 

                   /*------- attache it to the right detector --------*/

       detector = frame->detectProc;
       if(frame->detectSim != NULL)
          {if(strcmp(sm->name,frame->detectSim->name) == 0) 
	    {detector = frame->detectSim;}}

       FrStatDataAdd(detector, sData);

       /*-------- check the validity range -------*/

       if(frame->detectSim != NULL)
           {FrStatDataChkT(&frame->detectSim->sData,
			    frame->GTimeS, frame->GTimeS + frame->dt);}
       if(frame->detectProc != NULL)
           {FrStatDataChkT(&frame->detectProc->sData,
			    frame->GTimeS, frame->GTimeS + frame->dt);}
       }

    sm = sm->next;}

  return;}
/*------------------------------------------------- FrFileMarkData----*/
void FrFileMarkData(struct FrFile *oFile,
                    struct FrDataMark *firstMark,
                    char *name)
/*--------------------------------------------------------------------*/
{struct FrDataMark *dm;
 
                      /*-------- find dataMark structure -------------*/

 if(name == NULL)  return;

 dm = firstMark;
 while(dm != NULL)
   {if(strcmp(dm->name, name) == 0) break;
    dm = dm->next;}
                      /*-------------- fill information--------------*/

 if(dm != NULL)
   {dm->position[oFile->mark->nFrame-1]= oFile->nBytes;}

 return;}

/*------------------------------------------------- FrFileMarkDef ----*/
struct FrSH *FrFileMarkDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrFileMark",NULL);

  FrSENew(classe, "STRING", "name","-");

  FrSENew(classe, "INT_2U", "ULeaps","-"); 
  FrSENew(classe, "INT_4S", "localTime","-"); 
  FrSENew(classe, "INT_4U", "nFrame","-"); 
  FrSENew(classe, "*",      "*run","-");
  FrSENew(classe, "*",      "*frame","-");
  FrSENew(classe, "*",      "*GTime","-");
  FrSENew(classe, "*",      "*frPos","-");
  FrSENew(classe, "INT_4U", "*","-"); 
  FrSENew(classe, "INT_2U", "nSH","-"); 
  FrSENew(classe, "*",      "*SHid","-");
  FrSENew(classe, "*",      "*SNname","-");

  return(classe);}

/*-------------------------------------------------- FrFileMarkDump---*/
void FrFileMarkDump(struct FrFileMark *mark)
/*--------------------------------------------------------------------*/
{long size, i, gts;
 struct FrStatMark *sm;
 struct FrDataMark *dm;

 if(mark == NULL)   return;
 if(FrDebugLvl < 1) return;

 printf(" Dump file marks: ULeaps=%d localTime=%d\n",
                 mark->ULeapS,  mark->localTime);

                            /*------------ SH information -----------*/

 printf("  Number of SH structure: %d\n",mark->nSH);
 for(i=0; i<mark->nSH; i++)
   {printf("    id=%4d for:%s\n",mark->SHid[i],mark->SHname[i]);}

                        /*-------------- Frame information ----------*/

 printf("  Number of frames: %d\n",mark->nFrame);
 printf("   run#  frame#    GPS starting timeS     (sec)    "
        "        position  size(B) \n");
 size = 0;
 for(i=0; i<mark->nFrame; i++)
    {gts = mark->GTime[i];
     if(i==0) {printf("%7d %7d %s (%14.4f) %9ld", 
                     mark->run[i],mark->frame[i], FrStrGTime(gts),
		     mark->GTime[i], mark->frPos[i]);}
    else {printf(" %8ld \n%7d %7d %s (%14.4f) %9ld", 
             size, mark->run[i],mark->frame[i], FrStrGTime(gts),
             mark->GTime[i], mark->frPos[i]);}
     if(i <mark->nFrame -1) size = mark->frPos[i+1] - mark->frPos[i];}
 
 printf("        -\n");
 if(FrDebugLvl < 2) return;

                        /*--------- Static Data information ---------*/

 printf(" Number of static data blocks: %d\n",mark->nStat);
 sm = mark->statMark;
 while(sm != NULL)
   {printf(" For Static Data:%s   detector:%s    %d instances\n",
         sm->name, sm->detector, sm->nStat);
    printf("     TStart      TEnd      version      position\n");
    for(i=0; i<sm->nStat; i++)
      {printf("     %9d %9d %7d %14ld\n",sm->tStart[i],sm->tEnd[i],
                 sm->version[i],sm->position[i]);}
    sm = sm->next;}
                              /*--------- Adc information ---------*/

 printf(" Number of ADC: %d\n",mark->nAdc);
 dm = mark->adcMark;
 while(dm != NULL)
   {printf("   For ADC:%30s position:", dm->name);
    for(i=0; i<mark->nFrame; i++)
      {printf(" %ld",dm->position[i]);
       if(i < 4) continue;
       printf(" ....");
       break;}
    printf("\n");
    dm = dm->next;}

 return;}
/*-------------------------------------------------- FrFileMarkFree---*/
void FrFileMarkFree(struct FrFileMark *mark)
/*--------------------------------------------------------------------*/
{long i;
 struct FrStatMark *sm, *nextSm;
 struct FrDataMark *dm, *nextDm;

 if(mark == NULL)   return;

                        /*--------- Static Data information ---------*/

 sm = mark->statMark;
 while(sm != NULL)
   {nextSm = sm->next;
    free(sm->name);
    free(sm->detector);
    free(sm->tStart);
    free(sm->tEnd);
    free(sm->version);
    free(sm->position);
    free(sm);
    sm = nextSm;}
                              /*--------- Adc information ---------*/

 dm = mark->adcMark;
 while(dm != NULL)
   {nextDm = dm->next;
    free(dm->name);
    free(dm->position);
    free(dm);
    dm = nextDm;}

 free(mark->run);
 free(mark->frame);
 free(mark->GTime);
 free(mark->frPos);
 free(mark->SHid);
 for(i=0; i<mark->nSH; i++)
    {free(mark->SHname[i]);}
 free(mark->SHname);

 free(mark);

 return;
}

/*------------------------------------------------- FrFileMarkSH------*/
void FrFileMarkSH(struct FrFile *oFile, 
                  char *name, 
                  unsigned short id)
/*--------------------------------------------------------------------*/
{struct FrFileMark *mark;
 
  mark = oFile->mark;
  if(mark == NULL) return;

  if(mark->nSH >= FRMAPMAXSH) return;
  mark->SHid[mark->nSH] = id;
  FrStrCpy(&mark->SHname[mark->nSH], name);
  mark->nSH ++;

  return;}

/*------------------------------------------------- FrFileMarkStatD---*/
void FrFileMarkStatD(struct FrFile *oFile,
                     struct FrStatData *sData)
/*--------------------------------------------------------------------*/
{struct FrStatMark *sm;
 
                        /*-------- find MarkSD structure -------------*/

 if(sData == NULL)       return;
 if(oFile->mark == NULL) return;

 sm = oFile->mark->statMark;
 while(sm != NULL)
   {if((strcmp(sData->detector->name, sm->detector) == 0) &&
       (strcmp(sData->name,           sm->name) == 0)) break;
    sm = sm->next;}

                       /*----- create a new FrStatMark if needed ----*/
 if(sm == NULL) 
   {sm = (struct FrStatMark *) malloc(sizeof(struct FrStatMark));
    if(sm == NULL)
       {FrError(3,"FrFileMarkStatD"," malloc failed");
        oFile->error = FR_ERROR_MALLOC_FAILED; 
        return;}
    FrStrCpy(&sm->detector, sData->detector->name);
    FrStrCpy(&sm->name, sData->name);
    sm->maxStat = 4;
    sm->nStat = 0;
    sm->version = (unsigned  int *)malloc(sizeof(int)  * sm->maxStat);
    sm->tStart  = (unsigned  int *)malloc(sizeof(int)  * sm->maxStat);
    sm->tEnd    = (unsigned  int *)malloc(sizeof(int)  * sm->maxStat);
    sm->position= (         long *)malloc(sizeof(long) * sm->maxStat);
    if((sm->detector  == NULL) ||
       (sm->name      == NULL) ||
       (sm->version   == NULL) ||
       (sm->tStart    == NULL) ||
       (sm->tEnd      == NULL) ||
       (sm->position== NULL))
         {FrError(3,"FrFileMarkStatD"," malloc failed");
          oFile->error = FR_ERROR_MALLOC_FAILED; 
          return;}
    sm->next = oFile->mark->statMark;
    oFile->mark->statMark = sm;
    oFile->mark->nStat++;}

                       /*-------- increase space if needed -----------*/

 if(sm->nStat+1 >= sm->maxStat)
   {sm->maxStat = 2 * sm->maxStat;

    sm->version = (unsigned  int *)realloc(sm->version,
                             sizeof(int) * sm->maxStat);
    sm->tStart  = (unsigned  int *)realloc(sm->tStart,
                             sizeof(int) * sm->maxStat);
    sm->tEnd    = (unsigned  int *)realloc(sm->tEnd,
                             sizeof(int) * sm->maxStat);
    sm->position= (         long *)realloc(sm->position,
                            sizeof(long) * sm->maxStat);
    if((sm->version == NULL) ||
       (sm->tStart  == NULL) ||
       (sm->tEnd    == NULL) ||
       (sm->position== NULL))
           {FrError(3,"FrFileMarkStatD"," realloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}}
                       /*-------------- fill information--------------*/

 sm->version[sm->nStat] = sData->version;
 sm->tStart[sm->nStat]  = sData->timeStart;
 sm->tEnd[sm->nStat]    = sData->timeEnd;
 sm->position[sm->nStat]= oFile->nBytes;
 sm->nStat++;

 return;}

/*------------------------------------------------- FrFileMarkFrame---*/
void FrFileMarkFrame(struct FrFile *oFile,
                     struct FrameH *frame)
/*--------------------------------------------------------------------*/
{struct FrFileMark *mark;
 struct FrDataMark *dm;
 
 if(oFile->mark == NULL) FrFileMarkNew(oFile, frame);
 mark = oFile->mark; 
 if(mark == NULL) return;

                       /*-------- increase space if needed -----------*/

 if(mark->nFrame+1 >= mark->maxFrame)
   {mark->maxFrame = 2 * mark->maxFrame;

    mark->run    = (unsigned  int *)realloc(mark->run,
                              sizeof(int) * mark->maxFrame);
    mark->frame  = (unsigned  int *)realloc(mark->frame,
                              sizeof(int) * mark->maxFrame);
    mark->GTime  =        (double *)realloc(mark->GTime,
                           sizeof(double) * mark->maxFrame);
    mark->frPos  =          (long *)realloc(mark->frPos,
                             sizeof(long) * mark->maxFrame);

    if((mark->run   == NULL) ||
       (mark->frame == NULL) ||
       (mark->GTime == NULL) ||
       (mark->frPos == NULL))
           {FrError(3,"FrFileMarkFrame"," realloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}

                 /*-------- increase storage for adc information ----*/

    dm = mark->adcMark;
    while(dm != NULL)
      {dm->position  = (long *)realloc(dm->position,
                             sizeof(long) * mark->maxFrame);
       if((dm->position == NULL))
           {FrError(3,"FrFileMarkFrame"," realloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}

       dm = dm->next;}
    }

                       /*-------------- fill information--------------*/

 mark->run[mark->nFrame]   = frame->run;
 mark->frame[mark->nFrame] = frame->frame;
 mark->GTime[mark->nFrame] = frame->GTimeS + 1.e-9 * frame->GTimeN;
 mark->frPos[mark->nFrame] = oFile->nBytes;
 mark->nFrame++;

 return;}


/*--------------------------------------------------- FrFileMarkNew---*/
void FrFileMarkNew(struct FrFile *oFile, 
                   struct FrameH *frame)
/*--------------------------------------------------------------------*/
{struct FrFileMark *mark;
 struct FrDataMark *dm;
 struct FrAdcData  *adc;

  mark = malloc(sizeof(struct FrFileMark));
  if(mark == NULL)
           {FrError(3,"FrFileMarkNew"," malloc failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}
  mark->classe = FrFileMarkDef();

  oFile->mark = mark;

  mark->ULeapS    = frame->ULeapS;
  mark->localTime = frame->localTime;
  mark->nFrame    = 0;
  mark->nSH       = 0;
  mark->nStat     = 0;
  mark->nAdc      = 0;
  mark->statMark  = NULL;
  mark->adcMark   = NULL;

  mark->SHid   = (unsigned short *)malloc(FRMAPMAXSH*sizeof(short));
  mark->SHname = (char **)         malloc(FRMAPMAXSH*sizeof(char *));

  mark->maxFrame = 4;
  mark->run    = (unsigned  int *)malloc(mark->maxFrame*sizeof(int));
  mark->frame  = (unsigned  int *)malloc(mark->maxFrame*sizeof(int));
  mark->GTime  =        (double *)malloc(mark->maxFrame*sizeof(double));
  mark->frPos  =          (long *)malloc(mark->maxFrame*sizeof(long));

  if((mark->run    == NULL) ||
     (mark->frame  == NULL) ||
     (mark->GTime  == NULL) ||
     (mark->frPos  == NULL) ||
     (mark->SHid   == NULL) ||
     (mark->SHname == NULL))
           {FrError(3,"FrFileMarkNew"," malloc buffer failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}

                /*--------- add information for ADC ------------------*/

  if(frame->rawData != NULL)
    {adc = frame->rawData->firstAdc;
     while(adc != NULL)
       {dm = malloc(sizeof(struct FrDataMark));
        if(dm == NULL) break;

        FrStrCpy(&dm->name, adc->name);
        dm->position = (long *)malloc(mark->maxFrame*sizeof(long));
        if(dm->position == NULL)
          {FrError(3,"FrFileMarkNew"," malloc buffer failed");
            oFile->error = FR_ERROR_MALLOC_FAILED;
            return;}
        dm->next = mark->adcMark;
        mark->adcMark = dm;
        mark->nAdc++;

        adc = adc->next;}}

  mark->classe = FrFileMarkDef();

  return;}
/*---------------------------------------------------FrFileMarkRead --*/
struct FrFileMark* FrFileMarkRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrFileMark *mark;
 struct FrStatMark *sm;
 struct FrDataMark *dm;
 unsigned int compress, nBytes, offset;
 unsigned short type, id;
 int length,i,j;
 long off;

        /*--------first determine the offset for the file marks ----*/

 if(FrIOSetFromEnd(iFile->frfd, -sizeof(int)) == -1) {return (NULL);}

 FrReadIntU (iFile, &offset);
 if(offset == 0) {return(NULL);}
 off = offset;
 if(FrIOSetFromEnd(iFile->frfd, -off) == -1) {return (NULL);}
 
                   /*---- create the file mark and read it ----------*/

 mark = (struct FrFileMark *) calloc(1,sizeof(struct FrFileMark));
 if(mark == NULL)  
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return(NULL);}
 
 FrReadInt(iFile,    &length);
 FrReadShortU(iFile, &type);
 FrReadShortU(iFile, &id);
 if(length != offset)  
      {iFile->error = FR_ERROR_READ_ERROR;
       return(NULL);}

 FrReadShortU(iFile, &mark->ULeapS);
 FrReadInt   (iFile, &mark->localTime);
 FrReadIntU  (iFile, &mark->nFrame);
 FrReadIntU  (iFile, &compress);
 FrReadIntU  (iFile, &nBytes);
 FrReadVI    (iFile,(int **) &mark->run,   mark->nFrame);
 FrReadVI    (iFile,(int **) &mark->frame, mark->nFrame);
 FrReadVD    (iFile,         &mark->GTime, mark->nFrame);
 FrReadVL    (iFile,         &mark->frPos, mark->nFrame);
 FrReadInt   (iFile, &mark->nSH);
 FrReadVS    (iFile,(short **) &mark->SHid,   mark->nSH);
 FrReadVQ    (iFile,(char ***) &mark->SHname, mark->nSH);

                     /*--------- read the static data part --------*/

 FrReadInt  (iFile, &mark->nStat);
 for(i=0; i<mark->nStat; i++)
   {sm = (struct FrStatMark *) malloc(sizeof(struct FrStatMark));
    if(sm == NULL)
       {FrError(3,"FrFileMarkRead"," malloc failed");
        iFile->error = FR_ERROR_MALLOC_FAILED; 
        return(NULL);}
     FrReadSChar(iFile, &sm->name);
     FrReadSChar(iFile, &sm->detector);
     FrReadInt (iFile,  &sm->nStat);
     sm->maxStat = sm->nStat;
     FrReadVI (iFile, (int **) &sm->tStart,   sm->nStat);
     FrReadVI (iFile, (int **) &sm->tEnd,     sm->nStat);
     FrReadVI (iFile, (int **) &sm->version,  sm->nStat);
     FrReadVL (iFile,          &sm->position, sm->nStat);
     sm->next = mark->statMark;
     mark->statMark = sm;}

                        /*--------- read the adc data part --------*/

 FrReadInt  (iFile, &mark->nAdc);
 for(i=0; i<mark->nAdc; i++)
   {dm = (struct FrDataMark *) malloc(sizeof(struct FrDataMark));
    if(dm == NULL)
       {FrError(3,"FrFileMarkRead"," malloc failed");
        iFile->error = FR_ERROR_MALLOC_FAILED; 
        return(NULL);}
     FrReadSChar(iFile, &dm->name);
     FrReadVL (iFile,   &dm->position, mark->nFrame);
     dm->next = mark->adcMark;
     mark->adcMark = dm;}

 if(iFile->error == FR_ERROR_MALLOC_FAILED) return(NULL);
 
 FrFileMarkDump(mark);
 iFile->mark = mark;

      /*---------- set SH pointer for direct read function access ---*/

 for(i=0; i<mark->nSH; i++)
   {for(j=0; j<FrnSH; j++)
     {if(strcmp(mark->SHname[i],FrSH[j]->name) == 0) break;}

    type = mark->SHid[i];
    if(type >= iFile->maxSH) 
       {FrFileIncSH(iFile,type);
        if(iFile->error != FR_OK) return(NULL);}
     
    iFile->sh[type] =  FrSHNew(FrSH[j]->name,NULL);
    iFile->sh[type]->objRead = FrSH[j]->objRead;}
 
 return(mark);}

/*------------------------------------------------- FrFileMarkWrite---*/
void FrFileMarkWrite(struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{long position;
 struct FrFileMark *mark;
 struct FrStatMark *sm;
 struct FrDataMark *dm;

 int length;

  mark = oFile->mark;
  if(mark == NULL) return;

  FrFileMarkDump(oFile->mark);

   /*--- write first the dictionary to get the real header position--*/

  if(oFile->dicWrite[mark->classe->id] == FR_NO) 
    {oFile->dicWrite[mark->classe->id] = FR_YES; 
     FrSHWrite(mark->classe, oFile);}  

  position = oFile->nBytes;
 
            /*---------- write now the data bloc --------------------*/

  FrPutNewRecord(oFile, mark);
  FrPutShortU   (oFile, mark->ULeapS);
  FrPutInt      (oFile, mark->localTime);
  FrPutInt      (oFile, mark->nFrame);
  FrPutInt      (oFile, 0);                     /*-- compress flag---*/
  FrPutInt      (oFile, mark->nFrame * sizeof(int));/*number of bytes*/
  FrPutVI       (oFile, (int*) mark->run,   mark->nFrame);
  FrPutVI       (oFile, (int*) mark->frame, mark->nFrame);
  FrPutVD       (oFile,        mark->GTime, mark->nFrame);
  FrPutVL       (oFile,        mark->frPos, mark->nFrame);

  mark->nSH --;                         /*-- remove the FileMark SH--*/
  FrPutInt      (oFile, mark->nSH);
  FrPutVS       (oFile, (short *) mark->SHid,   mark->nSH);
  FrPutVQ       (oFile,           mark->SHname, mark->nSH);

                        /*------------ Static data part--------------*/
 
  FrPutInt (oFile, mark->nStat);
  sm = mark->statMark;
  while(sm != NULL)
    {FrPutSChar (oFile, sm->name); 
     FrPutSChar (oFile, sm->detector); 
     FrPutInt   (oFile, sm->nStat);
     FrPutVI    (oFile, (int*) sm->tStart,   sm->nStat);
     FrPutVI    (oFile, (int*) sm->tEnd,     sm->nStat);
     FrPutVI    (oFile, (int*) sm->version,  sm->nStat);
     FrPutVL    (oFile,        sm->position, sm->nStat);
     sm = sm->next;}

                         /*------------ Adc data part--------------*/
 
  FrPutInt (oFile, mark->nAdc);
  dm = mark->adcMark;
  while(dm != NULL)
    {FrPutSChar (oFile, dm->name); 
     FrPutVL    (oFile, dm->position, mark->nFrame);
     dm = dm->next;}

  FrPutInt (oFile, 0);   /* reserved for FrSerDatad data   */
  FrPutInt (oFile, 0);   /* reserved for FrProcData data   */
  FrPutInt (oFile, 0);   /* reserved for FrSimData data    */
  FrPutInt (oFile, 0);   /* reserved for FrTrigData data   */
  FrPutInt (oFile, 0);   /* reserved for FrSummary data    */

              /*--------------- store the marks length -------------*/

  length = (int) (oFile->p - oFile->pStart) + 4; 
  if(FrDebugLvl > 0) printf(" FrFileMarkWrite: length = %d\n",length);
  FrPutInt      (oFile, length);
  FrPutWriteRecord(oFile);

  return;}




