/*-----------------------------------------------------------*/
/* File: exampleDumpFile.c     by B. Mours (LAPP) Mar 25, 99 */
/*                                                           */
/*  This program produces of short summary for each frame    */
/*  present in a file. The file name is the program argument */
/*  An optional second argument is the debug level           */
/*-----------------------------------------------------------*/
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h> 
#include <stdarg.h>
#include "FrameL.h"
  
int main(int argc, char *argv[])   /*-------------- main ----*/
{struct FrFile *iFile;
 struct FrameH *frame;
 long debugLevel;

    /*--- increase the Debug level to see possible errors ---*/

  if(argc == 3) 
       {sscanf(argv[2],"%ld",&debugLevel);}
  else if(argc ==2) 
       {debugLevel = 1;}
  else              
       {printf("You should provide at least the file name\n");
        return(0);}
  FrLibSetLvl(debugLevel);
   
    /*------------------------------------ file open---------*/

  iFile = FrFileINew(argv[1]);
  if(iFile == NULL)
     {printf("Cannot open file %s\n",argv[1]);
      return(0);}

    /*------------------------- read all the frames --------*/

  while((frame = FrameRead(iFile)) != NULL)
      {FrameDump(frame, stdout, debugLevel);
       FrameFree(frame);}
       
    /*------------------------- close files ----------------*/

  FrFileIEnd(iFile);

  return(0);
}
