/*-----------------------------------------------------------*/
/* File: exampleMark.c         by B. Mours (LAPP) May 16, 99 */
/*                                                           */
/*  This program do a few random access in a file            */
/*-----------------------------------------------------------*/
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h> 
#include <stdarg.h>
#include "FrameL.h"
  
int main(int argc, char *argv[])   /*-------------- main ----*/
{struct FrFile *iFile;
 struct FrameH *frame;
 struct FrAdcData *adc;

 FrLibSetLvl(2);
    /*------------------------------------ file open---------*/

  iFile = FrFileINew("ran.dat");
  if(iFile == NULL)
     {printf("Cannot open file\n");
      return(0);}

             /*-------- get a frame according it's number ---*/

  frame = FrameReadN(iFile,0, 3);
  FrameDump(frame, stdout, 2);
  FrameFree(frame);
       
             /*---------- get a frame according it's time ----*/

  frame = FrameReadT(iFile, 303039393.2, 2.);
  FrameDump(frame, stdout, 2);
  FrameFree(frame);


  adc = FrAdcDataReadN(iFile, "adc 1", 0, 3);
  if(adc != NULL)
    {printf("Find by number\n ADC: %s ", adc->name);
    FrVectDump( adc->data, stdout, 3);}
 
  adc = FrAdcDataReadT(iFile, "adc 1", 6000000., 2.);
  if(adc != NULL)
    {printf("Find by time\n ADC: %s ", adc->name);
    FrVectDump( adc->data, stdout, 3);}

    /*- ------------------------ close files ----------------*/

  FrFileIEnd(iFile);

  return(0);
}



