/*-----------------------------------------------------------*/
/* File: exampleMultiW.c      by B. Mours (LAPP) Sep 14, 98  */
/*                                                           */
/*   This  program creates a frame and writes it in          */  
/*   file for several files. There are several frames        */
/*   par files (see the value of framePerFile).              */ 
/*   This is usefull to check the memory leaks....           */
/*-----------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include "FrameL.h"
  
#define BUFSIZE 1000000

int main()     /*-------------------- main------------------*/
{struct FrFile *oFile;
 struct FrameH *frame;
 struct FrAdcData *adc;
 double sampleRate;
 long nData,i,framePerFile,iFile,iFrame;
 char buf[BUFSIZE],fileName[100];
 
    /*------ initialisation --------------------------------*/
 
 framePerFile = 10;
 iFile = 0;

 for(iFrame=0; iFrame<1000000; iFrame++)
   {
    /*----- create one Frame header -----------------------*/
    
    frame = FrameHNew("new");
    if(frame == NULL)
       {printf("Error during frame creation\n"
             "  Last errors are:\n%s",FrErrorGetHistory());
        return(0);}
    frame->frame = iFrame;

     /*----- add 1 ADC with data -------------------------*/

    sampleRate = 1.e+4;
    nData = 512;

    adc = FrAdcDataNew(frame,"adc1",sampleRate,nData,16);
    if(adc == NULL)
       {printf("Error during adc creation\n"
               "  Last errors are:\n%s",FrErrorGetHistory());
        return(0);}

    for(i=0; i < nData; i++)
         {adc->data->dataS[i] = (short) (i+iFrame);}

   /*----- dump one frame on stdout---------------------*/

    if(iFrame < 2) FrameDump(frame, stdout, 2);
    
    /*--open the output file (we use only 10 file names)-*/

    if(iFrame%framePerFile == 0)
      {iFile ++;
       sprintf(fileName,"file%ld.dat",iFile%10);
       printf("open file %s at frame %ld \n",fileName,iFrame);

       oFile = FrFileONew(fileName, 0, buf, BUFSIZE); 
       if(oFile == NULL)
          {printf("Error during output file initialization\n"
               "  Last errors are:\n%s",FrErrorGetHistory());
	  return(0);}}

    if(FrameWrite(frame, oFile) != FR_OK)
       {printf("Error during frame write\n"
             "  Last errors are:\n%s",FrErrorGetHistory());
        return(0);}

     /*----- close everything -------------------------*/
     
    if(iFrame%framePerFile == framePerFile-1)
      {FrFileOEnd(oFile);}
                                
    FrameFree(frame);

   }  /*--- end of the loop on frames */
  return(0);
}
