#define _POSIX_SOURCE 
/* *********************************************************************
******** FrameL.c ******************************* FrameL.c *************
******** FrameL.c ******************************* FrameL.c *************
********************************************************************* */
/*  by B.Mours LAPP (Annecy) */

char FrVersion[] = "3.85; September 11, 1999";

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h> 
#include <stdarg.h>
#include <ctype.h>
#include "FrameL.h"
#include "zlib.h"

/*----------------------------- buffer space used in several places --*/
#define FRBUFSIZE 100000
char FrBuf[FRBUFSIZE];     
int FrBufSize = FRBUFSIZE;
/*-------------------------------------------miscellaneous variables--*/
int    FrSshort, FrSint, FrSlong, FrSfloat, FrSdouble;
FILE  *FrFOut = NULL;  
long   FrDebugLvl = 0;
struct FrDetector *FrCurDetector = NULL;
/*--------------------------------Header for each class of structure--*/
struct FrSH *FrSH[FRMAPMAXSH];
int FrnSH = 0;
/*----------------------static variable used by the FrError functions-*/
void (*FrErrorHandler)() = FrErrorDefHandler;
/*--------------------------------------------------------------------*/

#include "FrMark.c"               
               
               
/*--------------------------------------------------------- FrLibIni -*/
FILE *FrLibIni(char *outFile, 
               FILE *fOut, 
               long dbglvl)
                 /*if not outFile == NULL, we use fOut for output file*/
/*--------------------------------------------------------------------*/
{static int icall = 0;
 
  icall++;
  if(icall > 1) 
    {printf(" Warning, FrLibIni is call twice\n");
     return(FrFOut);}

  if(outFile == NULL)
    {FrFOut = fOut;
     if(FrFOut == NULL)  {FrFOut = stdout;}}
  else
    {printf("FrLibIni: output will be sent on file:%s\n",outFile);
     FrFOut = fopen(outFile,"w");
     if(FrFOut == NULL)
         {printf("\n !! Opening file error, output stay on screen\n");
          FrFOut = stdout;}}
  
  FrDebugLvl = dbglvl;

  FrLibVersion(FrFOut);

  FrLibShortIni();

  return(FrFOut);}

/*---------------------------------------------------- FrLibShortIni -*/
void FrLibShortIni()
/*--------------------------------------------------------------------*/
{static int icall = 0;
 
  icall++;
  if(icall > 1) return;

    /*----- i/o package initialization ------*/
	
  FrSshort  = sizeof(short);
  FrSint    = sizeof(int);
  FrSlong   = sizeof(long);
  FrSfloat  = sizeof(float);
  FrSdouble = sizeof(double);

    /*--- check the size of words. Unpredictible behevior will results
      from the use of non standard values ---------------------------*/

  if(FrSshort != 2)
     {FrError(3,"FrLibShortIni","Warning: sizeof(short) != 2 !!!!!");}
  if(FrSint != 4)
     {FrError(3,"FrLibShortIni","Warning: sizeof(int) != 4 !!!!!!!");}
  if(FrSlong != 4 && FrSlong != 8 )
     {FrError(3,"FrLibShortIni","Warning: sizeof(long) != 4 or 8 !");}
  if(FrSfloat != 4)
     {FrError(3,"FrLibShortIni","Warning: sizeof(float) != 4 !!!!!");}
  if(FrSdouble != 8)
     {FrError(3,"FrLibShortIni","Warning: sizeof(double) != 8 !!!!");}
	
    /*----- declare the standard structures -------*/

  if(FrObjectDef()     == NULL) return;
  if(FrSHDef()         == NULL) return;
  if(FrSEDef()         == NULL) return;
  if(FrFileMarkDef()   == NULL) return;

  if(FrameHDef()       == NULL) return;
  if(FrAdcDataDef()    == NULL) return;
  if(FrDetectorDef()   == NULL) return;
  if(FrEndOfFrameDef() == NULL) return;
  if(FrMsgDef()        == NULL) return;
  if(FrHistoryDef()    == NULL) return;
  if(FrRawDataDef()    == NULL) return;
  if(FrProcDataDef()   == NULL) return;
  if(FrSimDataDef()    == NULL) return;
  if(FrSerDataDef()    == NULL) return;
  if(FrStatDataDef()   == NULL) return;
  if(FrSummaryDef()    == NULL) return;
  if(FrTrigDataDef()   == NULL) return;

  if(FrVectDef()       == NULL) return;
  
  if(FrEndOfFileDef()  == NULL) return;

  return;}

/*------------------------------------------------------ FrLibSetLvl -*/
void FrLibSetLvl(long dbglvl)
/*--------------------------------------------------------------------*/
{ 
  FrDebugLvl = dbglvl;
  if(FrFOut == NULL) FrFOut = stdout;
  
  return;}

/*----------------------------------------------------- FrLibVersion -*/
float FrLibVersion(FILE *fOut)
                       /*if fOut != NULL, we use print version on fOut*/
/*--------------------------------------------------------------------*/
{float version;

 sscanf(FrVersion,"%f",&version);

 if(fOut != NULL)
    {fprintf(FrFOut,"  FrameL Version:%s(file: %s %s %s)\n"
	     ,FrVersion,__FILE__,__DATE__,__TIME__);}
  
 return(version);}

/*-------------------------------------------------FrAdcDataCopy------*/
struct FrAdcData *FrAdcDataCopy(struct FrAdcData *in,
                                struct FrameH *frame)
/*--------------------------------------------------------------------*/
{struct FrAdcData *out;
 struct FrRawData *rawData;

  if(in == NULL) return(NULL); 
  out = (struct FrAdcData *) calloc(1,sizeof(struct FrAdcData));
  if(out == NULL) {return(NULL);} 

  memcpy(out, in, sizeof(struct FrAdcData));
	 
  if(FrStrCpy(&out->name,   in->name)    == NULL) return(NULL);
  if(in->comment != NULL)
     {if(FrStrCpy(&out->comment,in->comment) == NULL) return(NULL);}
  if(in->units != NULL)
     {if(FrStrCpy(&out->units,  in->units)   == NULL) return(NULL);}
 
  if(in->data != NULL) 
     {out->data = FrVectCopy(in->data);
      if(out->data == NULL) return(NULL);}
  if(in->aux != NULL)
     {out->aux  = FrVectCopy(in->aux);
      if(out->aux == NULL) return(NULL);}

  out->next = NULL;

     /*----- now store it in the Frame structures -----*/

  if(frame != NULL) 
     {if(frame->rawData == NULL)  FrRawDataNew(frame);

      rawData = frame->rawData;
      if(rawData == NULL) return(NULL);

      out->next = rawData->firstAdc;
      rawData->firstAdc = out;}
  
  return(out);} 

/*-------------------------------------------------- FrAdcDataDef ----*/
struct FrSH *FrAdcDataDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrAdcData", FrAdcDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "INT_4U", "crate","-");
  FrSENew(classe, "INT_4U", "channel","-");
  FrSENew(classe, "INT_4U", "nBits","-");
  FrSENew(classe, "REAL_4", "bias","-");
  FrSENew(classe, "REAL_4", "slope","-");
  FrSENew(classe, "STRING", "units","-");
  FrSENew(classe, "REAL_8", "sampleRate","-");
  FrSENew(classe, "INT_4U","timeOffsetS","-");
  FrSENew(classe, "INT_4U","timeOffsetN","-");
  FrSENew(classe, "REAL_8","fShift","-");
  FrSENew(classe, "INT_2U","overRange","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "data","-");
  FrSENew(classe, "PTR_STRUCT(struct FrVect *)",   "aux","-");
  FrSENew(classe, "PTR_STRUCT(struct FrAdcData *)", "next","-"); 

  return(classe);}
  
/*--------------------------------------------- FrAdcDataFind---------*/
struct FrAdcData *FrAdcDataFind(struct FrameH *frameH, 
                                char *adcName)
/*--------------------------------------------------------------------*/
/* Return a pointer to the adc structure or NULL if not found */

{struct FrAdcData *adc;

 if(frameH == NULL)             return (NULL);
 if(frameH->rawData == NULL)    return (NULL);
 if(adcName == NULL)            return (NULL);

 adc = frameH->rawData->firstAdc;
 while(adc != NULL)
    {if(strcmp(adc->name, adcName) == 0) return (adc);
     adc = adc->next;}
  
 return (NULL);}

/*--------------------------------------------------FrAdcDataFree-----*/
struct FrAdcData *FrAdcDataFree(struct FrAdcData *adcData)
/*--------------------------------------------------------------------*/
{struct FrAdcData *next; 

 if(adcData == NULL) return(NULL);

 next = adcData->next;

 if(adcData->data    != NULL) FrVectFree (adcData->data);
 if(adcData->aux     != NULL) FrVectFree (adcData->aux);
 if(adcData->name    != NULL) free (adcData->name);
 if(adcData->comment != NULL) free (adcData->comment);

 free(adcData);

 return(next);}

/*-------------------------------------------------FrAdcDataNew ------*/
struct FrAdcData *FrAdcDataNew(struct FrameH *frame,  
                               char *name, 
                               double sampleRate, 
                               long nData, 
                               long nBits)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adcData;
 struct FrRawData *rawData;
 double dx;
 long type;
 
  adcData = (struct FrAdcData *) calloc(1,sizeof(struct FrAdcData));
  if(adcData == NULL) 
       {return(NULL);} 
  else {adcData->classe = FrAdcDataDef();}
	 
  if(FrStrCpy(&adcData->name,name) == NULL) return(NULL);

  adcData->overRange = 0;
  adcData->sampleRate = sampleRate;
  adcData->nBits = nBits;

  if(nBits >16)       {type = FR_VECT_4S;}
  else if(nBits >  8) {type = FR_VECT_2S;}
  else if(nBits >  0) {type = FR_VECT_C;}
  else if(nBits >-33) {type = FR_VECT_4R;}
  else                {type = FR_VECT_8R;}

  if(sampleRate == 0.)
       {dx = 0.;}
  else {dx = 1./sampleRate;}

  adcData->data = FrVectNew(type,1,nData,dx,"time (sec)");
  if(adcData->data == NULL) return(NULL);
  
  free(adcData->data->name);
  if(FrStrCpy(&adcData->data->name,name) == NULL) return(NULL);

     /*----- now store it in the Frame structures -----*/

  if(frame != NULL) 
     {if(frame->rawData == NULL)  FrRawDataNew(frame);

      rawData = frame->rawData;
      if(rawData == NULL) return(NULL);

      adcData->next = rawData->firstAdc;
      rawData->firstAdc = adcData;}
  
  return(adcData);} 


/*--------------------------------------------------- FrAdcDataRead---*/
void FrAdcDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adcData;

  adcData = (struct FrAdcData *) calloc(1,sizeof(struct FrAdcData));
  if(adcData == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {adcData->classe = FrAdcDataDef();}

  FrReadHeader(iFile,  adcData);
  FrReadSChar (iFile, &adcData->name); 
  FrReadSChar (iFile, &adcData->comment);
  FrReadIntU  (iFile, &adcData->crate);
  FrReadIntU  (iFile, &adcData->channel);
  FrReadIntU  (iFile, &adcData->nBits);
  FrReadFloat (iFile, &adcData->bias);
  FrReadFloat (iFile, &adcData->slope);
  FrReadSChar (iFile, &adcData->units);
  FrReadDouble(iFile, &adcData->sampleRate);
  FrReadIntU  (iFile, &adcData->timeOffsetS);
  FrReadIntU  (iFile, &adcData->timeOffsetN);
  FrReadDouble(iFile, &adcData->fShift);
  FrReadShortU(iFile, &adcData->overRange);
  FrReadStruct(iFile, &adcData->data);
  FrReadStruct(iFile, &adcData->aux);
  FrReadStruct(iFile, &adcData->next);
    
return;}

 /*------------------------------------------------- FrAdcDataWrite---*/
void FrAdcDataWrite(struct FrAdcData *adcData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
 
  FrPutNewRecord(oFile, adcData);
  if(oFile->mark != NULL)
    FrFileMarkData(oFile, oFile->mark->adcMark, adcData->name);

  FrPutSChar (oFile, adcData->name);
  FrPutSChar (oFile, adcData->comment);
  FrPutIntU  (oFile, adcData->crate);
  FrPutIntU  (oFile, adcData->channel);
  FrPutIntU  (oFile, adcData->nBits);
  FrPutFloat(oFile,  adcData->bias);
  FrPutFloat(oFile,  adcData->slope);
  FrPutSChar (oFile, adcData->units);
  FrPutDouble(oFile, adcData->sampleRate);
  FrPutIntU  (oFile, adcData->timeOffsetS);
  FrPutIntU  (oFile, adcData->timeOffsetN);
  FrPutDouble(oFile, adcData->fShift);
  FrPutShortU(oFile, adcData->overRange);
  FrPutStruct(oFile, adcData->data);
  FrPutStruct(oFile, adcData->aux);
  FrPutStruct(oFile, adcData->next);
  FrPutWriteRecord(oFile);

           /* write data */

  FrVectWrite(adcData->data, oFile);
  adcData->inMemory = adcData->data->inMemory;

  if(adcData->aux != NULL) FrVectWrite(adcData->aux, oFile);
   
 return;}

/*----------------------------------------------------- FrameCompress-*/
void FrameCompress(struct FrameH *frameH,
                   int compress,
                   int gzipLevel)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adc;
 struct FrProcData *proc;
 struct FrSimData *sim;

 if(frameH == NULL) return;
  
 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"Compress frame\n  Run:%d Frame:%d \n",
         frameH->run,frameH->frame);}

    /*---- compress the adc vectors ----*/
     
 if(frameH->rawData != NULL) 
   {adc = frameH->rawData->firstAdc;
    while(adc != NULL)
       {FrVectCompress(adc->data, compress, gzipLevel);
        adc = adc->next;}}

    /*---- compress the processed data ----*/

 if(frameH->procData != NULL) 
   {proc = frameH->procData;   
    while(proc != NULL)
       {FrVectCompress(proc->data, compress, gzipLevel);
        proc = proc->next;}}

    /*---- compress the simulated data ----*/

 if(frameH->simData != NULL) 
   {sim = frameH->simData;
    while(sim != NULL)
      {FrVectCompress(sim->data, compress, gzipLevel);
       sim = sim->next;}}  

 return;}

/*------------------------------------------------------- FrameCopy---*/
struct FrameH *FrameCopy(struct FrameH *frame)
/*--------------------------------------------------------------------*/
{struct FrameH *out;
 int nBytes;
 static int size = 0;
 static char *buf;
 char comment[100];

 if(frame == NULL) return(NULL);
 
 if(size == 0)
     {size = 200000;
      buf = (char *) malloc(size);}

 nBytes = 0;

 while(nBytes == 0)
    {if(buf == NULL) return(NULL);
     nBytes = FrameWriteToBuf(frame, 0, buf, size);
     if(nBytes == 0)
         {size = size*2;
          free(buf);
          buf = malloc(size);}}

 out = FrameReadFromBuf(buf,size,0);

   /*----- update the history record added by the frameWrite call --*/

 free(out->history->comment);
 sprintf(comment,"FrameCopy %s",FrVersion);
 FrStrCpy(&out->history->comment,comment);

 return(out);}

/*------------------------------------------------------- FrameDump---*/
void FrameDump(struct FrameH *frameH,
               FILE *fp, 
               long debugLvl)
/*--------------------------------------------------------------------*/
{struct FrProcData *procData;
 struct FrSimData   *simData;
 struct FrHistory *history; 
 struct FrTrigData *trig;
 struct FrSummary *sum;
 unsigned int local, UTC;

 if(fp     == NULL) return;
 if(frameH == NULL) return;

 if(debugLvl < 1) return;

 fprintf(fp,"\nDump frame: %s Run#:%d Frame#:%d\n",
               frameH->name,frameH->run,frameH->frame);
 fprintf(fp,"    Starting time:(GPS) %d sec and %d nsec  ULeapS:%d\n",
                  frameH->GTimeS,frameH->GTimeN,  frameH->ULeapS);
 UTC = frameH->GTimeS - frameH->ULeapS + FRGPSTAI;
 fprintf(fp,"                  (UTC) %d sec = %s \n", UTC,FrStrGTime(UTC));
 local = UTC + frameH->localTime;
 fprintf(fp,"                  (Local time)          %s \n", 
                  FrStrGTime(local));
 fprintf(fp,"     Frame length:%f sec\n",frameH->dt);

 /* do not forget that TAI is ahead of GPS by 19 seconds */
 /*   and TAI is ahead of UTC by 31 seconds (august 97)  */
      /*----------history------------------*/

 fprintf(fp,"History records:\n");
 history = frameH->history;
 while(history != NULL)
   {fprintf(fp," %s(GPS) %s\n", FrStrGTime(history->time), history->comment);
    history = history->next;}

  if(debugLvl < 2) return;

     /*----------static data----------------*/

 if(frameH->detectProc != NULL)
    {fprintf(fp,"Detector used for reconstruction:\n");
    FrDetectorDump(frameH->detectProc, fp, debugLvl);}
 if(frameH->detectSim != NULL)
    {fprintf(fp,"Detector used for simulation:\n");
    FrDetectorDump(frameH->detectSim, fp, debugLvl);}

      /*---- dump simulated data ----------*/

 simData = frameH->simData;
 
 while(simData != NULL) 
    {fprintf(fp,"Simulated Data: %s ", simData->name);
     FrVectDump(simData->data, fp, debugLvl); 
     simData = simData->next;}
  
      /*---- dump reconstructed data ----------*/

 procData = frameH->procData; 
 
 while(procData != NULL) 
    {fprintf(fp,"Reconstructed Data: %s ", procData->name);
     FrVectDump( procData->data,  fp, debugLvl); 
     FrVectDump( procData->aux,   fp, debugLvl); 
     procData = procData->next;}

     /*----- dump auxilliary data -----------*/
     
 trig = frameH->trigData;
 while(trig != NULL) 
    {fprintf(fp,"Trigger Data: %s %s Result:%e\n",
       trig->name, trig->comment, trig->rvalue);
     trig = trig->next;}

 sum = frameH->summaryData;
 while(sum != NULL)
    {fprintf(fp,"Summary: %s %s \n",sum->name, sum->comment);
     sum = sum->next;}

 if(frameH->auxData != NULL) {FrVectDump(frameH->auxData, fp, debugLvl);}

     /*----- dump raw data -----------*/

 if(frameH->rawData != NULL) FrRawDataDump(frameH->rawData, fp, debugLvl);      

 return;}

/*----------------------------------------------- FrameDumpToBuf------*/
char *FrameDumpToBuf(struct FrameH *frame,
                     long debugLvl, 
                     char *buf, 
                     long bufSize)
/*--------------------------------------------------------------------*/
{FILE *tmp;
 static int offset = -2;
 long sizeMin = BUFSIZ*2; 

 if(debugLvl < 1)    return(NULL);
 if(frame == NULL)   return(NULL);
 if(buf   == NULL)   return(NULL);
 if(bufSize<sizeMin) 
      {FrError(3,"FrameDumpBuf"," too short buffer < BUFSIZ");
       return(NULL);}

  /*-------- first determine the offset in buffer---*/

 if(offset == -2)
   {tmp = tmpfile();
    if(tmp == NULL) 
      {FrError(3,"FrameDumpBuf"," cannot open tempory file");
       return(NULL);}
    setbuf(tmp, buf);
    fprintf(tmp,"Start\n");

    for(offset=0; offset<sizeMin; offset++)
      {if(buf[offset] == 'S') break;}

    if(offset == sizeMin) return(NULL);
    if(strcmp(buf+offset,"Start\n") != 0) return(NULL);

    fclose(tmp);}

  /*------- dump --------------*/

 tmp = tmpfile();
 setbuf(tmp, buf);  
 FrameDump(frame, tmp, debugLvl);
 fputc('\0',tmp);
 strcpy(buf+bufSize/2, buf+offset);
 fclose(tmp);
 
 return(buf+bufSize/2);}
/*----------------------------------------------------- FrameExpand---*/
void FrameExpand(struct FrameH *frameH)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adc;
 struct FrProcData *proc;
 struct FrSimData *sim;
 struct FrSerData *ser;
 struct FrTrigData *trig;
 struct FrSummary *sum;

 if(frameH == NULL) return;

 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"Expand frame\n  Run:%d Frame:%d \n",
         frameH->run,frameH->frame);}

 FrVectExpand(frameH->user);
 FrVectExpand(frameH->auxData);
 if(frameH->detectSim  != NULL) FrVectExpand(frameH->detectSim->more);
 if(frameH->detectProc != NULL) FrVectExpand(frameH->detectProc->more);

    /*---- Uncompress the adc vectors ----*/
     
 if(frameH->rawData != NULL) 
   {adc = frameH->rawData->firstAdc;
    while(adc != NULL)
       {FrVectExpand(adc->data);
        FrVectExpand(adc->aux);
        adc = adc->next;}
    ser = frameH->rawData->firstSer;
    while(ser != NULL)
       {FrVectExpand(ser->serial);
        FrVectExpand(ser->more);
        ser = ser->next;}
    FrVectExpand(frameH->rawData->more);}

    /*---- Uncompress the processed data ----*/

 proc = frameH->procData;   
 while(proc != NULL)
       {FrVectExpand(proc->data);
        FrVectExpand(proc->aux);
        proc = proc->next;}

    /*---- Uncompress the simulated data ----*/

 sim = frameH->simData;
 while(sim != NULL)
      {FrVectExpand(sim->data);
       FrVectExpand(sim->input);
       sim = sim->next;}  

 trig = frameH->trigData;
 while(trig != NULL)
      {FrVectExpand(trig->data);
       trig = trig->next;} 

 sum = frameH->summaryData;
 while(sum != NULL)
      {FrVectExpand(sum->moments);
       sum = sum->next;}  

 return;}

/*-----------------------------------------------------FrameFree------*/
void FrameFree(struct FrameH *FrameH)
/*--------------------------------------------------------------------*/
{struct FrHistory *history;

 if(FrameH == NULL) return;

     /* free all structures connected to this frame */

 if(FrameH->detectSim  != NULL) FrDetectorFree(FrameH->detectSim);
 if(FrameH->detectProc != NULL) FrDetectorFree(FrameH->detectProc);
 
 history = FrameH->history;
 while(history != NULL) {history = FrHistoryFree (history);}

 if(FrameH->rawData     != NULL) FrRawDataFree (FrameH->rawData);
 if(FrameH->procData    != NULL) FrProcDataFree(FrameH->procData);   
 if(FrameH->simData     != NULL) FrSimDataFree (FrameH->simData);   
 if(FrameH->trigData    != NULL) FrTrigDataFree(FrameH->trigData);   
 if(FrameH->summaryData != NULL) FrSummaryFree (FrameH->summaryData);   
 if(FrameH->auxData     != NULL) FrVectFree    (FrameH->auxData);   

 free(FrameH->name);
 free(FrameH);

 return;}
    

/*------------------------------------------------------- FrameRead---*/
struct FrameH *FrameRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
/* this function read a new frame, keeping the static information from
   the old frame if any */
{struct FrStatData *next, *sData;
 struct FrDetector *detector;
 unsigned short type;
 unsigned int length, timeEnd;

 if(iFile == NULL) return(NULL);

         /* reset relocation mechanism */

 FrSetIni(iFile);
 
         /*----  read one Frame -----*/

 iFile->curFrame = NULL;
 iFile->endOfFrame = FR_NO;
 iFile->sDataCur = NULL;

 while((iFile->error == FR_OK) && (iFile->endOfFrame == FR_NO))
     {FrReadInt(  iFile,(int *) &length);
      FrReadShort(iFile,(short *) &type);
      if(iFile->error != FR_OK) break;
          
      if(FrDebugLvl > 2) 
         {fprintf(FrFOut,"length: %8d type=%4d ",length,type);
          if(type > 2 && type < iFile->maxSH)
               {if(iFile->sh[type] != NULL)
                   {fprintf(FrFOut,"(%s)",iFile->sh[type]->name);}}
          fprintf(FrFOut,"\n");}
                             
      if(type == 1) {iFile->FrSHRead(iFile);
                     continue;}
      if(type == 2) {iFile->FrSERead(iFile);
                     continue;}

      if(type >= iFile->maxSH) 
                    {FrError(3,"FrameRead"," missiging dictionary");
                     iFile->error = FR_ERROR_READ_ERROR;
                     break;}
      if(iFile->sh[type] == NULL) 
                    {FrError(3,"FrameRead"," missiging dictionary");
                     iFile->error = FR_ERROR_READ_ERROR;
                     break;}
      if(iFile->sh[type]->objRead == NULL)
	            {FrSHMatch(iFile, type);}

      if(iFile->sh[type]->objRead == NULL)
          {FrReadRecord(iFile, type, length);}
      else{iFile->type = type;
           iFile->sh[type]->objRead(iFile);}}


  if(iFile->curFrame == NULL) {return(NULL);}
  if(iFile->error   != FR_OK) 
         {FrError(3,"FrameRead"," Error during reading ");
          return(NULL);}
 
  /*---------- pointer reallocation------------------ */

  FrSetAll(iFile);   

  /*--- attach static data to the right detector ------*/
 
  sData = iFile->sDataCur;
  while(sData != NULL)
    {next = sData->next;
     detector = sData->detector;
     if(detector == NULL) FrError(3,"FrameRead","Missing detector");
     sData->next = detector->sData;
     detector->sData = sData;
     sData = next;}
  
  /*--- restore clean up the static data information --*/
  
  timeEnd = iFile->curFrame->GTimeS + iFile->curFrame->dt;
     
  if(iFile->curFrame->detectSim != NULL)
    {sData = iFile->sDataSim;
     while(sData != NULL)
       {next = sData->next;
        FrStatDataAdd(iFile->curFrame->detectSim, sData);
        sData = next;}

     FrStatDataChkT(&iFile->curFrame->detectSim->sData,
                     iFile->curFrame->GTimeS, timeEnd);
     iFile->sDataSim = iFile->curFrame->detectSim->sData;}
      
  if(iFile->curFrame->detectProc != NULL)
    {sData = iFile->sDataProc;
     while(sData != NULL)
       {next = sData->next;
        FrStatDataAdd(iFile->curFrame->detectProc, sData); 
        sData = next;}
 
     FrStatDataChkT(&iFile->curFrame->detectProc->sData,
                     iFile->curFrame->GTimeS, timeEnd);
     iFile->sDataProc = iFile->curFrame->detectProc->sData;}
      
  return(iFile->curFrame);}


/*---------------------------------------------------FrameReadFromBuf-*/
struct FrameH *FrameReadFromBuf(char *buf, 
                                long nBytes,
                                unsigned short comp)
/*--------------------------------------------------------------------*/
{struct FrFile *iFile;
 struct FrameH *frame;
 
 if(buf == NULL) return(NULL);
 if(nBytes <= 0) return(NULL);
  
 iFile = FrFileNew(NULL, 0, buf, nBytes);
 if(iFile == NULL) return (NULL);

 FrFileIOpen(iFile);
 if(iFile->error != FR_OK) return(NULL);

 iFile->compress = comp;

 frame = FrameRead(iFile);

 FrFileIEnd(iFile);

 return(frame);}

/*---------------------------------------------------FrameSelectAdc---*/
void FrameSelectAdc(struct FrameH *frame,
                    int nAdc,
                    char *adc1,
                    ...)
/*--------------------------------------------------------------------*/
{va_list ap;
 struct FrAdcData **current;
 long i;
 char **adc;
 int remove;

 if(frame == NULL) return;
 if(frame->rawData == NULL) return;
 if(nAdc < 1) return;

 adc = (char **)calloc(nAdc, sizeof(char *));
 if(adc == NULL) return;

 adc[0] = adc1; 
 va_start(ap, adc1);
 for(i=1; i<nAdc; i++)
    {adc[i] = va_arg(ap, char*);}

 current = &frame->rawData->firstAdc;
 while(*current != NULL)
    {remove = 1;
     for(i=0; i<nAdc; i++)
       {if(strcmp((*current)->name, adc[i])  == 0) remove = 0;}
     if(remove == 1)
        {*current = FrAdcDataFree(*current);}
     else{current = &((*current)->next);}}

 free(adc);
 return;}

/*----------------------------------------------------- FrameWrite---*/
int FrameWrite(struct FrameH *frameH,
               struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{char comment[100];
 struct FrHistory *history;
 
 if(oFile == NULL) 
     {return(FR_ERROR_NO_FILE);}
 if(frameH == NULL) 
     {oFile->error = FR_ERROR_NO_FRAME;
      return(oFile->error);}
 oFile->error = FR_OK;

 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"Output frame\n  Run:%d Frame:%d \n",
         frameH->run,frameH->frame);}

 oFile->nFrames++;
 
       /*-- add history record ---*/

  sprintf(comment,"FrameWrite:%s",FrVersion);
  FrHistoryAdd(frameH, comment);

      /*  reset instance numbers */

  FrDicIni();

      /* write FrameH struct */

 FrameHWrite(frameH, oFile);

     /* write the detector information  */
 
 if(frameH->detectSim != NULL) FrDetectorWrite(frameH->detectSim, oFile);
 if(frameH->detectProc!= NULL) FrDetectorWrite(frameH->detectProc,oFile);

     /* write the history  */
 
 FrHistoryWrite(frameH->history, oFile);

     /* write the raw data  */
 
 if(frameH->rawData != NULL) FrRawDataWrite(frameH->rawData, oFile);

    /* write the reconstructed data    */

 if(frameH->procData != NULL) FrProcDataWrite(frameH->procData, oFile);   

    /* write the simulated data    */

 if(frameH->simData != NULL) FrSimDataWrite(frameH->simData, oFile);   

    /* write experiment dependant data    */

 if(frameH->trigData != NULL) FrTrigDataWrite(frameH->trigData,   oFile);

 if(frameH->summaryData!= NULL) FrSummaryWrite(frameH->summaryData,oFile);

 if(frameH->auxData != NULL) FrVectWrite(frameH->auxData,    oFile);

    /* write the end of frame record */

 FrEndOfFrameWrite(frameH, oFile);

   /* delete the history we just add */

 history = frameH->history;
 frameH->history = history->next;
 free(history->name);
 free(history->comment);
 free(history);

 return(oFile->error);}

/*---------------------------------------------------FrameWriteToBuf--*/
long FrameWriteToBuf(struct FrameH *frame,
                     unsigned short comp,
                     char *buf, 
                     long nBytes)
/*--------------------------------------------------------------------*/
{struct FrFile *file;
 int status;
 long size;
 
 if(buf == NULL) return(0);
 if(nBytes <= 0) return(0);

 file = FrFileONew(NULL, comp, buf, nBytes);
 if(file == NULL) return(0);

 status = FrameWrite(frame, file);
 if(status != FR_OK) return (0);

 FrFileOEnd(file);
 
 size = file->p - buf;
 
 return(size);}

/*------------------------------------------------------ FrameHCopy---*/
struct FrameH *FrameHCopy(struct FrameH *in)
/*--------------------------------------------------------------------*/
{struct FrameH *out;

  if(in == NULL) return(NULL); 
  out = FrameHNew(in->name);
  if(out == NULL) 
       {FrError(3,"FrameHCopy","malloc failed");
        return (NULL);} 

  out->run       = in->run;
  out->frame     = in->frame;
  out->GTimeS    = in->GTimeS;
  out->GTimeN    = in->GTimeN;
  out->ULeapS    = in->ULeapS;
  out->localTime = in->localTime;
  out->dt        = in->dt;

  return(out);} 

/*----------------------------------------------------- FrameHDef ----*/
struct FrSH *FrameHDef()    
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrameH", FrameHRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_4U", "run","-");
  FrSENew(classe, "INT_4U", "frame","-");
  FrSENew(classe, "INT_4U", "GTimeS","-");
  FrSENew(classe, "INT_4U", "GTimeN","-");
  FrSENew(classe, "INT_4U", "ULeapS","-");
  FrSENew(classe, "INT_4S", "localTime","-");
  FrSENew(classe, "REAL_8", "dt","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "type","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *", "user","-");
  FrSENew(classe, "PTR_STRUCT(FrDetector *)", "detectSim","-");
  FrSENew(classe, "PTR_STRUCT(FrDetector *)", "detectProc","-");
  FrSENew(classe, "PTR_STRUCT(FrHistory *)", "history","-");
  FrSENew(classe, "PTR_STRUCT(FrRawData *)", "rawData","-");
  FrSENew(classe, "PTR_STRUCT(FrProcData *)", "procData","-");
  FrSENew(classe, "PTR_STRUCT(FrProcData *)", "strain","-");
  FrSENew(classe, "PTR_STRUCT(FrSimData *)", "simData","-");
  FrSENew(classe, "PTR_STRUCT(FrTrigData *)", "trigData","-");
  FrSENew(classe, "PTR_STRUCT(FrSummary *)", "summaryData","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "auxData","-");

  return(classe);}
  
/*------------------------------------------------------ FrameHNew ---*/
struct FrameH *FrameHNew(char *name)
/*--------------------------------------------------------------------*/
{struct FrameH *frame;
 
  frame = (struct FrameH *) calloc(1,sizeof(struct FrameH));
  if(frame == NULL) 
       {FrError(3,"FrameHNew","malloc failed");
        return (NULL);} 
  else {frame->classe = FrameHDef();} 

  FrStrCpy(&frame->name,name);

  frame->type        = NULL;
  frame->user        = NULL;
  frame->detectProc  = NULL;
  frame->detectSim   = NULL;
  frame->strain      = NULL;
  frame->history     = NULL;
  frame->rawData     = NULL;
  frame->procData    = NULL;
  frame->simData     = NULL;
  frame->trigData    = NULL;
  frame->summaryData = NULL;
  frame->auxData     = NULL;

  return(frame);} 

/*------------------------------------------------------ FrameHRead---*/
void FrameHRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrameH *frameH;
 unsigned short id;

  frameH = (struct FrameH *) calloc(1,sizeof(struct FrameH));
  if(frameH == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {frameH->classe = FrameHDef();} 
  
  FrReadShortU(iFile, &id);  /*frameH are not referenced by pointer*/
  FrReadSChar (iFile, &frameH->name); 
  FrReadIntU  (iFile, &frameH->run);
  FrReadIntU  (iFile, &frameH->frame);
  FrReadIntU  (iFile, &frameH->GTimeS);
  FrReadIntU  (iFile, &frameH->GTimeN);
  FrReadShortU(iFile, &frameH->ULeapS); /*only since version 3.30*/
  FrReadInt   (iFile, &frameH->localTime);
  FrReadDouble(iFile, &frameH->dt);
  FrReadStruct(iFile, &frameH->type);
  FrReadStruct(iFile, &frameH->user);
  FrReadStruct(iFile, &frameH->detectSim);
  FrReadStruct(iFile, &frameH->detectProc);
  FrReadStruct(iFile, &frameH->history);
  FrReadStruct(iFile, &frameH->rawData);
  FrReadStruct(iFile, &frameH->procData);
  FrReadStruct(iFile, &frameH->strain);
  FrReadStruct(iFile, &frameH->simData);
  FrReadStruct(iFile, &frameH->trigData);
  FrReadStruct(iFile, &frameH->summaryData);
  FrReadStruct(iFile, &frameH->auxData);

  if(FrDebugLvl > 0)
    {fprintf(FrFOut, "FrameHRead:Start reading frame:  Run:%d "
          "Frame:%d\n",frameH->run,frameH->frame);}

  iFile->curFrame = frameH;
   
  return;}
/*----------------------------------------------------- FrameHWrite---*/
void FrameHWrite(struct FrameH *frameH,
                 struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{

 if(oFile->mark == NULL) FrFileMarkNew(oFile, frameH);

 FrPutNewRecord(oFile, frameH);
 FrFileMarkFrame(oFile,frameH);

 FrPutSChar( oFile, frameH->name);
 oFile->inMemR = oFile->p;
 FrPutIntU(  oFile, frameH->run);
 oFile->inMemF = oFile->p;
 FrPutIntU(  oFile, frameH->frame);
 oFile->inMemS = oFile->p;
 FrPutIntU(  oFile, frameH->GTimeS);
 oFile->inMemN = oFile->p;
 FrPutIntU(  oFile, frameH->GTimeN);
 FrPutShortU(oFile, frameH->ULeapS);
 FrPutInt(   oFile, frameH->localTime);
 FrPutDouble(oFile, frameH->dt);          
 FrPutStruct(oFile, frameH->type);          
 FrPutStruct(oFile, frameH->user);          
 FrPutStruct(oFile, frameH->detectSim);
 FrPutStruct(oFile, frameH->detectProc);
 FrPutStruct(oFile, frameH->history);
 FrPutStruct(oFile, frameH->rawData);
 FrPutStruct(oFile, frameH->procData);
 FrPutStruct(oFile, frameH->strain);
 FrPutStruct(oFile, frameH->simData);
 FrPutStruct(oFile, frameH->trigData);
 FrPutStruct(oFile, frameH->summaryData);
 FrPutStruct(oFile, frameH->auxData);
 FrPutWriteRecord(oFile);

 return;}

/*------------------------------------------------- FrDetectorDef ----*/
struct FrSH *FrDetectorDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrDetector",FrDetectorRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_2S", "longitudeD","-"); 
  FrSENew(classe, "INT_2S", "longitudeM","-"); 
  FrSENew(classe, "REAL_4", "longitudeS","-"); 
  FrSENew(classe, "INT_2S", "latitudeD","-"); 
  FrSENew(classe, "INT_2S", "latitudeM","-"); 
  FrSENew(classe, "REAL_4", "latitudeS","-"); 
  FrSENew(classe, "REAL_4", "elevation","-"); 
  FrSENew(classe, "REAL_4", "armXazimuth","-"); 
  FrSENew(classe, "REAL_4", "armYazimuth","-"); 
  FrSENew(classe, "REAL_4", "armLength","-"); 
  FrSENew(classe, "PTR_STRUCT", "more","-"); 

  return(classe);}
/*------------------------------------------------- FrDetectorDump----*/
void FrDetectorDump(struct FrDetector *detector, 
                    FILE *fp, 
                    long debugLvl)
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;

 if(debugLvl < 1)     return;
 if(detector == NULL) return;
 if(fp     == NULL)   return;

 fprintf(fp,"Detector: %s \n",detector->name);

      /*----------static data----------------*/

 fprintf(fp,"Static Data:\n");
 sData = detector->sData;
 while(sData != NULL)
   {fprintf(fp," %s (%s) \n  valid from %s",
        sData->name, sData->comment,FrStrGTime(sData->timeStart));
    fprintf(fp," to %s (GPS) version %d\n",
             FrStrGTime(sData->timeEnd),sData->version);
    if(sData->data != NULL)
      {if(sData->data->classe->objDump != NULL)
         {sData->data->classe->objDump(sData->data,fp,debugLvl);}}
    sData = sData->next;}

 return;}
 
/*------------------------------------------------FrDetectorFree------*/
void FrDetectorFree(struct FrDetector *detector)
/*--------------------------------------------------------------------*/
{
   if(detector->name != NULL) free(detector->name);
   free(detector);

   return;}

/*-------------------------------------------------- FrDetectorNew----*/
struct FrDetector *FrDetectorNew(char *name)
/*--------------------------------------------------------------------*/
{struct FrDetector *detector;
 
  detector = (struct FrDetector *) calloc(1,sizeof(struct FrDetector));
  if(detector == NULL) 
       {return(NULL);}
  else {detector->classe = FrDetectorDef();} 

  FrStrCpy(&detector->name, name);
 
  FrCurDetector = detector;

  return(detector);}
/*-------------------------------------------------- FrDetectorRead---*/
void FrDetectorRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrDetector *detector;
 
  detector = (struct FrDetector *) calloc(1,sizeof(struct FrDetector));
  if(detector == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {detector->classe = FrDetectorDef();} 
  
  FrReadHeader(iFile,  detector);
  FrReadSChar (iFile, &detector->name); 
  FrReadShort (iFile, &detector->longitudeD); 
  FrReadShort (iFile, &detector->longitudeM); 
  FrReadFloat (iFile, &detector->longitudeS); 
  FrReadShort (iFile, &detector->latitudeD); 
  FrReadShort (iFile, &detector->latitudeM); 
  FrReadFloat (iFile, &detector->latitudeS); 
  FrReadFloat (iFile, &detector->elevation); 
  FrReadFloat (iFile, &detector->armXazimuth); 
  FrReadFloat (iFile, &detector->armYazimuth); 
  FrReadFloat (iFile, &detector->armLength); 
  FrReadStruct(iFile, &detector->more); 

  FrCurDetector = detector;

  return;}
 
/*------------------------------------------------- FrDetectorWrite---*/
void FrDetectorWrite(struct FrDetector *detector, 
                     struct FrFile *oFile)
                         /* write FrDetector structure on output file */
/*--------------------------------------------------------------------*/
{
 if(detector == NULL) return;
 	 
 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"  Output FrDetector %s\n",detector->name);}
         
 FrPutNewRecord(oFile, detector);
 FrPutSChar (oFile, detector->name);
 FrPutShort (oFile, detector->longitudeD); 
 FrPutShort (oFile, detector->longitudeM); 
 FrPutFloat (oFile, detector->longitudeS); 
 FrPutShort (oFile, detector->latitudeD); 
 FrPutShort (oFile, detector->latitudeM); 
 FrPutFloat (oFile, detector->latitudeS); 
 FrPutFloat (oFile, detector->elevation); 
 FrPutFloat (oFile, detector->armXazimuth); 
 FrPutFloat (oFile, detector->armYazimuth); 
 FrPutFloat (oFile, detector->armLength); 
 FrPutStruct(oFile, detector->more); 
 FrPutWriteRecord(oFile);
 
   /* write the static data */
   
 if(detector->sData != NULL) {FrStatDataWrite(detector->sData, oFile);}
 
   /* write the detector components */
 
 if(detector->more != NULL) {FrVectWrite(detector->more, oFile);}
  
 return;}

/*---------------------------------------------------- FrDicAddS----*/
struct FrSH *FrDicAddS(char *type, 
                       void  (*funRead)())
/*--------------------------------------------------------------------*/
{struct FrSH *structH;

  structH = FrSHNew(type, "");
  if(structH == NULL)  {return(NULL);}
  FrSH[FrnSH] = structH;
  FrnSH++;

  structH->objRead  = funRead;
  
  return(structH);}
  
/*-------------------------------------------------------- FrDicFree -*/
void FrDicFree(struct FrFile *file)
/*--------------------------------------------------------------------*/
{struct FrSH *sh;
 struct FrSE *nextSE;
 int i,j;

 for(j=0; j<file->maxSH; j++)
   {sh = file->sh[j];
    if(sh == NULL) continue;

    while(sh->firstE != NULL)
        {nextSE = sh->firstE->next;
         free(sh->firstE->comment); 
         free(sh->firstE->type);
         free(sh->firstE->name);
         free(sh->firstE); 
         sh->firstE = nextSE;}

    for(i=0; i<sh->nMap; i++)
       {if(sh->map[i] == NULL) continue;
        free(sh->map[i]);}

    free(sh->map);
    free(sh->name);
    free(sh->comment);
    free(sh);

    file->sh[j] = NULL;}

 return;} 
/*-------------------------------------------------------- FrDicGetId-*/
long FrDicGetId(struct FrSH *type, 
                void *instance)
/* this function return a unique id for a structure address           */
/* it return -1 if the instance is zero;                              */
/* it return -2 in case of fatal error(missing type or malloc failure)*/
/*--------------------------------------------------------------------*/
{static long id;
 
 if(type == 0) 
     {FrError(3,"FrDicGetId","structH = NULL");
      return(-2);}
 
 if(instance == NULL) return(-1);
 
 for(id=0; id< type->nAdd; id++)
   {if(type->bAddress[id] == instance) return(id);}
 
 if(type->maxAdd == 0)
    {type->maxAdd = 50;
     type->bAddress = (void*)malloc(type->maxAdd*sizeof(void *));
     if(type->bAddress == NULL) 
       {FrError(3,"FrDicGetId","malloc_failed");
        return(-2);}}

 if(id >= type->maxAdd)
    {type->maxAdd = type->maxAdd + 50;
     type->bAddress = (void *) realloc(type->bAddress,
                                       type->maxAdd*sizeof(void *));
     if(type->bAddress == NULL) 
       {FrError(3,"FrDicGetId","malloc_failed");
        return(-2);}}

 type->bAddress[id] = instance;
 type->nAdd++;

 return(id);} 
  
/*------------------------------------------------------- FrDicIni ---*/
void FrDicIni()
/*--------------------------------------------------------------------*/
{int i;

 for(i=0; i<FrnSH; i++) {FrSH[i]->nAdd = 0;}

 return;} 

/*----------------------------------------------- FrEndOfFileDef ----*/
struct FrSH *FrEndOfFileDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrEndOfFile",FrEndOfFileRead);

  FrSENew(classe, "INT_4U", "nFrames","-");
  FrSENew(classe, "INT_4U", "nBytes","-");
  FrSENew(classe, "INT_4U", "chkFlag","-");
  FrSENew(classe, "INT_4U", "chkSum","-");

  return(classe);}
/*------------------------------------------------ FrEndOfFileRead---*/
void FrEndOfFileRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{unsigned int nBytes,nFrames,chkFlag,chkSum;
 unsigned short instance;
 struct FrFile *temp, *new;
 char *newName;

  FrReadShortU(iFile, &instance);
  FrReadIntU  (iFile, &nFrames);
  FrReadIntU  (iFile, &nBytes);
  FrReadIntU  (iFile, &chkFlag);
  FrReadIntU  (iFile, &chkSum);

  if(FrDebugLvl > 0)
    {fprintf(FrFOut, "End of Files Reached\n  nFrames=%d nBytes=%d\n",
               nFrames, nBytes);}

     /*--- we try to open the next file in the list ----*/

  newName = iFile->namePtr;
  FrFileNextName(iFile);
  if(*iFile->fileName == '\0')
     {iFile->endOfFrame = FR_YES;
      return;}
 
    /*---- there is a new file, we close the old one ----*/

  new = FrFileINew(newName);

  temp = (struct FrFile *)malloc(sizeof(struct FrFile));
  if(temp == NULL || new == NULL) 
        {iFile->error = FR_ERROR_MALLOC_FAILED;
          return;}

  memcpy(temp, iFile, sizeof(struct FrFile));
  FrFileIEnd(temp);
  memcpy(iFile, new, sizeof(struct FrFile));
  free(new);

  return;}

/*----------------------------------------------- FrEndOfFileWrite---*/
void FrEndOfFileWrite(struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{static struct FrEndOfFile *eof = NULL;
 unsigned int nBytes;
 
 if(eof == NULL) 
    {eof = (struct FrEndOfFile *) calloc(1,sizeof(struct FrEndOfFile));
     if(eof == NULL) 
       {oFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
     else {eof->classe = FrEndOfFileDef();}}
 
 FrPutNewRecord(oFile, eof);
 nBytes = oFile->nBytes + 24; /* 24 is the size of the end of file bloc*/
 FrPutIntU (oFile, oFile->nFrames);
 FrPutIntU (oFile, nBytes);
 FrPutIntU (oFile, 0);
 FrPutIntU (oFile, 0);
 FrPutWriteRecord(oFile);

 if(FrDebugLvl > 0)
    {fprintf(FrFOut,"write End of File after %d frames; %d Bytes\n",
         oFile->nFrames, nBytes);}

 return;}


/*----------------------------------------------- FrEndOfFrameDef ----*/
struct FrSH *FrEndOfFrameDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrEndOfFrame",FrEndOfFrameRead);

  FrSENew(classe, "INT_4U", "run","-");
  FrSENew(classe, "INT_4U", "frame","-");

  return(classe);}
/*------------------------------------------------ FrEndOfFrameRead---*/
void FrEndOfFrameRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{unsigned int run,frameNumber;
 unsigned short instance;

  FrReadShortU(iFile, &instance);
  FrReadIntU(iFile, &run);
  FrReadIntU(iFile, &frameNumber);

  if(FrDebugLvl > 0)
    {fprintf(FrFOut, "FrEndOfFrameRead: reach end of frame"
                     " (run=%d frame=%d)\n", run, frameNumber);}

  /*------ check that the frame is not corrupted -----*/

  if(run != iFile->curFrame->run)
     {FrError(3,"FrEndOfFrameRead","run number missmatch");
      iFile->error = FR_ERROR_BAD_END_OF_FRAME;
      return;}

  if(frameNumber != iFile->curFrame->frame)
     {FrError(3,"FrEndOfFrameRead","frame number missmatch");
      iFile->error = FR_ERROR_BAD_END_OF_FRAME;
      return;}

  iFile->endOfFrame = FR_YES;

  return;}

/*----------------------------------------------- FrEndOfFrameWrite---*/
void FrEndOfFrameWrite(struct FrameH *frameH, 
                       struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{static struct FrEndOfFrame *eof = NULL;
 
 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"write eof for frame %d Run:%d \n",
         frameH->frame, frameH->run);}

 if(eof == NULL) 
    {eof = (struct FrEndOfFrame *) calloc(1,sizeof(struct FrEndOfFrame));
     if(eof == NULL) 
       {oFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
     else {eof->classe = FrEndOfFrameDef();}}
 
 FrPutNewRecord(oFile, eof);
 oFile->inMemER = oFile->p;
 FrPutIntU (oFile, frameH->run);
 oFile->inMemEF = oFile->p;
 FrPutIntU (oFile, frameH->frame);
 FrPutWriteRecord(oFile);

 return;}

/*----------------------------------------------------- FrError ------*/
char *FrError(long level, 
              char *function, 
              char *message)
/*--------------------------------------------------------------------*/
/* handle FrameLib error acording the level of severity.              */
/* input: function: name of the function calling for an error         */
/*        message:  message to by reported                            */
/*        level:    2 = warning,                                      */
/*                  3 = fatal error: requested action could not be    */
/*                                   completed                        */
/* return: a pointer to the string which contains the history of the  */
/*         error messages                                             */
/*--------------------------------------------------------------------*/
{static long errorMsgL = 0;
#define  FRERRORMSGSIZE  500     /* this is used only in this function */
 static char errorMsg[FRERRORMSGSIZE];
 
 if(level == -1) return(errorMsg);

 if(level < 2)
     {sprintf(FrBuf," *** FrInfo: in %s %s\n",function,message);}
 else if(level < 3)
     {sprintf(FrBuf," *** FrWarning: in %s %s\n",function,message);}
 else{sprintf(FrBuf," *** FrError: in %s %s\n",function,message);}
   
 if(errorMsgL < FRERRORMSGSIZE)
   {strncpy(&errorMsg[errorMsgL], FrBuf, FRERRORMSGSIZE-errorMsgL);
    errorMsgL = strlen(FrBuf) + errorMsgL;}
 
 if(FrErrorHandler != NULL) 
   {FrErrorHandler(level, FrBuf);}
 
  return(errorMsg);}

/*---------------------------------------------FrErrorGetHistory------*/
char *FrErrorGetHistory()
/*--------------------------------------------------------------------*/
/* return: a pointer to the string which contains the history of the  */
/*         error messages                                             */
/*--------------------------------------------------------------------*/
{static char *errorMsg = NULL;

 if(errorMsg == NULL)
   {errorMsg = FrError(-1,NULL,NULL);}
 
  return(errorMsg);}
/*----------------------------------------------- FrErrorDefHandler---*/
void FrErrorDefHandler(long level, 
                       char *lastMessage)
/*--------------------------------------------------------------------*/
/* default handler for the FrameLib error.                            */
/* input parameters:                                                  */
/*   lastMessage: the string which contain the last generated message */
/*   level:  2 = warning,                                             */
/*           3 = fatal error: requested action could not be  completed*/
/*--------------------------------------------------------------------*/
{
    if(FrDebugLvl > 0)
       {fprintf(FrFOut,"%s",lastMessage);
        fprintf(stderr,"%s",lastMessage);}
 
    return;}

/*-------------------------------------------------FrErrorSetHandler--*/
void FrErrorSetHandler(void  (*handler)(long, char *))
/*--------------------------------------------------------------------*/
{
 FrErrorHandler = handler;

 return;}

/*--------------------------------------------------- FrFileDbg ----*/
void FrFileDbg(struct FrFile *file)
/*--------------------------------------------------------------------*/
{long i,size;
  char *b;
  unsigned c;
 
  if(FrDebugLvl < 1) return;
  if(file->string == FR_YES)
    {size = file->p - file->buf;
     fprintf(FrFOut," \n Buffer size = %ld\n Buffer:\n\n",size);
     b = file->buf;
     for(i=0; i<size; i=i+16)
           {fprintf(FrFOut," %10ld  ",i); 
            c = b[i+0]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+1]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+2]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+3]; fprintf(FrFOut,"%2.2x  ",c);
            c = b[i+4]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+5]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+6]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+7]; fprintf(FrFOut,"%2.2x   ",c);
            c = b[i+8]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+9]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+10]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+11]; fprintf(FrFOut,"%2.2x  ",c);
            c = b[i+12]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+13]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+14]; fprintf(FrFOut,"%2.2x ",c);
            c = b[i+15]; fprintf(FrFOut,"%2.2x\n",b[i+15]);}} 
  
  return;}

/*----------------------------------------------------- FrFileFree----*/
void FrFileFree(struct FrFile *file)
/*--------------------------------------------------------------------*/
{  
  if(file->fileName != NULL) 
    {free(file->fileList);
     free(file->fileName);}

  FrFileId(file->id, 2);

  FrDicFree(file);

  FrFileMarkFree(file->mark);

  free(file->sh);

  free(file);

  return;
}
/*-------------------------------------------------- FrFileHeader-----*/
void FrFileHeader(unsigned char *buf)
/*--------------------------------------- define the format version --*/
/* format version 3 is valid since FrameLib version 3.0 (July 97)     */
/* format version 2 is valid since FrameLib version 2.3 (May 97)      */
/* format version 1 was valid up to the FrameLib version 2.24         */
/*--------------------------------------------------------------------*/
{unsigned short swapS;
 unsigned int swapI,i;
 unsigned long int swapL;
 double dPi;
 float fPi;
 int formatVersion;
 int libMinorVersion;

 sscanf(FrVersion,"%d.%d",&formatVersion,&libMinorVersion);

 for(i=0; i<40; i++) {buf[i] = 0;}

 strcpy((char *) buf,"IGWD");
 buf[5]  = formatVersion;
 buf[6]  = libMinorVersion;
 buf[7]  = FrSshort;
 buf[8]  = FrSint;
 buf[9]  = FrSlong;
 buf[10] = FrSfloat;
 buf[11] = FrSdouble;
 swapS = 0x1234;         
 swapI = 0x12345678;
 swapL = 0x12345678; 
 swapL = 0;
 for (i=0; i<2*sizeof(long); i++)
    {swapL = swapL*16 + i;}          /*  swapL = 0x123456789abcdef;  */
 fPi = 3.1415926535897932384626; 
 dPi = 3.1415926535897932384626;
 memcpy(&buf[12],&swapS,2);
 memcpy(&buf[14],&swapI,FrSint);
 memcpy(&buf[18],&swapL,FrSlong);
 memcpy(&buf[26],&fPi,FrSfloat);
 memcpy(&buf[30],&dPi,FrSdouble);
 buf[38] = 'A';
 buf[39] = 'Z';
   
 return;}

/*----------------------------------------------------- FrFileId ----*/
long FrFileId(long id, 
              long mode)

/* this function keep the list of valid file id's. id are > 0. 
   to add a file id (mode = 0):
             It returns the same file id or 0 in case of error.
   to check the existance of a file (mode = 1): 
             call it with the file id as argument. 
             It returns the file id if it exist or 0 if not.
   to remove a file id (mode = 2): 
             call it with minus the file id as argument. It returns 0.*/
/*--------------------------------------------------------------------*/
{static long idList[100];
 static long idMax=0;
 long i;
 
                /*-------remove a file---------------------*/

 if(mode == 2)
   {for(i=0; i<idMax; i++)
      {if(idList[i] == id) {idList[i] = 0;}}}
 
                /*------ add a file---------------------*/
  
 else if(mode == 0)
   {for(i=0; i<idMax; i++)
      {if(idList[i] == id) return(id);}
    for(i=0; i<idMax; i++)
      {if(idList[i] == 0) {idList[i] = id;
                           return(id);}}
    if(idMax<100)
      {idMax++;
       idList[idMax] = id;
       return(id);}}

                /*------ check a file---------------------*/
    
 else
   {for(i=0; i<idMax; i++)
      {if(idList[i] == id) return(id);}}
  
 return(0);}
/*------------------------------------------------------ FrFileIncSH--*/
void FrFileIncSH(struct FrFile *iFile,
                 unsigned short id)
/*--------------------------------------------------------------------*/
{struct FrSH **old;
 int i;

          /*--- check the space for the direct acces table ----*/
          
 if(id < iFile->maxSH) return;
 
 old = iFile->sh;
 iFile->sh = calloc(id+10, sizeof(struct FrSH*));
 if(iFile->sh == NULL)
                {iFile->error = FR_ERROR_MALLOC_FAILED;
                 return;} 
 for(i=0; i<iFile->maxSH; i++)
               {iFile->sh[i] = old[i];}
 iFile->maxSH = id+10;
 free(old);

 return;}
/*----------------------------------------------------- FrFileNew ----*/
struct FrFile *FrFileNew(char *fileName, 
                         unsigned short compress, 
                         char *buf, 
                         long bufSize)
/*--------------------------------------------------------------------*/
{struct FrFile *file;
 static long id=1;
 long i;
   
  FrLibShortIni();  /*---- do a short init if needed ---*/
 
  file = (struct FrFile *) calloc(1,sizeof(struct FrFile));
  if(file == NULL) 
    {FrError(3,"FrFileNew","malloc struct file failed");
     return(NULL);}

  if(fileName != NULL) 
    {file->fileList = malloc(strlen(fileName)+1);
     file->fileName = malloc(strlen(fileName)+1);
     if(file->fileList == NULL || 
        file->fileName == NULL) FrError(3,"FrFileNew","malloc name failed");
     strcpy(file->fileList,fileName);
     file->namePtr = file->fileList;
     FrFileNextName(file);}
  else
   {file->fileName = NULL;}

  file->compress = compress;
  file->gzipLevel = 1;
  file->run = -1;
  file->frfd= NULL;
  file->p   = NULL;
  file->pMax = file->p + 99999999;
  file->bufSize = 0;
  file->buf       = NULL;
  file->sDataSim  = NULL;
  file->sDataProc = NULL;
  file->error = 0;
  file->id = FrFileId(id++,0);
  file->FrSHRead = FrSHRead;
  file->FrSERead = FrSERead;
  file->nBytes  = 0;
  file->nFrames = 0;
  file->relocation = FR_YES;
 
  file->maxSH = 10; 
  file->sh = calloc(file->maxSH, sizeof(struct FrSH*));

     /*--- check tempory space  ---*/

  if(file->fileName == NULL)
       {file->string = FR_YES;}
  else if(strcmp(file->fileName,"STRING") != 0) 
       {file->string = FR_NO;}
  else {file->string = FR_YES;}

  file->buf = buf;
  file->bufSize = bufSize;
  file->p    = file->buf;
  file->pMax = file->p + bufSize;
 
     /*---- reset dictionary output ----*/

  for(i=0; i<FRMAPMAXSH; i++)
     {file->dicWrite[i] = FR_NO;}

  return(file);
}

/*------------------------------------------------ FrFileNextName ----*/
void FrFileNextName(struct FrFile *file)
/*--------------------------------------------------------------------*/
/* this function extarct the next file name in the list               */
{char *copy, *current;

     /*---- search for the beginning of the string ---*/

  current = file->namePtr;
  while(isspace(*current))
       {if(*current == '\0') break;
        current++;}

      /*---------- copy the fileName -----------------*/

  copy = file->fileName;
  while(!isspace(*current))
       {if(*current == '\0') break;
        *copy = *current;
        copy++;
        current++;}

  *copy = '\0';
  file->namePtr = current;

  return;}

/*--------------------------------------------------- FrFileIEnd ----*/
void FrFileIEnd(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;
 
  if(iFile == NULL) return;
  
  if(iFile->frfd != NULL) {FrIOClose(iFile->frfd);}

  sData = iFile->sDataSim;
  while(sData != NULL) {sData = FrStatDataFree(sData);}

  sData = iFile->sDataProc;
  while(sData != NULL) {sData = FrStatDataFree(sData);}

  FrFileFree(iFile);
 
  return;}
  
/*--------------------------------------------------- FrFileINew------*/
struct FrFile *FrFileINew(char *fileName,...) 
/*--------------------------------------------------------------------*/
{struct FrFile *file;

  file = FrFileNew(fileName, 0, NULL, 0);
  if(file == NULL) return (NULL);

  FrFileIOpen(file);
  if(file->error != FR_OK) return(NULL);

  return(file);
}
/*--------------------------------------------------- FrFileINewFd----*/
struct FrFile *FrFileINewFd(struct FrIO *frfd,...)
/*--------------------------------------------------------------------*/
{struct FrFile *file;
 
  file = FrFileNew("open_with_fd",0, NULL, 0);
  if(file == NULL) return (NULL);

  file->frfd = frfd;

  FrFileIOpen(file);
  if(file->error != FR_OK) return(NULL);

  return(file);
}
/*--------------------------------------------------- FrFileIOpen ----*/
void FrFileIOpen(struct FrFile *file)
/*--------------------------------------------------------------------*/
{char format;
 int i;
 unsigned char *h,l[40];

      /*---------- read the first byte --------------*/
      
 if(file->frfd != NULL)
      {if(FrDebugLvl > 0) fprintf(FrFOut,
           "FrFileIOpen: open file using existing file descriptor\n");}
 else if(file->string == FR_NO)
      {if(FrDebugLvl > 0) fprintf(FrFOut,
           "FrFileIOpen: open file:%s\n",file->fileName); 

       file->frfd = FrIOOpenR(file->fileName);
       if(file->frfd == NULL)  
           {FrError(3,"FrFileIOpen"," Open file error");
            file->error = FR_ERROR_OPEN_ERROR;
            return;}}
  
 else
     {if(FrDebugLvl > 0) fprintf(FrFOut,
            "FrFileIOpen: input data from string");} 
 
      /*---------- read the first bytes to determine the format --*/
      
 i = FrRead(file, (char *) &format, 1);
 if(i != 1)  
     {FrError(3,"FrFileIOpen"," Cannot read first byte");
      file->error = FR_ERROR_READ_ERROR;
      return;}
 
       /*------ select format type (old or current) -----*/
      
 if     (format == 2)   {FrBack2FileOpen(file);} 

 else if(format == 'I')	 
   {if(FrRead(file, (char *) file->header+1, 39) != 39)  
      {FrError(3,"FrOFileOpen","read failled"); 
       file->error = FR_ERROR_READ_ERROR;
       return;}
    file->fmtVersion = file->header[5];

     /*----- for binary files select check byte swaping and word lenght---*/

    FrFileHeader(l);
    h = file->header;
    h[0] = format;
    if(FrDebugLvl > 0)
       {fprintf(FrFOut," Header(local): Originator:%.5s(%.5s)",h,l);
        fprintf(FrFOut," Format version:%d(%d)",h[5],l[5]);
        fprintf(FrFOut," Library version:%d(%d)\n",h[6],l[6]);
        fprintf(FrFOut,
          "  Sizeof: s:%d(%d) i:%d(%d) l:%d(%d) f:%d(%d) d:%d(%d)\n",
              h[7],l[7],h[8],l[8],h[9],l[9],h[10],l[10],h[11],l[11]);
        fprintf(FrFOut,
          "  SwapS:%3x%2x(%2x%2x)  \n",
              h[12],h[13],l[12],l[13]);
        fprintf(FrFOut,
          "  SwapI:%3x%2x%2x%2x(%2x%2x%2x%2x)\n",
              h[14],h[15],h[16],h[17],
              l[14],l[15],l[16],l[17]);
        fprintf(FrFOut,
          "  SwapL:%3x%2x%2x%2x%2x%2x%2x%2x(%2x%2x%2x%2x%2x%2x%2x%2x)\n",
              h[18],h[19],h[20],h[21],h[22],h[23],h[24],h[25],
              l[18],l[19],l[20],l[21],l[22],l[23],l[24],l[25]);
        fprintf(FrFOut,"  FPi:%3x%2x%2x%2x(%2x%2x%2x%2x)\n",
              h[26],h[27],h[28],h[29],
              l[26],l[27],l[28],l[29]);
        fprintf(FrFOut,"  DPi:%3x%2x%2x%2x%2x%2x%2x%2x"
                            "(%2x%2x%2x%2x%2x%2x%2x%2x)\n",
              h[30],h[31],h[32],h[33],h[34],h[35],h[36],h[37],
              l[30],l[31],l[32],l[33],l[34],l[35],l[36],l[37]);}

    file->fmType = FRNATIVE;
    file->fmLong = FRNATIVE;
    if(memcmp(&h[7],&l[7],19) == 0)               
        {if(FrDebugLvl > 0) fprintf(FrFOut,
                 " No format conversion is needed\n");}
    else{if(FrDebugLvl > 0) fprintf(FrFOut,
                " Format conversion is needed\n");
         if(h[12] == l[13])
            {file->fmType = FRSWAP;
             file->fmLong = FRSWAP;
             if(FrDebugLvl > 0) fprintf(FrFOut," We will swap bytes\n");}
         if(FrSlong == 8 && h[9] == 4) 
            {if(file->fmLong == FRSWAP) 
                 {file->fmLong = FREXPAND_AND_SWAP;}
             else{file->fmLong = FREXPAND;}
             if(FrDebugLvl > 0) fprintf(FrFOut,
                " We will convert long from 4 bytes word to 8 bytes\n");}
         if(FrSlong == 4 && h[9] == 8) 
            {if(file->fmLong == FRSWAP) 
                 {file->fmLong = FRCONTRACT_AND_SWAP;}
             else{file->fmLong = FRCONTRACT;}
             if(FrDebugLvl > 0) fprintf(FrFOut,
                " We will convert long from 8 bytes word to 4 bytes\n");}
         if(file->fmLong == FRNATIVE) 
           {if(FrDebugLvl > 0) fprintf(FrFOut," Strange format\n");
            FrError(3,"FrOFileOpen","Strange format");}
     }  }

 else
      {if(FrDebugLvl > 0) 
           fprintf(FrFOut,"    unknown format: %d\n",format);
       FrError(3,"FrOFileOpen","unknown format"); 
       file->error = FR_ERROR_OPEN_ERROR;
       return;}
 
 return;}

/*--------------------------------------------------- FrFileIRewind---*/
struct FrFile *FrFileIRewind(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrFile *newFile;

  if(iFile == NULL) return(NULL);
  
  if(iFile->frfd != NULL) {FrIOClose(iFile->frfd);}

    /*--- free the space used by the dictionnary ----*/

  FrDicFree(iFile);

  free(iFile->sh);

    /*----- open again the file------------*/

  newFile = FrFileINew(iFile->fileName);
  if(newFile == NULL) return(NULL);

    /*--------- map the information---------*/

  memcpy(newFile, iFile, sizeof(struct FrFile));

  free(newFile);

  return(iFile);
}

/*---------------------------------------------------- FrFileOEnd ----*/
void FrFileOEnd(struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{ 
  if(oFile == NULL) return;

  FrEndOfFileWrite(oFile);

  FrFileMarkWrite(oFile);
    
  if(oFile->frfd != NULL) {FrIOClose(oFile->frfd);}

  FrFileFree(oFile);
 
  return;}



/*-------------------------------------------------- FrFileONew -----*/
struct FrFile *FrFileONew(char  *fileName, 
                          unsigned short  compress, 
                          char  *outBuf, 
                          long  bufSize)
/*--------------------------------------------------------------------*/
{struct FrFile *oFile;
 
      /*-- first create structure ------*/
     
  oFile = FrFileNew(fileName, compress, outBuf, bufSize);
  if(oFile == NULL) return(NULL);
  oFile->inMemH1 = NULL;
  oFile->inMemH2 = NULL;

     /*----- initialized output file ------*/      
     /* check if we use a real file and open it */

  if(oFile->string == FR_NO)
       {oFile->frfd = FrIOOpenW(oFile->fileName);
        if(oFile->frfd == NULL) 
           {FrError(3,"FrFileONew"," Open file error");
            oFile->error = FR_ERROR_OPEN_ERROR;
            return(NULL);}}

    /*---- first write file header ----*/
	 
  FrFileOOpen(oFile);
   
  return(oFile);}

/*-------------------------------------------------- FrFileONewFd----*/
struct FrFile *FrFileONewFd(struct FrIO *frfd, 
                            unsigned short compress, 
                            char *outBuf, 
                            long bufSize)
/*--------------------------------------------------------------------*/
{struct FrFile *oFile;
 
      /*-- first create structure ------*/
      
  oFile = FrFileNew("open_with_fd", compress, outBuf, bufSize);
  if(oFile == NULL) return(NULL);

     /*----- initialized output file ------*/      

  oFile->frfd = frfd;
  if(oFile->frfd == NULL) 
           {FrError(3,"FrFileONewFd"," Open file error");
            oFile->error = FR_ERROR_OPEN_ERROR;
            return(NULL);}

    /*---- first write file header ----*/
	 
  FrFileOOpen(oFile);
 
  return(oFile);}

/*-------------------------------------------------- FrFileOOpen-----*/
void FrFileOOpen(struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{char buf[40];
 struct FrSH *classe;
 
    /*---- write the file header ----*/
	 
  FrFileHeader((unsigned char*) buf);
     
  if(oFile->string == FR_YES)
          {memcpy(oFile->p, buf, 40);}
  else {if(FrIOWrite(oFile->frfd, buf, 40) != 40) 
                 {FrError(3,"FrOFileIni"," write error");
                  oFile->error = FR_ERROR_WRITE_ERROR;
                  return;}}
  oFile->p += 40;
  oFile->nBytes = 40;
    

     /*---- we do not write here the minimal dictionnary -----*/

  classe = FrSHDef();
  oFile->dicWrite[classe->id] = FR_YES;	 
  classe = FrSEDef();
  oFile->dicWrite[classe->id] = FR_YES;
   
  return;}

/*------------------------------------------- FrFileOSetGzipLevel-----*/
void FrFileOSetGzipLevel(struct FrFile *oFile, unsigned short level)
/*--------------------------------------------------------------------*/
{
  if(oFile != NULL) {oFile->gzipLevel = level;}

 return;}

/*-------------------------------------------------- FrFileOUpdate---*/
void FrFileOUpdate(struct FrFile *oFile,
                   unsigned int frame, 
                   unsigned int run, 
                   unsigned int gtimeS, 
                   unsigned int gtimeN)
/*--------------------------------------------------------------------*/
{
 if(oFile == NULL) return;

/*--- update FrameH structure ----*/

 memcpy(oFile->inMemF, &frame,4);
 memcpy(oFile->inMemEF,&frame,4);
 memcpy(oFile->inMemR, &run,4);
 memcpy(oFile->inMemER,&run,4);
 memcpy(oFile->inMemS,&gtimeS,4);
 memcpy(oFile->inMemN,&gtimeN,4);
 
 /*---- update the last two history records ---*/

 if(oFile->inMemH1 != NULL) memcpy(oFile->inMemH1,&gtimeS,4);
 if(oFile->inMemH2 != NULL) memcpy(oFile->inMemH2,&gtimeS,4);
 
 return;}

/*-------------------------------------------------FrHistoryAdd ------*/
struct FrHistory *FrHistoryAdd(struct FrameH *frame, 
                               char *comment)
/*--------------------------------------------------------------------*/
{struct FrHistory *history;
 char name[10];
 int i;
 
  history = (struct FrHistory *) calloc(1,sizeof(struct FrHistory));
  if(history == NULL)  
       {return(NULL);}
  else {history->classe = FrHistoryDef();}
 
  history->time = time(NULL) - FRGPSOFF + FRGPSLEAPS;

  if(FrStrCpy(&history->comment, comment) == NULL) return(NULL);
   
  i = 1;
  if(frame != NULL) 
      {if(frame->history != NULL)
	{sscanf(frame->history->name,"%d",&i);}}
         
  sprintf(name,"%d",i+1);
  if(FrStrCpy(&history->name,name) == NULL) return(NULL);
         
     /*----- now store it in the Frame structure -----*/

  if(frame != NULL)
    {history->next = frame->history;
     frame->history = history;}

 return(history);}

/*-------------------------------------------------- FrHistoryDef ----*/
struct FrSH *FrHistoryDef()    
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrHistory",FrHistoryRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_4U", "time","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "PTR_STRUCT(FrHistory *)", "next","-");

  return(classe);}
 
/*--------------------------------------------------FrHistoryFree-----*/
struct FrHistory *FrHistoryFree(struct FrHistory *history)
/*--------------------------------------------------------------------*/
{struct FrHistory *next;

 if (history==NULL) return(NULL);

 next = history->next;

 if (history->comment != NULL) free(history->comment);
 free(history->name);
 free(history);

 return(next);}

/*--------------------------------------------------- FrHistoryRead---*/
void FrHistoryRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/{struct FrHistory *history;

  history = (struct FrHistory *) calloc(1,sizeof(struct FrHistory));
  if(history == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {history->classe = FrHistoryDef();}
  
  FrReadHeader(iFile,  history);
  FrReadSChar (iFile, &history->name); 
  FrReadIntU  (iFile, &history->time);
  FrReadSChar (iFile, &history->comment);
  FrReadStruct(iFile, &history->next);
   
return;}

/*------------------------------------------------- FrHistoryWrite---*/
void FrHistoryWrite(struct FrHistory *history, 
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{

  FrPutNewRecord(oFile, history);
  FrPutSChar (oFile, history->name);
  oFile->inMemH2 = oFile->inMemH1;
  oFile->inMemH1 = oFile->p;
  FrPutIntU  (oFile, history->time);
  FrPutSChar (oFile, history->comment);
  FrPutStruct(oFile, history->next);
  FrPutWriteRecord(oFile);

  if(history->next != NULL)  {FrHistoryWrite(history->next, oFile);}

  return;}

/*-------------------------------------------------FrMsgAdd ----------*/
struct FrMsg *FrMsgAdd(struct FrameH *frame, 
                       char *alarm,
                       char *message, 
                       unsigned int severity)
/* This function returns NULL in case of errors                       */
/*--------------------------------------------------------------------*/
{struct FrRawData *rawData;
 struct FrMsg *msg;
 
    /*--- first create and fill the structure ---*/

  msg = (struct FrMsg *) calloc(1,sizeof(struct FrMsg));
  if(msg == NULL)  
       {FrError(3,"FrMsgAdd","malloc failed");
        return(NULL);}
  else {msg->classe = FrMsgDef();}
	 
  if(FrStrCpy(&msg->message,message) == NULL) 
       {FrError(3,"FrMsgAdd","malloc failed");
        return(NULL);}
  msg->severity = severity;

  if(FrStrCpy(&msg->alarm, alarm) == NULL)
       {FrError(3,"FrMsgAdd","Cannot malloc alarm name");
        return(NULL);}
  
   /*--- then store it -----*/

  if(frame->rawData == NULL) {FrRawDataNew(frame);}
  rawData = frame->rawData;
  if(rawData == NULL) 
       {FrError(3,"FrMsgAdd","Cannot create FrRawData");
        return(NULL);}
     
  msg->next = rawData->logMsg;
  rawData->logMsg = msg;
  
  return(msg);} 

/*------------------------------------------------------ FrMsgDef ----*/
struct FrSH *FrMsgDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrMsg",FrMsgRead);

  FrSENew(classe, "STRING", "alarm","-");
  FrSENew(classe, "STRING", "message","-");
  FrSENew(classe, "INT_4U", "severity","-");
  FrSENew(classe, "PTR_STRUCT(FrMsg *)", "next","-");

  return(classe);}
  
/*------------------------------------------------------FrMsgFree-----*/
void FrMsgFree(struct FrMsg *msg)
/*--------------------------------------------------------------------*/
{ 

 if(msg == NULL) return;

 if(msg->next != NULL) FrMsgFree(msg->next);

 if(msg->alarm   != NULL) free (msg->alarm);
 if(msg->message != NULL) free (msg->message);
 free(msg);

 return;}

/*------------------------------------------------------- FrMsgRead---*/
void FrMsgRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrMsg *msg;

  msg = (struct FrMsg *) calloc(1,sizeof(struct FrMsg));
  if(msg == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {msg->classe = FrMsgDef();}

  FrReadHeader(iFile,  msg);
  FrReadSChar (iFile, &msg->alarm); 
  FrReadSChar (iFile, &msg->message);
  FrReadIntU  (iFile, &msg->severity);
  FrReadStruct(iFile, &msg->next);
    
return;}

 /*---------------------------------------------------- FrMsgWrite---*/
void FrMsgWrite(struct FrMsg *msg,
                struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
 
  FrPutNewRecord(oFile, msg);
  FrPutSChar (oFile, msg->alarm);
  FrPutSChar (oFile, msg->message);
  FrPutIntU  (oFile, msg->severity);
  FrPutStruct(oFile, msg->next);
  FrPutWriteRecord(oFile);
    
 return;}
 
/*--------------------------------------------------- FrObjectDef ----*/
struct FrSH *FrObjectDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrObject",NULL);

  return(classe);}

/*---------------------------------------------------- FrObjectDump---*/
void FrObjectDump(struct FrObject *proto,
                  FILE *fp)
/*--------------------------------------------------------------------*/
{
 if(fp    == NULL) return;
 if(proto == NULL) return;
 
 if(proto->classe != NULL)  {proto->classe->objDump(proto, fp);}   


 return;}

/*--------------------------------------------------- FrObjectFree----*/
void FrObjectFree(struct FrObject *proto)
/*--------------------------------------------------------------------*/
{
 if(proto == NULL) return;
 
 if(proto->classe != NULL)  {proto->classe->objFree(proto);}   

 return;}

/*----------------------------------------------------FrObjectWrite---*/
void FrObjectWrite(struct FrObject *proto, 
                   struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
 if(proto == NULL) return;
 
 if(proto->classe != NULL)  {proto->classe->objWrite(proto, oFile);}   

 return;}

/*--------------------------------------------------------FrPutChar---*/
void FrPutChar(struct FrFile *oFile,
               char value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;

 if(oFile->p+1 > oFile->pMax) 
     {FrError(3,"FrPutChar","Fr_buf overflow");
      oFile->error = FR_ERROR_BUFF_OVERFLOW;}

 else{*oFile->p++ = value;}
    
 return;}
/*-------------------------------------------------------FrPutDouble--*/
void FrPutDouble(struct FrFile *oFile,
                 double value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;

 if(oFile->p+FrSdouble > oFile->pMax) 
     {FrError(3,"FrPutDouble","Fr_buf overflow");
      oFile->error = FR_ERROR_BUFF_OVERFLOW;}

 else{memcpy(oFile->p, &value, FrSdouble); 
      oFile->p += FrSdouble;}
    
 return;}

/*---------------------------------------------------------FrPutFloat-*/
void FrPutFloat(struct FrFile *oFile,
                float value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;
  
 if(oFile->p+FrSfloat > oFile->pMax) 
     {FrError(3,"FrPutFloat","Fr_buf overflow");
      oFile->error = FR_ERROR_BUFF_OVERFLOW;}

 else{memcpy(oFile->p, &value, FrSfloat);
      oFile->p += FrSfloat;}
     
 return;}

/*--------------------------------------------------------FrPutInt----*/
void FrPutInt(struct FrFile *oFile,
              int value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;
 
 if(oFile->p+FrSint > oFile->pMax) 
     {FrError(3,"FrPutInt","Fr_buf overflow");
      oFile->error = FR_ERROR_BUFF_OVERFLOW;}
   
 else{memcpy(oFile->p, &value, FrSint);
      oFile->p += FrSint;}
     
return;}

/*--------------------------------------------------------FrPutIntU---*/
void FrPutIntU(struct FrFile *oFile,
               unsigned int value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;
 
 if(oFile->p+FrSint > oFile->pMax) 
     {FrError(3,"FrPutIntU","Fr_buf overflow");
      oFile->error = FR_ERROR_BUFF_OVERFLOW;}

 else{memcpy(oFile->p, &value, FrSint);
      oFile->p += FrSint;}
     
return;}

/*--------------------------------------------------------FrPutLong---*/
void FrPutLong(struct FrFile *oFile,
               long value)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;

 if(oFile->p+FrSlong > oFile->pMax) 
     {FrError(3,"FrPutLong","Fr_buf overflow");
      oFile->error = FR_ERROR_BUFF_OVERFLOW;}
 
 else{memcpy(oFile->p, &value, FrSlong);
      oFile->p += FrSlong;}
 
 return;}
 
/*---------------------------------------------------FrPutNewRecord---*/
void FrPutNewRecord(struct FrFile *oFile,
                    void *instance)
/*--------------------------------------------------------------------*/
{short id;
 struct FrObject *proto; 
 
 if(oFile->error != FR_OK) return;

 proto = instance;
 if(proto == NULL) {FrError(3,"FrPutNewRecord","instance == NULL");}
 if(proto->classe == NULL) {FrError(3,"FrPutNewRecord","classe == NULL");}

 if(oFile->dicWrite[proto->classe->id] == FR_NO) 
   {oFile->dicWrite[proto->classe->id] = FR_YES; 
    FrSHWrite(proto->classe, oFile);}  
    
 if(oFile->string == FR_NO) {oFile->p = oFile->buf;} 

 oFile->pStart = oFile->p;

 if(oFile->p+2*FrSshort+FrSint > oFile->pMax) 
      {FrError(3,"FrPutNewRecord","Fr_buf overflow");
       oFile->error = FR_ERROR_BUFF_OVERFLOW;
       return;}
 id = (short) proto->classe->id;
 oFile->p +=FrSint;

 memcpy(oFile->p, &id, FrSshort);
 oFile->p += FrSshort;

 id = FrDicGetId(proto->classe, instance);
 if(id == -2) 
      {FrError(3,"FrPutNewRecord","FrDicGetId error");
       oFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 memcpy(oFile->p, &id, FrSshort);
 oFile->p += FrSshort;
     
 return;}
 
/*--------------------------------------------------FrPutStruct-------*/
void FrPutStruct(struct FrFile *oFile,
                 void *instance)
/*--------------------------------------------------------------------*/
{short id;
 struct FrObject *example;
 struct FrSH *type;
       
 if(oFile->error != FR_OK) return;

 if(oFile->p+50 > oFile->pMax) 
    {FrError(3,"FrPutStruct","Fr_buf overflow");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return;} 
    
 if(instance == NULL)
   {id = 0; 
    memcpy(oFile->p, &id, FrSshort); 
    oFile->p += FrSshort; 
    memcpy(oFile->p, &id, FrSshort); 
    oFile->p += FrSshort;

    return;}

   /* we assume that the first element of 
    the structure is a name like in FrProto */
    
 example = instance;
 type = example->classe;
 if(type == NULL) {FrError(3,"FrPutStruct","classe == NULL");}
       
 id = type->id; 
 memcpy(oFile->p, &id, FrSshort); 
 oFile->p += FrSshort; 

 id = FrDicGetId(type, example); 
 if(id == -2) 
    {FrError(3,"FrPutStruct","FrDicGetId malloc failed");
     oFile->error = FR_ERROR_MALLOC_FAILED;
     return;} 
 memcpy(oFile->p, &id, FrSshort); 
 oFile->p += FrSshort;

 return;}

/*--------------------------------------------------------FrPutShort--*/
void FrPutShort(struct FrFile *oFile,
                short value)
/*--------------------------------------------------------------------*/
{   
 if(oFile->error != FR_OK) return;

 if(oFile->p+FrSshort > oFile->pMax) 
     {FrError(3,"FrPutShort","Fr_buf overflow");
      oFile->error = FR_ERROR_BUFF_OVERFLOW;}

 else{memcpy(oFile->p, &value, FrSshort);
      oFile->p += FrSshort;}
     
 return;}

/*--------------------------------------------------------FrPutShortU-*/
void FrPutShortU(struct FrFile *oFile,
                 unsigned short value)
/*--------------------------------------------------------------------*/
{   
 if(oFile->error != FR_OK) return;

 if(oFile->p+FrSshort > oFile->pMax) 
     {FrError(3,"FrPutShortU","Fr_buf overflow");
      oFile->error = FR_ERROR_BUFF_OVERFLOW;}

 else{memcpy(oFile->p, &value, FrSshort);
      oFile->p += FrSshort;}
    
 return;}

/*--------------------------------------------------------FrPutSChar--*/
void FrPutSChar(struct FrFile *oFile,
                char *value)
/*--------------------------------------------------------------------*/
{short slen;

 if(oFile->error != FR_OK) return;

 if(value == NULL) {slen = 0;}
 else              {slen = strlen(value)+1;}

 FrPutShort(oFile,slen);

 if(slen != 0) 
    {if(oFile->p+slen > oFile->pMax) 
       {FrError(3,"FrPutFSChar","Fr_buf overflow");
        oFile->error = FR_ERROR_BUFF_OVERFLOW;
        return;} 
     memcpy(oFile->p, value, slen);
     oFile->p += slen;}
 
 return;}

  
/*-----------------------------------------------------------FrPutVC--*/
void FrPutVC(struct FrFile *oFile,
             char *data,
             long nData)
/*--------------------------------------------------------------------*/
{
 if(oFile->error != FR_OK) return;

 if(oFile->p+nData > oFile->pMax) 
    {FrError(3,"FrPutVC","Output File buffer overflow");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return;} 
 
 memcpy(oFile->p, data, nData);
 oFile->p += nData;

 return;}

/*-----------------------------------------------------------FrPutVD--*/
void FrPutVD(struct FrFile *oFile, 
             double *data, 
             long nData)
/*--------------------------------------------------------------------*/
{long size;
	
 if(oFile->error != FR_OK) return;

 size = FrSdouble*nData;
 if(oFile->p+size > oFile->pMax) 
    {FrError(3,"FrPutVD","Output File buffer overflow");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return;} 
   
 memcpy(oFile->p, data, size);
 oFile->p += size;

 return;}

/*-----------------------------------------------------------FrPutVF--*/
void FrPutVF(struct FrFile *oFile, 
             float *data, 
             long nData)
/*--------------------------------------------------------------------*/
{long size;

 if(oFile->error != FR_OK) return;

 size = FrSfloat*nData;
 if(oFile->p+size > oFile->pMax) 
    {FrError(3,"FrPutVF","Output File buffer overflow");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return;} 

 memcpy(oFile->p, data, size);
 oFile->p += size;
	
 return;}

/*-----------------------------------------------------------FrPutVI--*/
void FrPutVI(struct FrFile *oFile, 
             int *data, 
             long nData)
/*--------------------------------------------------------------------*/
{long size;

 if(oFile->error != FR_OK) return;

 size = FrSint*nData;
 if(oFile->p+size > oFile->pMax) 
    {FrError(3,"FrPutVI","Output File buffer overflow");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return;}

 memcpy(oFile->p, data, size);
 oFile->p += size;
	
 return;}

/*-----------------------------------------------------------FrPutVL--*/
void FrPutVL(struct FrFile *oFile, 
             long *data, 
             long nData)
/*--------------------------------------------------------------------*/
{long size;

 if(oFile->error != FR_OK) return;

 size = FrSlong*nData;
 if(oFile->p+size > oFile->pMax) 
    {FrError(3,"FrPutVL","Output File buffer overflow");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return;} 

 memcpy(oFile->p, data, size);
 oFile->p += size;
	
 return;}
/*-----------------------------------------------------------FrPutVQ--*/
void FrPutVQ(struct FrFile *oFile, 
             char **data, 
             long nData)
/*--------------------------------------------------------------------*/
{long i;

 for(i=0; i<nData; i++)
    {FrPutSChar(oFile, data[i]);}

 return;}

/*-----------------------------------------------------------FrPutVS--*/
void FrPutVS(struct FrFile *oFile, 
             short *data, 
             long nData)
/*--------------------------------------------------------------------*/
{long size;

 if(oFile->error != FR_OK) return;

 size = FrSshort*nData;
 if(oFile->p+size > oFile->pMax) 
    {FrError(3,"FrPutVS","Output File buffer overflow");
     oFile->error = FR_ERROR_BUFF_OVERFLOW;
     return;} 

 memcpy(oFile->p, data, size);
 oFile->p += size;		
	
 return;}

/*--------------------------------------------------FrPutWriteRecord--*/
void FrPutWriteRecord(struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{int len;

 if(oFile->error != FR_OK) return;

 len = (int) (oFile->p - oFile->pStart); 
 memcpy(oFile->pStart, &len, FrSint);
           
 if(oFile->string == FR_NO) 
    {if(FrIOWrite(oFile->frfd,oFile->pStart, len) != len) 
            {FrError(3,"FrPutWriteRecord"," write error");
             oFile->error = FR_ERROR_WRITE_ERROR;}}

 oFile->nBytes += len;

 return;}

/*-------------------------------------------------- FrRawDataDef ----*/
struct FrSH *FrRawDataDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrRawData",FrRawDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "PTR_STRUCT(FrSerData *)", "firstSer","-");
  FrSENew(classe, "PTR_STRUCT(FrAdcData *)", "firstAdc","-");
  FrSENew(classe, "PTR_STRUCT(FrMsg *)", "logMsg","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "more","-");

  return(classe);}

/*--------------------------------------------------- FrRawDataDump---*/
void FrRawDataDump(struct FrRawData *rawData, 
                   FILE *fp, 
                   long debugLvl)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adcData;
 struct FrMsg     *msg;
 struct FrSerData *smsData;

 if(fp      == NULL) return;
 if(rawData == NULL) return;
 if(debugLvl < 1)    return;

 fprintf(fp,"Dump Raw data:\n");

     /*----- dump logMsg data -----------*/

 msg = rawData->logMsg;
 while(msg != NULL)
   {fprintf(fp," Message:%s severity=%d\n",
       msg->message, msg->severity);
    msg = msg->next;}

      /*---- dump adc data ----------*/

 adcData = rawData->firstAdc;
 
 while(adcData != NULL) 
    {fprintf(fp," ADC: %s ", adcData->name);
     FrVectDump( adcData->data,  fp, debugLvl);
     adcData = adcData->next;}

      /*--------- dump Slow monitoring data -------*/

 smsData = rawData->firstSer;
 
 while(smsData != NULL) 
    {fprintf(fp," SMS: %s Data:%30s\n", smsData->name, smsData->data);
     smsData = smsData->next;}

 return;}
  
/*--------------------------------------------------FrRawDataFree-----*/
void FrRawDataFree(struct FrRawData *rawData)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adcData;

 if(rawData->name     != NULL) free(rawData->name);
 if(rawData->firstSer != NULL) FrSerDataFree(rawData->firstSer);

 adcData = rawData->firstAdc;
 while(adcData != NULL)
      {adcData = FrAdcDataFree(adcData);}

 if(rawData->logMsg != NULL) FrMsgFree(rawData->logMsg);
 if(rawData->more   != NULL) FrVectFree (rawData->more);

 free(rawData);

 return;}

/*--------------------------------------------------FrRawDataNew------*/
struct FrRawData *FrRawDataNew(struct FrameH *frame)
/*--------------------------------------------------------------------*/
{struct FrRawData *rawData;
  
  rawData = (struct FrRawData *) calloc(1,sizeof(struct FrRawData));
  if(rawData == NULL)  
       {FrError(3,"FrRawData","malloc failed");
        return(NULL);}
  else {rawData->classe = FrRawDataDef();}

  FrStrCpy(&rawData->name,"rawData");
  
  if(frame != NULL) {frame->rawData = rawData;}
  
  return(rawData);}

/*-------------------------------------------------- FrRawDataRead----*/
void FrRawDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrRawData *rawData;

  rawData = (struct FrRawData *) calloc(1,sizeof(struct FrRawData));
  if(rawData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {rawData->classe = FrRawDataDef();}
  
  FrReadHeader(iFile,  rawData);
  FrReadSChar (iFile, &rawData->name); 
  FrReadStruct(iFile, &rawData->firstSer);
  FrReadStruct(iFile, &rawData->firstAdc);
  FrReadStruct(iFile, &rawData->logMsg);
  FrReadStruct(iFile, &rawData->more);
  
  return;}
  
/*------------------------------------------------- FrRawDataWrite---*/
void FrRawDataWrite(struct FrRawData *rawData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adcData;
 struct FrSerData *serData;
 struct FrMsg     *logMsg;

	 /* first write rawData struct */
 
 FrPutNewRecord(oFile, rawData);
 FrPutSChar (oFile, rawData->name);
 FrPutStruct(oFile, rawData->firstSer);
 FrPutStruct(oFile, rawData->firstAdc);
 FrPutStruct(oFile, rawData->logMsg);
 FrPutStruct(oFile, rawData->more);
 FrPutWriteRecord(oFile);   
 
    /* then write adc data struct */

 adcData = rawData->firstAdc;
 
 while(adcData != NULL) 
    {FrAdcDataWrite(adcData, oFile);
     adcData = adcData->next;}
    
   /* write the slow monitoring station stuff */
 
 serData = rawData->firstSer;
 
 while(serData != NULL) 
    {FrSerDataWrite(serData, oFile);
     serData = serData->next;}
    
   /*  write error messages */

 logMsg = rawData->logMsg;

 while(logMsg != NULL) 
    {FrMsgWrite(logMsg, oFile);
     logMsg = logMsg->next;}

   /*  finally write aditional data */
   
 if(rawData->more != NULL) {FrVectWrite(rawData->more, oFile);}

 return;}

/*-------------------------------------------------------FrRead-------*/
int FrRead(struct FrFile *iFile,
           char *buf,
           unsigned int n)
/*--------------------------------------------------------------------*/
{int i,nb;

 if(iFile->string == FR_NO) 
     {i = 0;
      do{nb = FrIORead(iFile->frfd, buf+i, n-i);
         i += nb;
        }while(nb>0 && i<n);
      }
       /*------ the previous logic is complicate since a read may 
        need several calls to deliver all the requested bytes -------*/
         
 else{memcpy(buf,iFile->p,n);
      iFile->p += n;
      i = n;
      if(iFile->p > iFile->pMax) 
         {i = i - (iFile->p - iFile->pMax);}}

 return(i);}  

/*-----------------------------------------------------FrReadDouble---*/
void FrReadDouble(struct FrFile *iFile, 
                  double *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf,local[8];
   
  if(iFile->error != FR_OK) {return;}
 
  if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *) value, FrSdouble);}
  else 
       {i = FrRead(iFile,(char *) local,FrSdouble);
        buf = (unsigned char *) value;
        buf[0] = local[7];
        buf[1] = local[6];
        buf[2] = local[5];
        buf[3] = local[4];
        buf[4] = local[3];
        buf[5] = local[2];
        buf[6] = local[1];
        buf[7] = local[0];}

  if(i == 0) 
    {FrError(3,"FrReadDouble","end of file");
     iFile->error = FR_ERROR_READ_ERROR;}

  return;}

/*-----------------------------------------------------FrReadFloat----*/
void FrReadFloat(struct FrFile *iFile,
                 float *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char local[4], *buf;

  if(iFile->error != FR_OK) {return;}
 
  if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile, (char *) value, FrSfloat);}
  else 
       {i = FrRead(iFile,(char *) local,FrSfloat);
        buf = (unsigned char *) value;
        buf[0] = local[3];
        buf[1] = local[2];
        buf[2] = local[1];
        buf[3] = local[0];}
        
  if(i == 0) 
    {FrError(3,"FrReadFloat","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

  return;}

/*-----------------------------------------------------FrReadHeader---*/
void FrReadHeader(struct FrFile *iFile,
                  void *instance)
/*--------------------------------------------------------------------*/
{unsigned short id;

  FrReadShortU(iFile, &id);

  if(iFile->error == FR_OK)   {FrSetBAT(iFile, id, instance);}
  
  return;}
 
/*-------------------------------------------------------FrReadInt----*/
void FrReadInt(struct FrFile *iFile,
               int *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf,local[4];
   
  if(iFile->error != FR_OK) {return;}
 
  if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *) value, FrSint);}
  else 
       {i = FrRead(iFile,(char *) local,FrSint);
        buf = (unsigned char *) value;
        buf[0] = local[3];
        buf[1] = local[2];
        buf[2] = local[1];
        buf[3] = local[0];}

  if(i == 0) 
    {FrError(3,"FrReadInt","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

  return;}

/*-------------------------------------------------------FrReadInt----*/
void FrReadIntU(struct FrFile *iFile,
                unsigned int *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf,local[4];
   
  if(iFile->error != FR_OK) {return;}
 
  if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *) value, FrSint);}
  else 
       {i = FrRead(iFile,(char *) local,FrSint);
        buf = (unsigned char *) value;
        buf[0] = local[3];
        buf[1] = local[2];
        buf[2] = local[1];
        buf[3] = local[0];}

  if(i == 0) 
    {FrError(1,"FrReadIntU","End of file detected");
     iFile->error = FR_ERROR_READ_ERROR;} 

  return;}

/*-------------------------------------------------------FrReadLong---*/
void FrReadLong(struct FrFile *iFile,
               long *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf,local[8];
 
  if(iFile->error != FR_OK) {return;}
   
  if(iFile->fmLong == FRNATIVE)
       {i = FrRead(iFile, (char *) value, FrSlong);}
  else
    {buf = (unsigned char *) value;
     i = FrRead(iFile,(char *) local, iFile->header[9]);
     if(iFile->fmLong == FREXPAND_AND_SWAP)
       {buf[7] = 0;
        buf[6] = 0;
        buf[5] = 0;
        buf[4] = 0;
        buf[3] = local[0];
        buf[2] = local[1];
        buf[1] = local[2];
        buf[0] = local[3];}
     else if((iFile->fmLong == FRSWAP) && (FrSlong == 8))
       {buf[7] = local[0];
        buf[6] = local[1];
        buf[5] = local[2];
        buf[4] = local[3];
        buf[3] = local[4];
        buf[2] = local[5];
        buf[1] = local[6];
        buf[0] = local[7];}
     else if((iFile->fmLong == FRSWAP) && (FrSlong == 4))
       {buf[3] = local[0];
        buf[2] = local[1];
        buf[1] = local[2];
        buf[0] = local[3];}
     else if(iFile->fmLong == FREXPAND)
       {buf[7] = 0;
        buf[6] = 0;
        buf[5] = 0;
        buf[4] = 0;
        buf[3] = local[3];
        buf[2] = local[2];
        buf[1] = local[1];
        buf[0] = local[0];}
     else if(iFile->fmLong == FRCONTRACT_AND_SWAP)
       {buf[0] = local[3];
        buf[1] = local[2];
        buf[2] = local[1];
        buf[3] = local[0];}
     else if(iFile->fmLong == FRCONTRACT)
       {buf[0] = local[0];
        buf[1] = local[1];
        buf[2] = local[2];
        buf[3] = local[3];}
     else 
       {FrError(3,"FrReadLong","unknown type");}} 

  if(i != iFile->header[9]) 
    {FrError(3,"FrReadLong","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

  return;}

/*----------------------------------------------------FrReadRecord----*/
void FrReadRecord(struct FrFile *iFile,
                 unsigned short type,
                 unsigned int length)
/*--------------------------------------------------------------------*/
{unsigned short instance;
 unsigned int l1,l2;

 FrReadShortU(iFile, &instance);
 if(FrDebugLvl > 0) fprintf(FrFOut,
               "    skip unknown structure. type=%d"
               " instance=%d, size=%d\n",type,instance,length);

 l1 = length-8;
 while(l1 > 0)
      {l2 = FrBufSize;
       if(l2 > l1) {l2 = l1;}
       if(l2 != FrRead(iFile, FrBuf,  l2)) break;
       l1 = l1-l2;}
             
 FrError(3,"FrReadRecord","unknown record");

 return;}
 
/*-------------------------------------------------------FrReadSChar--*/
void FrReadSChar(struct FrFile *iFile,
                 char **value)
/*--------------------------------------------------------------------*/
{short slen;

  if(iFile->error != FR_OK) {return;}
 
  FrReadShort(iFile, &slen); 
  if(iFile->error != FR_OK) {return;}
  if(slen == 0)
    {*value = NULL;}
  else
    {*value = malloc(slen+1); 
     if(*value == NULL) 
        {FrError(3,"FrReadSChar","malloc failed"); 
         iFile->error = FR_ERROR_MALLOC_FAILED;
         return;} 
     if(slen != FrRead(iFile,(char *)  *value, slen)) 
        {FrError(3,"FrReadSChar","error reading string");
         iFile->error = FR_ERROR_READ_ERROR;
         return;}}

 return;}

/*-------------------------------------------------------FrReadShort---*/
void FrReadShort(struct FrFile *iFile,
                 short *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf, local[2];
 
 if(iFile->error != FR_OK) {return;}
 
 if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *)  value, FrSshort);}
 else 
       {i = FrRead(iFile,(char *) local, FrSshort);
        buf = (unsigned char *) value;
        buf[0] = local[1];
        buf[1] = local[0];}

 if(i == 0) 
    {FrError(3,"FrReadShort","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

 return;}

/*-------------------------------------------------------FrReadShortU--*/
void FrReadShortU(struct FrFile *iFile,
                  unsigned short *value)
/*--------------------------------------------------------------------*/
{int i;
 unsigned char *buf, local[2];
 
 if(iFile->error != FR_OK) {return;}
 
 if(iFile->fmType == FRNATIVE)
       {i = FrRead(iFile,(char *)  value, FrSshort);}
 else 
       {i = FrRead(iFile,(char *) local, FrSshort);
        buf = (unsigned char *) value;
        buf[0] = local[1];
        buf[1] = local[0];}

 if(i == 0) 
    {FrError(3,"FrReadShortU","end of file");
     iFile->error = FR_ERROR_READ_ERROR;} 

 return;}

/*-------------------------------------------------------FrReadStruct-*/
void FrReadStruct(struct FrFile *iFile,
                  void *address)
/*--------------------------------------------------------------------*/
{unsigned short type, instance;

  if(iFile->error != FR_OK) {return;}
 
  FrReadShortU(iFile, &type); 
  FrReadShortU(iFile, &instance);

                           /* this is for backward compatibility (3.10)*/  
  if(type > 3000) {type = 0;} 

  if(iFile->error != FR_OK) {return;}
  FrSetBRT(iFile, instance, type, address); 

  return;}
  
/*---------------------------------------------------------FrReadVC --*/
void FrReadVC(struct FrFile *iFile,
              char **data, 
              unsigned int nData)                
/*--------------------------------------------------------------------*/
{unsigned int nread;
 char *buf;
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (char *) malloc(nData*sizeof(char));
 *data = buf;
 if(buf == NULL) 
        {FrError(3,"FrReadVC","malloc failed");
         iFile->error = FR_ERROR_MALLOC_FAILED;
         return;} 
 
 nread = FrRead(iFile,(char *) buf, nData);
 if(nread != nData)
        {FrError(3,"FrReadVC","error reading bank");
         iFile->error = FR_ERROR_READ_ERROR;}
          
 return;}
 
/*---------------------------------------------------------FrReadVD --*/
void FrReadVD(struct FrFile *iFile,
              double **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{long i,nread;
 double *buf;
 unsigned char *swap,local[4];

 if(iFile->error != FR_OK) {return;}
 
 buf = (double *) malloc(nData*sizeof(double));
 *data = buf;
 if(buf == NULL) 
      {FrError(3,"FrReadVD","malloc failed");
       iFile->error = FR_ERROR_MALLOC_FAILED;
       return;} 
 
 nread = FrRead(iFile,(char *) buf, sizeof(double)*nData);
 if(nread != nData*sizeof(double))
      {FrError(3,"FrReadVD","error reading bank");
       iFile->error = FR_ERROR_READ_ERROR;
       return;} 
   
 if(iFile->fmType != FRNATIVE)
      {swap = (unsigned char *) buf;
       for(i=0; i<nData; i++)
          {local[0] = swap[7];
           local[1] = swap[6];
           local[2] = swap[5];
           local[3] = swap[4];
           swap[7]  = swap[0];
           swap[6]  = swap[1];
           swap[5]  = swap[2];
           swap[4]  = swap[3];
           swap[3]  = local[3];
           swap[2]  = local[2];
           swap[1]  = local[1];
           swap[0]  = local[0];
           swap = swap + 8;}}

 return;}

/*---------------------------------------------------------FrReadVF --*/
void FrReadVF(struct FrFile *iFile,
              float **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{long i,nread;
 float *buf;
 unsigned char *swap,local[2];
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (float *) malloc(nData*sizeof(float));
 *data = buf;
 if(buf == NULL) 
      {FrError(3,"FrReadVF","malloc failed");
       iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}               
 
 nread = FrRead(iFile,(char *) buf, sizeof(float)*nData);
 if(nread != sizeof(float)*nData)
      {FrError(3,"FrReadVF","error reading bank");
       iFile->error = FR_ERROR_READ_ERROR;
       return;}               

 if(iFile->fmType != FRNATIVE)
      {swap = (unsigned char *) buf;
       for(i=0; i<nData; i++)
          {local[0] = swap[3];
           local[1] = swap[2];
           swap[3]  = swap[0];
           swap[2]  = swap[1];
           swap[1]  = local[1];
           swap[0]  = local[0];
           swap = swap + 4;}}
        
 return;}
 
/*---------------------------------------------------------FrReadVI --*/
void FrReadVI(struct FrFile *iFile,
              int **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{long i,nread;
 int *buf;
 unsigned char *swap,local;
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (int *) malloc(nData*sizeof(int));
 *data = buf;
 if(buf == NULL) 
        {FrError(3,"FrReadVI","malloc failed");
         iFile->error = FR_ERROR_MALLOC_FAILED;
         return;}               
 
 nread = FrRead(iFile,(char *) buf, sizeof(int)*nData);
 if(nread != sizeof(int)*nData)
       {FrError(3,"FrReadVI","error reading bank");
        iFile->error = FR_ERROR_READ_ERROR;
        return;}               
 
 if(iFile->fmType != FRNATIVE)
      {swap = (unsigned char *) buf;
       for(i=0; i<nData; i++)
          {local   = swap[3];
           swap[3] = swap[0];
           swap[0] = local;
           local   = swap[2];
           swap[2] = swap[1];
           swap[1] = local;
           swap = swap + 4;}}
           
 return;}

/*---------------------------------------------------------FrReadVL --*/
void FrReadVL(struct FrFile *iFile,
              long **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{long i,nread,nBytes;
 long *buf;
 unsigned char *swap,*local;
 
 if(iFile->error != FR_OK) {return;}
 
 nBytes = nData * iFile->header[9];  
 buf = (long *) malloc(nBytes);
 if(buf == NULL) {FrError(3,"FrReadVL","malloc failed");
                  iFile->error = FR_ERROR_MALLOC_FAILED;
                  return;}             

 nread = FrRead(iFile,(char *) buf, nBytes);
 if(nread != nBytes)
              {FrError(3,"FrReadVL","error reading bank");
               iFile->error = FR_ERROR_READ_ERROR;
               return;}
  
 if(iFile->fmLong == FRNATIVE)
    {*data = buf;
     return;}

   /*------ special cases -----------*/

 local = (unsigned char *) buf;
 swap  = (unsigned char *) malloc(nData*sizeof(long));
 if(swap == NULL) {FrError(3,"FrReadVL","malloc failed");
                  iFile->error = FR_ERROR_MALLOC_FAILED;
                  return;}             
 *data = (long *) swap;

 if((iFile->fmLong == FRSWAP) && (FrSlong == 8))
   {for(i=0; i<nData; i++)
          {swap[7+i*8]  = local[  i*8];
           swap[6+i*8]  = local[1+i*8];
           swap[5+i*8]  = local[2+i*8];
           swap[4+i*8]  = local[3+i*8];
           swap[3+i*8]  = local[4+i*8];
           swap[2+i*8]  = local[5+i*8];
           swap[1+i*8]  = local[6+i*8];
           swap[  i*8]  = local[7+i*8];}}
 else if((iFile->fmLong == FRSWAP) && (FrSlong == 4))
   {for(i=0; i<nData; i++)
          {swap[3+i*4]  = local[  i*4];
           swap[2+i*4]  = local[1+i*4];
           swap[1+i*4]  = local[2+i*4];
           swap[  i*4]  = local[3+i*4];}}
 else if(iFile->fmLong == FREXPAND)
    {for(i=0; i<nData; i++)
          {swap[7+i*8]  = 0;
           swap[6+i*8]  = 0;
           swap[5+i*8]  = 0;
           swap[4+i*8]  = 0;
           swap[3+i*8]  = local[3+i*4];
           swap[2+i*8]  = local[2+i*4];
           swap[1+i*8]  = local[1+i*4];
           swap[  i*8]  = local[  i*4];}}
 else if(iFile->fmLong == FREXPAND_AND_SWAP)
    {for(i=0; i<nData; i++)
          {swap[7+i*8]  = 0;
           swap[6+i*8]  = 0;
           swap[5+i*8]  = 0;
           swap[4+i*8]  = 0;
           swap[3+i*8]  = local[  i*4];
           swap[2+i*8]  = local[1+i*4];
           swap[1+i*8]  = local[2+i*4];
           swap[  i*8]  = local[3+i*4];}}
 else if(iFile->fmLong == FRCONTRACT)
    {for(i=0; i<nData; i++)
          {swap[  i*4]  = local[  i*8];
           swap[1+i*4]  = local[1+i*8];
           swap[2+i*4]  = local[2+i*8];
           swap[3+i*4]  = local[3+i*8];}}
 else if(iFile->fmLong == FRCONTRACT_AND_SWAP)
    {for(i=0; i<nData; i++)
          {swap[  i*4]  = local[3+i*8];
           swap[1+i*4]  = local[2+i*8];
           swap[2+i*4]  = local[1+i*8];
           swap[3+i*4]  = local[0+i*8];}}
 
 free(local);

 return;}

/*---------------------------------------------------------FrReadVQ --*/
void FrReadVQ(struct FrFile *iFile, 
              char  ***data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{long i;
 char **buf;
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (char **) malloc(nData*sizeof(char *));
 *data = buf; 
 if(buf == NULL) 
        {FrError(3,"FrReadVQ","malloc failed");
         iFile->error = FR_ERROR_MALLOC_FAILED;
          return;}               
  
 for(i=0; i<nData; i++)
        {FrReadSChar(iFile, &buf[i]);}

 return;}

/*---------------------------------------------------------FrReadVS --*/
void FrReadVS(struct FrFile *iFile,
              short **data,
              unsigned int nData)
/*--------------------------------------------------------------------*/
{long i,nread;
 short *buf;
 unsigned char *swap,local;
 
 if(iFile->error != FR_OK) {return;}
 
 buf = (short *) malloc(nData*sizeof(short));
 *data = buf;
 if(buf == NULL) 
     {FrError(3,"FrReadVS","malloc failed");
      iFile->error = FR_ERROR_MALLOC_FAILED;
      return;}               

 nread = FrRead(iFile,(char *) buf, sizeof(short)*nData);
 if(nread != sizeof(short)*nData)
     {FrError(3,"FrReadVS","error reading bank");
      iFile->error = FR_ERROR_READ_ERROR;
      return;}               
 
 if(iFile->fmType != FRNATIVE)
     {swap = (unsigned char *) buf;
      for(i=0; i<nData; i++)
          {local   = swap[1];
           swap[1] = swap[0];
           swap[0] = local;
           swap = swap + 2;}}
           
 return;}

/*------------------------------------------------- FrProcDataDef ----*/
struct FrSH *FrProcDataDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrProcData",FrProcDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "REAL_8", "sampleRate","-");
  FrSENew(classe, "INT_4U","timeOffsetS","-");
  FrSENew(classe, "INT_4U","timeOffsetN","-");
  FrSENew(classe, "REAL_8","fShift","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "data","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "aux","-");
  FrSENew(classe, "PTR_STRUCT(FrProcData *)", "next","-");

  return(classe);}

/*---------------------------------------------- FrProcDataFind ------*/
struct FrProcData *FrProcDataFind(struct FrameH *frameH,
                                  char *name)
/*--------------------------------------------------------------------*/
/* Return a pointer to the procData structure or NULL if not found */

{struct FrProcData *proc;

 if(frameH == NULL)              return (NULL);
 if(frameH->procData == NULL)    return (NULL);

 proc = frameH->procData;
 while(proc != NULL)
    {if(strcmp(proc->name, name) == 0) return(proc);
     proc = proc->next;}
  
 return (NULL);}


/*-------------------------------------------------FrProcDataFree-----*/
void FrProcDataFree(struct FrProcData *procData)
/*--------------------------------------------------------------------*/
{
 if(procData->next != NULL) FrProcDataFree(procData->next);

 if(procData->name    != NULL) free(procData->name);
 if(procData->comment != NULL) free(procData->comment);
 if(procData->data    != NULL) FrVectFree(procData->data);
 if(procData->aux     != NULL) FrVectFree(procData->aux);
 
 free(procData);

 return;}

/*------------------------------------------------FrProcDataNew ------*/
struct FrProcData *FrProcDataNew(struct FrameH *frame,  
                                 char *name, 
                                 double sampleRate, 
                                 long nData, 
                                 long nBits)
/*--------------------------------------------------------------------*/
{struct FrProcData *procData;
 double dx;
 long type;
 
 procData = (struct FrProcData *) calloc(1,sizeof(struct FrProcData));
 if(procData == NULL) 
      {return(NULL);} 
 else {procData->classe = FrProcDataDef();}
	 
 if(FrStrCpy(&procData->name,name) == NULL) return(NULL);

 procData->sampleRate = sampleRate;
 
 if(nBits >16)       {type = FR_VECT_4S;}
 else if(nBits >  8) {type = FR_VECT_2S;}
 else if(nBits >  0) {type = FR_VECT_C;}
 else if(nBits >-33) {type = FR_VECT_4R;}
 else                {type = FR_VECT_8R;}

 if(sampleRate == 0.)
      {dx = 0.;}
 else {dx = 1./sampleRate;}

 procData->data = FrVectNew1D(name, type, nData, dx,"time (s)",NULL);
 if(procData->data == NULL) return(NULL);
  
     /*----- now store it in the Frame structures -----*/

 if(frame != NULL) 
    {procData->next = frame->procData;
     frame->procData = procData;}
  
 return(procData);}
  
/*------------------------------------------------- FrProcDataRead---*/
void FrProcDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrProcData *procData;

  procData = (struct FrProcData *) calloc(1,sizeof(struct FrProcData));
  if(procData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {procData->classe = FrProcDataDef();}
  
  FrReadHeader(iFile,  procData);
  FrReadSChar( iFile, &procData->name);
  FrReadSChar( iFile, &procData->comment);
  FrReadDouble(iFile, &procData->sampleRate);
  FrReadIntU  (iFile, &procData->timeOffsetS);
  FrReadIntU  (iFile, &procData->timeOffsetN);
  FrReadDouble(iFile, &procData->fShift);
  FrReadStruct(iFile, &procData->data);
  FrReadStruct(iFile, &procData->aux);
  FrReadStruct(iFile, &procData->next);

  return;}
/*------------------------------------------------ FrProcDataWrite---*/
void FrProcDataWrite(struct FrProcData *procData,
                     struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
	 /* first write procData struct */
 
  FrPutNewRecord(oFile, procData);
  FrPutSChar (oFile, procData->name);
  FrPutSChar (oFile, procData->comment);
  FrPutDouble(oFile, procData->sampleRate);
  FrPutIntU  (oFile, procData->timeOffsetS);
  FrPutIntU  (oFile, procData->timeOffsetN);
  FrPutDouble(oFile, procData->fShift);
  FrPutStruct(oFile, procData->data);
  FrPutStruct(oFile, procData->aux);
  FrPutStruct(oFile, procData->next);
  FrPutWriteRecord(oFile);

           /* data write buffer */

  FrVectWrite (procData->data, oFile);

  if(procData->aux != NULL) {FrVectWrite (procData->aux, oFile);}
     
           /* write next struct. if any */

  if(procData->next != NULL)  {FrProcDataWrite(procData->next, oFile);}  

 return;}


/*------------------------------------------------------- FrSEDef ----*/
struct FrSH *FrSEDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSE",FrSERead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "type","-");
  FrSENew(classe, "STRING", "comment","-");

  return(classe);}

/*---------------------------------------------------------- FrSENew-*/
void FrSENew(struct FrSH *structH,
             char *type,
             char  *name,
             char  *comment)
/*--------------------------------------------------------------------*/
{struct FrSE *structE, *last;
 int nTypes = 19, i;
 static char *dataTypes[] = 
   {"UNKNOWN","CHAR","CHAR_U","INT_2S","INT_2U",
    "INT_4S","INT_4U","INT_8S","INT_8U","REAL_4","REAL_8",
    "STRING","PTR_STRUCT","COMPLEX_8","COMPLEX_16",
    "*","INT_4U *","REAL_8 *","STRING *"};

  /*----- check the type validity ---------*/

  if(type == NULL) type = dataTypes[0];

  for(i=0; i<nTypes; i++)
    {if(strcmp(type,dataTypes[i]) == 0) break;}
  if(strncmp(type,"PTR_STRUCT",10) == 0) i=13;
  if(i == nTypes)
    {sprintf(FrBuf,"For %s.%s unknown type:%s\n",
                   structH->name,name,type);
     FrError(2,"FrSENew",FrBuf);}

  /*----- fill structure --------*/

  structE = (struct FrSE *) calloc(1,sizeof(struct FrSE));
  if(structE == NULL) 
       {return;}
  else {structE->classe = FrSEDef();}

  if(FrStrCpy(&structE->type    ,type)    == NULL) return;
  if(FrStrCpy(&structE->name    ,name)    == NULL) return;
  if(comment == NULL)
    {structE->comment = NULL;}
  else
    {if(FrStrCpy(&structE->comment ,comment) == NULL) return;}

  structE->next    = NULL;
  
  if(structH->firstE == NULL)
    {structH->firstE = structE;}
  else
   {last = structH->firstE;
    while( last->next != NULL ) {last = last->next;}
    last->next = structE;}

  structH->nSE++;

  return;}

/*-------------------------------------------------------- FrSERead---*/
void FrSERead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSE *se, *last;
 short id;

  se = (struct FrSE *) calloc(1,sizeof(struct FrSE));
  if(se == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {se->classe = FrSEDef();}

  FrReadShort(iFile, &id);
  FrReadSChar(iFile, &se->name); 
  FrReadSChar(iFile, &se->type);
  FrReadSChar(iFile, &se->comment);

                     /*--- in the case of file mark, do not use SH ---*/

  if(iFile->curSH == NULL) return;

                       /*-------- store the SH structure -------------*/

  if(iFile->curSH->firstE == NULL) 
       {iFile->curSH->firstE = se;}
  else {last = iFile->curSH->firstE;
        while(last->next != NULL) {last = last->next;}
        last->next = se;}

  iFile->curSH->nSE++;

return;}
 
/*-------------------------------------------------------- FrSEWrite---*/
void FrSEWrite(struct FrSE *structE,
               struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{

 FrPutNewRecord(oFile, structE);
 FrPutSChar(oFile,structE->name);
 FrPutSChar(oFile,structE->type);
 FrPutSChar(oFile,structE->comment);
 FrPutWriteRecord(oFile);

 return;} 

/*------------------------------------------------------- FrSetAddMap---*/
struct FrMap *FrSetAddMap(struct FrSH *sh,
                          unsigned short id)
/*--------------------------------------------------------------------*/
{ struct FrMap *map;
 
  map = (struct FrMap*)malloc(sizeof(struct FrMap));
  if(map == NULL) 
       {FrError(3,"FrSetMapAdd","malloc failled");
        return(NULL);}
  map->nref = 0;
  map->baddress = NULL;
	 
  if(sh->maxMap == 0)
      {sh->maxMap = 20;
       sh->map = malloc(sh->maxMap * sizeof(struct FrMap*));
       if(sh->map == NULL) 
          {FrError(3,"FrSetMapAdd","malloc failled");
           return(NULL);}}
 
  if(id >= sh->maxMap)
      {sh->maxMap = 20 + sh->maxMap;
       if(sh->maxMap > id+1) {sh->maxMap = id+1;}
       sh->map = realloc(sh->map,sh->maxMap * sizeof(struct FrMap*));
       if(sh->map == NULL) 
          {FrError(3,"FrSetMapAdd","malloc failled");
           return(NULL);}}
       
  sh->map[id] = map;
  sh->nMap++;

  return(map);}

/*------------------------------------------------------ FrSetAll ----*/
void FrSetAll(struct FrFile *file)           /* set all banks address */
/*--------------------------------------------------------------------*/
{int i,j,k;
 void **reference;
  struct FrSH *sh;
 
  if(FrDebugLvl > 0)
     fprintf(FrFOut,"FrSetAll: Start address relocation <<<<");

  for(j=0; j<file->maxSH; j++)
     {sh = file->sh[j];
      if(sh == NULL) continue;
  
      if(FrDebugLvl > 2) fprintf(FrFOut," Class:%-20s  id=%d number "
                       "of instances: %ld\n",sh->name,sh->id,sh->nMap);

      for(i=0; i<sh->nMap; i++)
        
         {if(sh->map[i] == NULL) continue;
    
          if(FrDebugLvl > 2) 
              {fprintf(FrFOut,"   addr:%12p nref=%2d",
                      sh->map[i]->baddress, sh->map[i]->nref);
               if(sh->map[i]->nref > 0) 
                   {fprintf(FrFOut," ref:");}
               for(k=0; k<sh->map[i]->nref; k++)
                   {fprintf(FrFOut,"%d %p",k,sh->map[i]->bref[k]);}
               fprintf(FrFOut,"\n");}
	 
          if(sh->map[i]->baddress == NULL && FrDebugLvl > 0)
             {fprintf(FrFOut," Warning: FrSetAll: struct #%d not"
                     " created for class %s with %d references\n",
                       i,sh->name,sh->map[i]->nref);}

          if(sh->map[i]->nref == 0)
             {if(FrDebugLvl > 2) fprintf(FrFOut, " Warning: FrSetAll: "
               "struct #%d not referenced for class %s\n",i,sh->name);}

          for(k=0; k<sh->map[i]->nref; k++)	
             {reference  = sh->map[i]->bref[k];
              *reference = sh->map[i]->baddress;}
            
	 }
     }

  return;}
 
/*---------------------------------------------------- FrSetBAT ------*/
void FrSetBAT(struct FrFile *file, 
              unsigned short instance,
              void *address)              /* store address for a bank */
/*--------------------------------------------------------------------*/
{struct FrMap *map;
 struct FrSH *sh;
 unsigned short type;
                                    /*------ if using mark ---------*/
 if(file->relocation == FR_NO)
   {file->address = address;
    return;}

      /*----------- first find FrSH structure ---------*/
 	  
  type = file->type;

  if(type >= file->maxSH) 
      {FrError(3,"FrSetBAT","maxSH too small");
       return;}
           
  sh = file->sh[type];
  if(sh == NULL)
      {FrError(3,"FrSetBAT","class not found (missing dictionnary)");
       return;}
       
      /*------ struct is not already in Frmap, save it -----*/
 	 
  if(instance < sh->nMap)
       {map = sh->map[instance];}
  else {map = FrSetAddMap(sh, instance);}
  if(map == NULL) 	 
          {FrError(3,"FrSetBAT","map not found");
           file->error = FR_ERROR_FRSET;
           return;}

      /*------ save data -----*/
 
  if(map->baddress != NULL) 
          {FrError(3,"FrSetBAT","bank already registered");
           file->error = FR_ERROR_FRSET;
           return;}
  map->baddress = address;
 
  return;}

/*------------------------------------------------------ FrSetBRT ----*/
void FrSetBRT(struct FrFile *file,
              unsigned short instance,
              unsigned short type, 
              void *address)                  /* store bank reference */
/*--------------------------------------------------------------------*/
{void **reference;
 struct FrMap *map;
 struct FrSH *sh;

 if(file->relocation == FR_NO)  return;

 if(FrDebugLvl > 2) {fprintf(FrFOut," FrSetBRT: instance=%d type=%d\n",
        instance, type);}
 
 if(type == 0) 
    {reference = address;
     *reference = NULL;
     return;}
 
      /*-------------  find FrSH structure ---------*/
 	 
  if(type >= file->maxSH) 
      {FrFileIncSH(file,type);
       if(file->error != FR_OK) return;}
     
  sh = file->sh[type];
  if(sh == NULL)
       {sh = FrSHNew(NULL,NULL);
        if(sh == NULL) 
             {FrError(3,"FrSetBRT","malloc failed");
              file->error = FR_ERROR_MALLOC_FAILED;
              return;}
        file->sh[type] = sh;
        sh->id = type;}
       
      /*---------------- find the FrMap structure. 
         The procedure is simpler because we are sure that the 
        instance will always been increasing ----------------*/
	  
 if(instance >= sh->nMap)
     {map = FrSetAddMap(sh, instance);}
 else{map = sh->map[instance];}
 if(map == NULL) 
     {file->error = FR_ERROR_FRSET;
      return;}
		
       /*----- store bank address ------*/
    
  map->bref[map->nref] = address;
  map->nref++;
  if(map->nref >= FRMAPMAXREF) 
     {FrError(3,"FrSetBRT","max ref reached, Increase FRMAPMAXREF "
                     "and recompile the Frame Librairy");
      file->error = FR_ERROR_FRSET;
      return;}

  return;}

/*------------------------------------------------------ FrSetIni ----*/
void FrSetIni(struct FrFile *file)  
                               /* init the address relocation package */
/*--------------------------------------------------------------------*/
{long i,j;
 struct FrSH *sh;

 for(j=0; j<file->maxSH; j++)
    {sh = file->sh[j];
     if(sh == NULL) continue;
     
     for(i=0; i<sh->nMap; i++)
       {if(sh->map[i] == NULL) continue;
        sh->map[i]->nref = 0;
        sh->map[i]->baddress = NULL;
        free(sh->map[i]); 
        sh->map[i] = NULL;}
     sh->nMap = 0;}
 
 return;}

/*------------------------------------------------------- FrSHDef ----*/
struct FrSH *FrSHDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSH",FrSHRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_2U", "classe","-");
  FrSENew(classe, "STRING", "comment","-");

  return(classe);}

/*------------------------------------------------------- FrSHMatch---*/
void FrSHMatch(struct FrFile *iFile,
               unsigned short id)
/*--------------------------------------------------------------------*/
{struct FrSH *sh, *shRef;
 struct FrSE *se, *seRef;
 int i;
           
 sh = iFile->sh[id]; 
 if(sh == NULL) return;        
                
         /*------ search the reference shRef -----*/
 
 shRef = NULL; 
 for(i=0; i<FrnSH; i++)
   {shRef = FrSH[i];
    if(shRef->name == NULL) continue;
    if(strcmp(sh->name,shRef->name) == 0) {break;}}
 if(i == FrnSH) {shRef = NULL;}
            
 if(shRef == NULL)
      {sh->objRead = NULL;
       if(FrDebugLvl > 0) fprintf(FrFOut,
           "FrSHMatch: unknown bank:%s id=%d\n",sh->name,id);
       return;}
       
 sh->objRead = shRef->objRead;
 
        /*------ check for the data type ------*/

 if(iFile->fmtVersion < 3) return; /*--there are too many differences
                                       for old versions----------------*/
 if(sh->nSE != shRef->nSE)
      {/*FrError(3,"FrSHMatch","the number of element has changed");*/
       if(FrDebugLvl > 1) fprintf(FrFOut,
             "FrSHMatch: the number of element has changed" 
             " for structure:%s (id=%d) (%ld %ld)\n",
                sh->name,id,sh->nSE,shRef->nSE);
      
       /*-- backward compatibility for frameH (before version 3.30)*/

       if(strcmp(sh->name,"FrameH") == 0)
           {if(sh->nSE == 19) 
              {if(FrDebugLvl > 0) fprintf(FrFOut,
                     "We will read FrameH without ULeapS\n");
	       sh->objRead = FrBack3FrameHRead;
               return;}}

       /*-- backward compatibility for FrStatData (before v3.40)*/

       if(strcmp(sh->name,"FrStatData") == 0)
           {if(sh->nSE == 6) 
              {if(FrDebugLvl > 0) fprintf(FrFOut,
                  "We will read FrStatData without detector\n");
	       sh->objRead = FrBack3FrStatDataRead;
               return;}}
       }
       
 se    = sh->firstE;
 seRef = shRef->firstE;
 while(se != NULL && seRef != NULL)
    {if(strcmp(se->name,seRef->name) != 0) 
        {/*FrError(3,"FrSHMatch","the element name has changed");*/
         if(FrDebugLvl > 1) fprintf(FrFOut,
             "FrSHMatch: the element name has changed" 
             " for structure:%s (id=%d) (%s %s)\n",
                  sh->name,id,se->name,seRef->name);}
     se    = se->next;
     seRef = seRef->next;}
              
 return;}

/*------------------------------------------------------- FrSHNew-----*/
struct FrSH *FrSHNew(char *name,
                     char *comment)
/*--------------------------------------------------------------------*/
{struct FrSH *sh;
 static int id = 1;

  sh = (struct FrSH *) calloc(1,sizeof(struct FrSH));
  if(sh == NULL)   {return(NULL);}

  if(name == NULL)                  {sh->classe = FrSHDef();}
  else if(strcmp(name,"FrSH") == 0) {sh->classe = sh;}
  else                              {sh->classe = FrSHDef();}

  if(name != NULL) 
    {if(FrStrCpy(&sh->name, name)       == NULL) return(NULL);}
  if(comment != NULL)
    {if(FrStrCpy(&sh->comment, comment) == NULL) return(NULL);}

  sh->objRead = NULL;
  sh->objDump = NULL;
  sh->objCopy = NULL;

  sh->nMap  = 0;
  sh->nAdd  = 0;
  sh->firstE = NULL;
  sh->id = id;
  id++;
  
  return(sh);}

/*-------------------------------------------------------- FrSHRead---*/
void FrSHRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSH *sh, *shDup;
 short id0;
 unsigned short id,i;
 char *name, *comment;

 if(iFile->error != FR_OK) return;

 FrReadShort(iFile, &id0);
 FrReadSChar (iFile, &name); 
 FrReadShortU(iFile, &id); 
 FrReadSChar (iFile, &comment); 

                /*----- skeep the structure if using file marks ----*/
 
 if(iFile->mark != NULL)
   {if(name    != NULL) free(name);
    if(comment != NULL) free(comment);
    return;}
                          /*--- check for existing sh structure ----*/
       
 for(i=0; i<iFile->maxSH; i++)
    {shDup = iFile->sh[i];
     if(shDup == NULL)       continue;
     if(shDup->name == NULL) continue;
     if(strcmp(name,shDup->name) == 0) 
       {FrError(3,"FrSHRead","Duplicate FrSH. Data may be corrupted");
        return;}}
                                 /*---- add it in the list --------*/
 if(id >= iFile->maxSH) 
      {FrFileIncSH(iFile, id);
       if(iFile->error != FR_OK) return;}

 sh = iFile->sh[id];
 if(sh == NULL)
   {sh = FrSHNew(name,comment);
    sh->id = id;
    iFile->sh[id] = sh;
    if(name    != NULL) free(name);
    if(comment != NULL) free(comment);}
 else
   {sh->name = name;
    sh->comment = comment;}

 iFile->curSH = sh;

 return;}
 
/*-------------------------------------------------------- FrSHWrite---*/
void FrSHWrite(struct FrSH *structH,
               struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{struct FrSE *structE;

 FrPutNewRecord(oFile, structH);
 FrPutSChar    (oFile, structH->name);
 FrPutShortU   (oFile, structH->id);
 FrPutSChar    (oFile, structH->comment);
 FrFileMarkSH  (oFile, structH->name, structH->id);
 FrPutWriteRecord(oFile);

     /*--- write FrSE structure ------*/
	 
 structE = structH->firstE;
 while(structE != NULL )
       {FrSEWrite(structE, oFile);
        structE = structE->next;}
		 
 return;}

/*-------------------------------------------------- FrSimDataDef ----*/
struct FrSH *FrSimDataDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSimData",FrSimDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "REAL_4", "sampleRate","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "data","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "input","-");
  FrSENew(classe, "PTR_STRUCT(FrSimData *)", "next","-");

  return(classe);}

/*--------------------------------------------- FrSimDataFind---------*/
struct FrSimData *FrSimDataFind(struct FrameH *frameH,
                                char *simName)
/*--------------------------------------------------------------------*/
/* Return a pointer to the simData structure or NULL if not found */

{struct FrSimData *sim;

 if(frameH == NULL)             return (NULL);
 if(frameH->simData == NULL)    return (NULL);

 sim = frameH->simData;
 while(sim != NULL)
    {if(strcmp(sim->name, simName) == 0) return(sim);
     sim = sim->next;}
  
 return (NULL);}


/*--------------------------------------------------FrSimDataFree-----*/
void FrSimDataFree(struct FrSimData *simData)
/*--------------------------------------------------------------------*/
{

 if(simData->next  != NULL) FrSimDataFree(simData->next);
 if(simData->data  != NULL) FrVectFree (simData->data);
 if(simData->name  != NULL) free (simData->name);
 
 if(simData->input != NULL) {FrVectFree(simData->input);}
 
 free(simData);

 return;}

/*-------------------------------------------------FrSimDataNew ------*/
struct FrSimData *FrSimDataNew(struct FrameH *frame,
                               char *name,
                               double sampleRate,
                               long nData,
                               long nBits)
/*--------------------------------------------------------------------*/
{struct FrSimData *simData;
 double dx;
 long type;
 
  simData = (struct FrSimData *) calloc(1,sizeof(struct FrSimData));
  if(simData == NULL) 
       {return(NULL);} 
  else {simData->classe = FrSimDataDef();}
	 
  if(FrStrCpy(&simData->name, name) == NULL) return(NULL); 
	   
  simData->sampleRate = sampleRate;

  if(nBits >16)       {type = FR_VECT_4S;}
  else if(nBits >  8) {type = FR_VECT_2S;}
  else if(nBits >  0) {type = FR_VECT_C;}
  else if(nBits >-33) {type = FR_VECT_4R;}
  else                {type = FR_VECT_8R;}

  if(sampleRate == 0.)
       {dx = 0.;}
  else {dx = 1./sampleRate;}

  simData->data = FrVectNew1D(name,type,nData,dx,"time (s)",NULL);
  if(simData->data == NULL)
       {FrError(3,"FrSimDataNew","cannot create vector");
        return(NULL);}

 free(simData->data->name);
 if(FrStrCpy(&simData->data->name,name) == NULL) return(NULL);
 
    /*----- now store it in the Frame structures -----*/

 
  if(frame == NULL) 
       {FrError(2,"FrSimDataNew","No frame struct");}
  else
       {simData->next = frame->simData;
        frame->simData = simData;}

  return(simData);} 

/*--------------------------------------------------- FrSimDataRead---*/
void FrSimDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSimData *simData;

  simData = (struct FrSimData *) calloc(1,sizeof(struct FrSimData));
  if(simData == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {simData->classe = FrSimDataDef();}
  
  FrReadHeader(iFile,  simData);
  FrReadSChar( iFile, &simData->name);
  FrReadSChar (iFile, &simData->comment);
  FrReadFloat (iFile, &simData->sampleRate);
  FrReadStruct(iFile, &simData->data);
  FrReadStruct(iFile, &simData->input);
  FrReadStruct(iFile, &simData->next);
    
return;}

/*------------------------------------------------- FrSimDataWrite---*/
void FrSimDataWrite(struct FrSimData *simData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
 
  FrPutNewRecord(oFile, simData);
  FrPutSChar (oFile, simData->name);
  FrPutSChar (oFile, simData->comment);
  FrPutFloat (oFile, simData->sampleRate);
  FrPutStruct(oFile, simData->data);
  FrPutStruct(oFile, simData->input);
  FrPutStruct(oFile, simData->next);
  FrPutWriteRecord(oFile);

           /* data write buffer */

  FrVectWrite(simData->data, oFile);
     
  if(simData->input != NULL){FrVectWrite(simData->input, oFile);}

  if(simData->next != NULL) {FrSimDataWrite(simData->next, oFile);}

 return;}

/*-------------------------------------------------- FrSerDataDef ----*/
struct FrSH *FrSerDataDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSerData",FrSerDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "INT_4U", "timeSec","-");
  FrSENew(classe, "INT_4U", "timeNsec","-");
  FrSENew(classe, "REAL_4", "sampleRate","-");
  FrSENew(classe, "STRING", "data","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "serial","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "more","-");
  FrSENew(classe, "PTR_STRUCT(FrSerData *)", "next","-");

  return(classe);}


/*--------------------------------------------------FrSerDataFree-----*/
void FrSerDataFree(struct FrSerData *serData)
/*--------------------------------------------------------------------*/
{
 if(serData->next   != NULL) FrSerDataFree(serData->next);

 if(serData->more   != NULL) FrVectFree(serData->more);
 if(serData->serial != NULL) FrVectFree(serData->serial);

 if(serData->name   != NULL) free(serData->name);
 if(serData->data   != NULL) free(serData->data);

 free(serData);

 return;}
/*------------------------------------------------- FrSerDataFind----*/
struct FrSerData *FrSerDataFind(struct FrameH *frameH,
                                char *smsName)
/*--------------------------------------------------------------------*/
{struct FrSerData *sms;

 if(frameH == NULL)             return (NULL);
 if(frameH->rawData == NULL)    return (NULL);
 if(smsName == NULL)            return (NULL);

 sms = frameH->rawData->firstSer;
 while(sms != NULL)
    {if(strcmp(sms->name, smsName) == 0) break;
     sms = sms->next;}

 return (sms);}
  
/*-------------------------------------------------- FrSerDataGet-----*/
long FrSerDataGet(struct FrameH *frameH,
                  char *smsName,
                  char  *smsParam,
                  double *value)
/*--------------------------------------------------------------------*/
/* this function return:
      -2 if the sms is not found
      -1 if the parameters is not found
       0 if everything is ok, the result is put in value */

{struct FrSerData *sms;
 char vName[50], vValue[50], vType[2], *pointer;
 int l;

 *value = 0;
 if(frameH == NULL)             return (-2);
 if(frameH->rawData == NULL)    return (-2);

 sms = frameH->rawData->firstSer;
 while(sms != NULL)
    {if(strcmp(sms->name, smsName) == 0) break;
     sms = sms->next;}
 
 if(sms == NULL) return(-2);
 
          /*-- here we have found the sms structure ---*/

  vName[0] = ' ';
  strcpy(&vName[1],smsParam);
  l = strlen(smsParam);
  vName[l+1] = ' ';
  vName[l+2] = '\0';
 
  pointer = strstr(sms->data, vName);
  if(pointer == NULL) return (-1);

  sscanf(pointer,"%s %c%s",vName, vType, vValue);
  sscanf(vValue,"%lf",value);

  return (0);}
  
/*----------------------------------------------------FrSerDataNew ---*/
struct FrSerData *FrSerDataNew(struct FrameH *frame,
                               char *smsName,
                               unsigned int serTime,
                               char *data)
/*--------------------------------------------------------------------*/
{struct FrSerData *smsData;

  smsData = (struct FrSerData *) calloc(1,sizeof(struct FrSerData));
  if(smsData == NULL) 
       {return(NULL);}
  else {smsData->classe = FrSerDataDef();}
	 
  if(FrStrCpy(&smsData->name, smsName) == NULL) return(NULL);
  if(FrStrCpy(&smsData->data, data)    == NULL) return(NULL);

  smsData->timeSec    = serTime;
  smsData->timeNsec   = 0;
  smsData->sampleRate = 0.;
  smsData->more       = NULL;

  if(frame != NULL) 
      {if(frame->rawData == NULL) FrRawDataNew(frame);
       if(frame->rawData == NULL) {return(NULL);}
       smsData->next = frame->rawData->firstSer;
       frame->rawData->firstSer = smsData;}
	   
  return(smsData);}

/*--------------------------------------------------- FrSerDataRead---*/
void FrSerDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSerData *smsData;

  smsData = (struct FrSerData *) calloc(1,sizeof(struct FrSerData));
  if(smsData == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {smsData->classe = FrSerDataDef();}
  
  FrReadHeader(iFile,  smsData);
  FrReadSChar( iFile, &smsData->name);
  FrReadIntU  (iFile, &smsData->timeSec);
  FrReadIntU  (iFile, &smsData->timeNsec);
  FrReadFloat (iFile, &smsData->sampleRate);
  FrReadSChar (iFile, &smsData->data);
  FrReadStruct(iFile, &smsData->serial);
  FrReadStruct(iFile, &smsData->more);
  FrReadStruct(iFile, &smsData->next);
    
 return;} 

/*----------------------------------------------------FrSerDataUpd ------*/
void FrSerDataUpd(struct FrSerData *smsData,
                  unsigned int serTime,
                  char *data)
/*--------------------------------------------------------------------*/
{
  if(smsData == NULL) 
      {FrError(2,"FrSerDUpd","No sms struct");
       return;}
	   
  smsData->timeSec = serTime;

  free(smsData->data);

  FrStrCpy(&smsData->data, data);

  return;}

/*-------------------------------------------------- FrSerDataWrite---*/
void FrSerDataWrite(struct FrSerData *serData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
 
  FrPutNewRecord(oFile, serData);
  FrPutSChar (oFile, serData->name);
  FrPutIntU  (oFile, serData->timeSec);
  FrPutIntU  (oFile, serData->timeNsec);
  FrPutFloat (oFile, serData->sampleRate);
  FrPutSChar (oFile, serData->data);
  FrPutStruct(oFile, serData->serial);
  FrPutStruct(oFile, serData->more);
  FrPutStruct(oFile, serData->next);
  FrPutWriteRecord(oFile);
    
  if(serData->serial != NULL) FrVectWrite(serData->serial, oFile);
  if(serData->more   != NULL) FrVectWrite(serData->more,   oFile);

 return;} 

/*------------------------------------------------- FrStatDataAdd  ---*/
void FrStatDataAdd(struct FrDetector *detector,
                   struct FrStatData *sData)
/* There should be only one static data with a given name and 
   time boundaries in the program. 
   This function remove the existing static data structure.           */
/*--------------------------------------------------------------------*/
{struct FrStatData **current;
 	 
 if(detector  == NULL) 
     {FrStatDataFree(sData);
      return;}
      
 if(sData == NULL) {return;}
 sData->detector = detector;
 
 for(current = &detector->sData; *current != NULL; current = &((*current)->next))
   {if(strcmp((*current)->name, sData->name) != 0) continue;
    if((*current)->timeStart != sData->timeStart)  continue;
    if((*current)->timeEnd   != sData->timeEnd)    continue;
    if(sData->version > (*current)->version) 
          {sData->next = FrStatDataFree(*current);
           *current = sData;}
    else
          {FrStatDataFree(sData);}
    return;}

 sData->next = detector->sData;
 detector->sData = sData;

 return;}

/*------------------------------------------------- FrStatDataChkT ---*/
void FrStatDataChkT(struct FrStatData **root,
                    unsigned int timeStart,
                    unsigned int timeEnd)
/*--------------------------------------------------------------------*/
/* This function remove all static data which are not valid for 
   requested validity range (RVR). The rule is the following:
     -remove all data with a validy range not overlapping the RVR
     -keep all data with a validy range partially overlapping the RVR 
     -keep the latest (ie with the latest starting time) data 
      with a validy range fully overlapping the RVR
   Note that timeEnd == 0 means no upper bound limit.
-----------------------------------------------------------------------*/
{struct FrStatData **current, **name;
 unsigned int cts,cte;
 	 
  if(root == NULL) return;
     
    /*-- we first remove all data not in the validity range ----------*/
    /*-- and we flag all the data with full overlapp. ----------------*/

 for(current = root; *current != NULL;)
   {cts = (*current)->timeStart;
    cte = (*current)->timeEnd;
    if(cte == 0) cte = timeEnd; 

    /*-- we first remove all data not in the validity range ---*/

    if     (timeEnd   < cts) {*current = FrStatDataFree(*current);}
    else if(timeStart > cte) {*current = FrStatDataFree(*current);}

    /*-- then we flag all the data with full overlapp. --------*/

    else
      {if((timeStart > cts) && (timeEnd   < cte))
          {(*current)->overlap = 1;}
      else{(*current)->overlap = 0;}
      current = &(*current)->next;}}

      /* then we loop on all possible names ----*/
      
 for(name = root; *name != NULL; name = &(*name)->next)
   {if((*name)->overlap != 1) continue; 

      /*--- we search for the latest fully overlapping  ---*/

    for(current = &((*name)->next); 
        *current != NULL; 
        current = &(*current)->next)
      {if((*current)->overlap != 1)                      continue;
       if(strcmp((*current)->name, (*name)->name) != 0)  continue;
       if((*name)->timeStart < (*current)->timeStart) 
                {(*name)->overlap = 2;}
       else  {(*current)->overlap = 2;}}}

      /*--- now remove the tagged blocs ----*/

 for(current = root; *current != NULL;)
      {if((*current)->overlap == 2)
            {*current = FrStatDataFree(*current);}
       else  {current = &(*current)->next;}} 
 
 return;}

/*------------------------------------------------FrStatDataCopy------*/
struct FrStatData *FrStatDataCopy(struct FrStatData *sData)
/*--------------------------------------------------------------------*/
{struct FrStatData *copy;

  if(sData == NULL) return(NULL);

  copy = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
  if(copy == NULL)  
       {return(NULL);}
  else {copy->classe = FrStatDataDef();}

  memcpy(copy, sData, sizeof(struct FrStatData));

  if(FrStrCpy(&copy->name,    sData->name)    == NULL) return(NULL);
  if(FrStrCpy(&copy->comment, sData->comment) == NULL) return(NULL);

  if(sData->data != NULL)
       {FrVectCopy(sData->data);}
          
  return(copy);}

/*------------------------------------------------- FrStatDataFind ---*/
struct FrStatData *FrStatDataFind(struct FrDetector *detector,
                                  char *name, 
                                  unsigned int timeNow)
/*--------------------------------------------------------------------*/
{struct FrStatData *current, *latest;
 	 
 if(detector == NULL) return(NULL);
 
 latest = NULL;
 current = detector->sData;
 while(current != NULL)
   {if(strcmp(current->name, name) == 0)
     {if(timeNow == 0) {return(current);}
      if(current->timeStart <= timeNow)
         {if(latest == NULL) {latest = current;}
          if(latest->timeStart < current->timeStart) {latest = current;}}}

    current = current->next;}
 
 return(latest);} 

/*------------------------------------------------- FrStatDataDef ----*/
struct FrSH *FrStatDataDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrStatData",FrStatDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-"); 
  FrSENew(classe, "INT_4U", "timeStart","-"); 
  FrSENew(classe, "INT_4U", "timeEnd","-"); 
  FrSENew(classe, "INT_4U", "version","-"); 
  FrSENew(classe, "PTR_STRUCT(FrDetector *)", "detector","-"); 
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "data","-"); 

  return(classe);}

/*------------------------------------------------FrStatDataFree------*/
struct FrStatData *FrStatDataFree(struct FrStatData *sData)
/*--------------------------------------------------------------------*/
{struct FrStatData *next;

   if(sData == NULL) return(NULL);
   next = sData->next;

   if(sData->data != NULL)
       {if(sData->data->classe->objFree != NULL)
          {sData->data->classe->objFree(sData->data);}}
          
   if(sData->comment != NULL) {free(sData->comment);}
   if(sData->name    != NULL) {free(sData->name);}
   
   free(sData);

   return(next);}
/*------------------------------------------------FrStatDataNew-------*/
struct FrStatData *FrStatDataNew(char *name,
                                 char *comment,
                                 unsigned int tStart,
                                 unsigned int tEnd,
                                 unsigned int version,
                                 void *data)
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;

  sData = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
  if(sData == NULL)  
       {return(NULL);}
  else {sData->classe = FrStatDataDef();}

 if(FrStrCpy(&sData->name, name)       == NULL) return(NULL);
 if(FrStrCpy(&sData->comment, comment) == NULL) return(NULL);

 sData->timeStart = tStart;
 sData->timeEnd   = tEnd;
 sData->version   = version;
 sData->data      = data;

 sData->nFile = 0;
 sData->fileId = NULL;
 sData->maxFile = 0;
   
 return(sData);
 }
/*-------------------------------------------------- FrStatDataRead---*/
void FrStatDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;
 unsigned short id;
 
  sData = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
  if(sData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {sData->classe = FrStatDataDef();}

  if(iFile->relocation == FR_NO) {iFile->address = sData;}

  FrReadShortU(iFile, &id);  /*statData are not referenced by pointer*/
  FrReadSChar( iFile, &sData->name);
  FrReadSChar (iFile, &sData->comment); 
  FrReadIntU  (iFile, &sData->timeStart); 
  FrReadIntU  (iFile, &sData->timeEnd); 
  FrReadIntU  (iFile, &sData->version); 
  FrReadStruct(iFile, &sData->detector); 
  FrReadStruct(iFile, &sData->data); 

  sData->nFile = 0;
  sData->fileId = NULL;
  sData->maxFile = 0;

  sData->next = iFile->sDataCur;
  iFile->sDataCur = sData;

  return;}
 
/*------------------------------------------------- FrStatDataRemove-*/
void FrStatDataRemove(struct FrDetector *detector,
                      char *name) 
/*                                 remove all static data of one type */
/*--------------------------------------------------------------------*/
{struct FrStatData **current;

 if(detector == NULL) return;
 if(name == NULL) return;
  
    /*--- search for an existing structure -----*/

 current = &detector->sData;
 while(*current != NULL)
   {if(strcmp((*current)->name, name) == 0)
       {*current = FrStatDataFree(*current);}
    else
      {current = &(*current)->next;}}
 
 return;}

/*------------------------------------------------FrStatDataTouch-----*/
void FrStatDataTouch(struct FrStatData * sData)
/*--------------------------------------------------------------------*/
{
 sData->nFile = 0;
 sData->maxFile = 0;
   
 return;
 }

/*------------------------------------------------- FrStatDataWrite---*/
void FrStatDataWrite(struct FrStatData *sData,
                     struct FrFile *oFile)
                         /* write FrStatData structure on output file */
/*--------------------------------------------------------------------*/
{int i;

 if(sData == NULL) return;
 	 
   /*--- now write this bloc----*/
   /* first we check if this bloc has already been written */
   
 for(i=0; i<sData->nFile; i++)
   {if(sData->fileId[i] == oFile->id) {return;}}

  /*---- update the file list ------*/
 
 for(i=0; i<sData->nFile; i++)
   {sData->fileId[i] = FrFileId(sData->fileId[i], 1);
    if(sData->fileId[i] == 0)
       {sData->fileId[i] = oFile->id;
        break;}}

 if(i >= sData->nFile)
   {if(sData->maxFile == 0) 
     {sData->maxFile = 5;
      sData->fileId = malloc(sData->maxFile*sizeof(long));}

   if(i == sData->maxFile) 
     {sData->maxFile += 5;
      sData->fileId = realloc(sData->fileId, sData->maxFile*sizeof(long));}
    
   sData->fileId[i] = oFile->id;
   sData->nFile ++;}
 
    /*--- write the bloc ----*/
    
 if(FrDebugLvl > 1)
    {fprintf(FrFOut,"  Output FrStatData %s\n",sData->name);}

 FrPutNewRecord(oFile, sData);
 FrFileMarkStatD(oFile, sData);
 FrPutSChar (oFile, sData->name);
 FrPutSChar (oFile, sData->comment); 
 FrPutIntU  (oFile, sData->timeStart); 
 FrPutIntU  (oFile, sData->timeEnd); 
 FrPutIntU  (oFile, sData->version); 
 FrPutStruct(oFile, sData->detector); 
 FrPutStruct(oFile, sData->data); 
 FrPutWriteRecord(oFile);
  
   /* write the sData components */
 
 if(sData->data != NULL) 
   {if(sData->data->classe->objWrite == NULL)
       FrError(3,"FrStatData","No data write function");
    FrVectWrite(sData->data, oFile);}
  
   /*--- write the next data ---*/
   
 if(sData->next != NULL) {FrStatDataWrite(sData->next, oFile);}
 
 return;}

/*------------------------------------------------- FrStrCpy----------*/
char *FrStrCpy(char **copy,
               char *old)
/*--------------------------------------------------------------------*/
{
 if(old == NULL) 
    {*copy = NULL;
     return(*copy);}
 
 *copy = (char *) malloc(strlen(old)+1);  
 if(*copy == NULL) 
     {FrError(3,"FrStrCpy","malloc failed at line");} 
 else{strcpy(*copy ,old);}
 
 return(*copy);}

/*-------------------------------------------------FrStrGTime---------*/
char *FrStrGTime(unsigned int in)
/*--------------------------------------------------------------------*/
/* this function format a GPS time                                    */
/* the GPS time origin is Sun Jan  6 00:00:00 1980                    */
/* the C function time origin is Jan 1 00:00:00 1970 (no leap seconds)*/
/* (C time - GPS time = 3600*24*3567 = 315964800 seconds = FRGPSOFF)  */
{static char stringTime[30];
 time_t tp;
 
 tp = in + FRGPSOFF;
 strncpy(stringTime,asctime(gmtime(&tp)),24);

 return(stringTime);}
/*-------------------------------------------------- FrSummaryDef ----*/
struct FrSH *FrSummaryDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrSummary",FrSummaryRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "STRING", "test","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "moments","-");
  FrSENew(classe, "PTR_STRUCT(struct FrSummary *)", "next","-"); 

  return(classe);}
  
/*--------------------------------------------- FrSummaryFind---------*/
struct FrSummary *FrSummaryFind(struct FrameH *frameH, 
                                char *name)
/*--------------------------------------------------------------------*/
/* Return a pointer to the summary structure or NULL if not found     */

{struct FrSummary *sum;

 if(frameH == NULL)   return (NULL);

 sum = frameH->summaryData;
 while(sum != NULL)
    {if(strcmp(sum->name, name) == 0) return (sum);
     sum = sum->next;}
  
 return (NULL);}

/*--------------------------------------------------FrSummaryFree-----*/
struct FrSummary *FrSummaryFree(struct FrSummary *summary)
/*--------------------------------------------------------------------*/
{struct FrSummary *next; 

 if(summary == NULL) return(NULL);

 next = summary->next;

 if(summary->moments    != NULL) FrVectFree (summary->moments);
 if(summary->name    != NULL) free (summary->name);
 if(summary->comment != NULL) free (summary->comment);
 if(summary->test    != NULL) free (summary->test);

 free(summary);

 return(next);}

/*-------------------------------------------------FrSummaryNew ------*/
struct FrSummary *FrSummaryNew(struct FrameH *frameH,  
                               char *name, 
                               char *comment, 
                               char *test, 
                               struct FrVect *moments)
/*--------------------------------------------------------------------*/
{struct FrSummary *summary;
 
  summary = (struct FrSummary *) calloc(1,sizeof(struct FrSummary));
  if(summary == NULL) 
       {return(NULL);} 
  else {summary->classe = FrSummaryDef();}
	 
  if(FrStrCpy(&summary->name,name)       == NULL) return(NULL);
  if(FrStrCpy(&summary->comment,comment) == NULL) return(NULL);
  if(FrStrCpy(&summary->test,test)       == NULL) return(NULL);

  summary->moments = moments;
  
     /*----- now store it in the Frame structures -----*/

  if(frameH != NULL) 
    {summary->next = frameH->summaryData;
     frameH->summaryData = summary;}
  
  return(summary);} 

/*--------------------------------------------------- FrSummaryRead---*/
void FrSummaryRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSummary *summary;

  summary = (struct FrSummary *) calloc(1,sizeof(struct FrSummary));
  if(summary == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {summary->classe = FrSummaryDef();}

  FrReadHeader(iFile,  summary);
  FrReadSChar (iFile, &summary->name); 
  FrReadSChar (iFile, &summary->comment);
  FrReadSChar (iFile, &summary->test);
  FrReadStruct(iFile, &summary->moments);
  FrReadStruct(iFile, &summary->next);
    
return;}

 /*------------------------------------------------- FrSummaryWrite---*/
void FrSummaryWrite(struct FrSummary *summary,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
 
  FrPutNewRecord(oFile, summary);
  FrPutSChar (oFile, summary->name);
  FrPutSChar (oFile, summary->comment);
  FrPutSChar (oFile, summary->test);
  FrPutStruct(oFile, summary->moments);
  FrPutStruct(oFile, summary->next);
  FrPutWriteRecord(oFile);

           /* write the data */

  FrVectWrite(summary->moments, oFile);

           /* write next bloc if any */
 
  if(summary->next != NULL) FrSummaryWrite(summary->next, oFile);
 
 return;}

/*-------------------------------------------------- FrTrigDataDef ----*/
struct FrSH *FrTrigDataDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrTrigData",FrTrigDataRead);

  FrSENew(classe, "STRING", "name","-");
  FrSENew(classe, "STRING", "comment","-");
  FrSENew(classe, "STRING", "inputs","-");
  FrSENew(classe, "INT_4U", "GTimeS","-");
  FrSENew(classe, "INT_4U", "GTimeN","-");
  FrSENew(classe, "INT_4U", "bvalue","-");
  FrSENew(classe, "REAL_4", "rvalue","-");
  FrSENew(classe, "REAL_4", "probabilty","-");
  FrSENew(classe, "STRING", "statistics","-");
  FrSENew(classe, "PTR_STRUCT(FrVect *)",   "data","-");
  FrSENew(classe, "PTR_STRUCT(struct FrTrigData *)", "next","-"); 

  return(classe);}
  
/*--------------------------------------------- FrTrigDataFind---------*/
struct FrTrigData *FrTrigDataFind(struct FrameH *frameH, 
                                char *name)
/*--------------------------------------------------------------------*/
/* Return a pointer to the TrigData structure or NULL if not found     */

{struct FrTrigData *trig;

 if(frameH == NULL)   return (NULL);

 trig = frameH->trigData;
 while(trig != NULL)
    {if(strcmp(trig->name, name) == 0) return (trig);
     trig = trig->next;}
  
 return (NULL);}

/*--------------------------------------------------FrTrigDataFree-----*/
struct FrTrigData *FrTrigDataFree(struct FrTrigData *trigData)
/*--------------------------------------------------------------------*/
{struct FrTrigData *next; 

 if(trigData == NULL) return(NULL);

 next = trigData->next;

 if(trigData->data       != NULL) FrVectFree (trigData->data);
 if(trigData->name       != NULL) free (trigData->name);
 if(trigData->comment    != NULL) free (trigData->comment);
 if(trigData->inputs     != NULL) free (trigData->inputs);
 if(trigData->statistics != NULL) free (trigData->statistics);

 free(trigData);

 return(next);}

/*-------------------------------------------------FrTrigDataNew ------*/
struct FrTrigData *FrTrigDataNew(struct FrameH *frameH,  
                               char *name, 
                               char *comment, 
                               char *inputs, 
                               unsigned int GTimeS,
                               unsigned int GTimeN,  
                               unsigned int bvalue,
                               float  rvalue,
                               float  probability,
                               char   *stat,
                               struct FrVect *data)
/*--------------------------------------------------------------------*/
{struct FrTrigData *trigData;
 
  trigData = (struct FrTrigData *) calloc(1,sizeof(struct FrTrigData));
  if(trigData == NULL) 
       {return(NULL);} 
  else {trigData->classe = FrTrigDataDef();}
	 
  if(FrStrCpy(&trigData->name,name)       == NULL) return(NULL);
  if(FrStrCpy(&trigData->comment,comment) == NULL) return(NULL);
  if(FrStrCpy(&trigData->inputs,inputs)   == NULL) return(NULL);
  if(FrStrCpy(&trigData->statistics,stat) == NULL) return(NULL);

  trigData->GTimeS = GTimeS;
  trigData->GTimeN = GTimeN;
  trigData->bvalue = bvalue;
  trigData->rvalue = rvalue;
  trigData->probability = probability;
  trigData->data = data;
  
     /*----- now store it in the Frame structures -----*/

  if(frameH != NULL) 
     {trigData->next = frameH->trigData;
      frameH->trigData = trigData;}
  
  return(trigData);} 

/*--------------------------------------------------- FrTrigDataRead---*/
void FrTrigDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrTrigData *trigData;

  trigData = (struct FrTrigData *) calloc(1,sizeof(struct FrTrigData));
  if(trigData == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {trigData->classe = FrTrigDataDef();}

  FrReadHeader(iFile,  trigData);
  FrReadSChar (iFile, &trigData->name); 
  FrReadSChar (iFile, &trigData->comment);
  FrReadSChar (iFile, &trigData->inputs);
  FrReadIntU  (iFile, &trigData->GTimeS);
  FrReadIntU  (iFile, &trigData->GTimeN);
  FrReadIntU  (iFile, &trigData->bvalue);
  FrReadFloat (iFile, &trigData->rvalue);
  FrReadFloat (iFile, &trigData->probability);
  FrReadSChar (iFile, &trigData->statistics);
  FrReadStruct(iFile, &trigData->data);
  FrReadStruct(iFile, &trigData->next);
    
return;}

 /*------------------------------------------------- FrTrigDataWrite---*/
void FrTrigDataWrite(struct FrTrigData *trigData,
                    struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{
 
  FrPutNewRecord(oFile, trigData);
  FrPutSChar (oFile, trigData->name);
  FrPutSChar (oFile, trigData->comment);
  FrPutSChar (oFile, trigData->inputs);
  FrPutIntU  (oFile, trigData->GTimeS);
  FrPutIntU  (oFile, trigData->GTimeN);
  FrPutIntU  (oFile, trigData->bvalue);
  FrPutFloat (oFile, trigData->rvalue);
  FrPutFloat (oFile, trigData->probability);
  FrPutSChar (oFile, trigData->statistics);
  FrPutStruct(oFile, trigData->data);
  FrPutStruct(oFile, trigData->next);
  FrPutWriteRecord(oFile);

           /* write the data */

  FrVectWrite(trigData->data, oFile);

           /* write next data bloc if any */

  if(trigData->next != NULL) FrTrigDataWrite(trigData->next, oFile);
  
 return;}

/*---------------------------------------------------FrVectCompData---*/
unsigned short FrVectCompData(struct FrVect *vect,
                              int compType,
                              int gzipLevel,
                              unsigned char **result,
                              unsigned int *nBytes)
/*--------------------------------------------------------------------*/
/* compType = 1 -> gzip
            = 3 -> differentiate + gzip
            = 6 -> differentiate + Zcomp (only for short)
            = 7 -> differentiate + Zcomp for short and gzip for others
  This function returns the number of bytes of the compressed array
  passed as argument or 0 in case of failure.                        */
{int err, compValue;
 short ref;
 unsigned char *compr;
 unsigned long comprLen;
 char *swap, *dataIn;

         /*-------- first check if we need/can do the compression----*/

 if(vect == NULL)                                return(0);
 if(vect->compress == compType)                  return(0);

 if((vect->type != FR_VECT_2S && 
     vect->type != FR_VECT_2U) && compType == 5) return(0);
    
         /*----- if the vector is already compress, first expand it---*/

 if(vect->compress != 0)  FrVectExpand(vect);

         /*----------------- differentiate the data ------------------*/

 if(compType > 1)  
      {dataIn = FrVectDiff(vect);
       if(dataIn == NULL) {return(0);}}
 else {dataIn = vect->data;}

         /*--------------- reserve the output space ------------------*/

 comprLen = vect->nBytes;
 compr    = malloc(comprLen);
 if(compr == NULL) 
    {FrError(3,"FrCompress","malloc failed");
     return(0);}

        /*--------------------- do compression -----------------------*/

 if((vect->type == FR_VECT_2S || 
     vect->type == FR_VECT_2U) && compType > 3)
   {err = FrVectZComp((unsigned short *)compr, &comprLen, 
                  (short *)dataIn, vect->nData,6);}
 else
   {err = compress(compr, &comprLen, (const Bytef*)dataIn,
		   (uLong) vect->nBytes,gzipLevel);}

 if (err != Z_OK) 
    {FrError(3,"FrCompress","compression failed");
     free(compr);
     return(0);}

              /*------------ prepared the returned arguments----------*/

 *result = compr;
 *nBytes = comprLen;

 compValue = compType;
 swap = (char *)&ref;
 ref = 0x1234;
 if(swap[0] == 0x34) compValue = 256*compValue;

 return(compValue);}

/*---------------------------------------------------FrVectCompress---*/
void FrVectCompress(struct FrVect *vect,
                    int compType,
                    int gzipLevel)
/*--------------------------------------------------------------------*/
{unsigned char *result;
 unsigned short compress;
 unsigned int nBytes;
 
 compress = FrVectCompData(vect,compType,gzipLevel,&result,&nBytes);
 if(compress == 0) return;

 free(vect->data);

                /*--- all pointers except 'data' are set to NULL -----*/

 vect->data = NULL;
 FrVectMap(vect);
 vect->dataU = result;

 vect->nBytes = nBytes;
 vect->compress = compress;

 return;}

/*----------------------------------------------------FrVectCopy -----*/
struct FrVect *FrVectCopy(struct FrVect *vectin)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 long i;

   vect = (struct FrVect *) calloc(1,sizeof(struct FrVect));
   if(vect == NULL)  
        {return(NULL);}
   else {vect->classe = FrVectDef();}

   if(FrStrCpy(&vect->name, vectin->name) == NULL) return(NULL); 

   vect->compress = vectin->compress;
   vect->type     = vectin->type;
   vect->nData    = vectin->nData;
   vect->nBytes   = vectin->nBytes;
   vect->nDim     = vectin->nDim;
   vect->nx    = malloc(vectin->nDim*sizeof(long));
   vect->unitX = malloc(vectin->nDim*sizeof(char *));
   vect->dx    = malloc(vectin->nDim*sizeof(double));
   vect->startX= malloc(vectin->nDim*sizeof(double));
   if(vect->nx    == NULL || 
      vect->unitX == NULL || 
      vect->dx    == NULL || 
      vect->startX== NULL) return(NULL);

   for(i=0; i<vectin->nDim; i++)
     {vect->nx[i]     = vectin->nx[i];
      vect->dx[i]     = vectin->dx[i];
      vect->startX[i] = vectin->startX[i];
      FrStrCpy(&vect->unitX[i], vectin->unitX[i]);
      if(vect->unitX[i] == NULL && vectin->unitX[i] != NULL) return(NULL);}


   FrStrCpy(&vect->unitY, vectin->unitY);

   vect->wSize = vectin->wSize;
   vect->size = vectin->size;
   vect->data = malloc(vect->nBytes);
   if(vect->data == NULL) 
      {FrError(3,"FrVectCopy","malloc failed");
       return(NULL);}

   memcpy(vect->data, vectin->data, vect->nBytes);

   FrVectMap(vect);

   if(vectin->next != NULL) 
        {vect->next = FrVectCopy(vectin->next);}
   else {vect->next = NULL;}

   return(vect);
}

/*---------------------------------------------------- FrVectDef -----*/
struct FrSH *FrVectDef()
/*--------------------------------------------------------------------*/
{static struct FrSH *classe = NULL;

  if(classe != NULL) return(classe);
  classe = FrDicAddS("FrVect",FrVectRead);

  FrSENew(classe, "STRING",  "name","-");
  FrSENew(classe, "INT_2U",   "compress","-");
  FrSENew(classe, "INT_2U",   "type","-");
  FrSENew(classe, "INT_4U",   "nData","-");
  FrSENew(classe, "INT_4U",   "nBytes","-");
  FrSENew(classe, "*",        "data","-");
  FrSENew(classe, "INT_4U",   "nDim","-");
  FrSENew(classe, "INT_4U *", "nx","-");
  FrSENew(classe, "REAL_8 *", "dx","-");
  FrSENew(classe, "STRING *", "unitX", NULL);
  FrSENew(classe, "STRING",   "unitY", NULL);
  FrSENew(classe, "PTR_STRUCT(FrVect *)", "next", NULL);
 
  classe->objDump  = FrVectDump;
  classe->objWrite = FrVectWrite;
  classe->objFree  = FrVectFree;
/*  classe->objCopy  = (void *)(void *)FrVectCopy;*/

  return(classe);}

/*-------------------------------------------------------FrVectDiff---*/
char *FrVectDiff(struct FrVect *vect)
/*--------------------------------------------------------------------*/
/* This function return a pointer to the array of differented values  */
/* The input vector is unchanged                                      */
{int i,err;
 static char  *data, last;
 static short *dataS, lastS;
 static int  *dataI, lastI, localBytes = 0;
 static unsigned char  *dataU,  lastU;
 static unsigned short *dataUS, lastUS;
 static unsigned int   *dataUI, lastUI;

 if(vect == NULL) return(NULL);
 if(vect->nBytes > localBytes)
    {if(localBytes != 0) free(data);
     localBytes = vect->nBytes;
     data = (char *) malloc(localBytes);
     if(data == NULL) 
        {localBytes = 0;
         return(NULL);}

     dataS  = (short          *)data;
     dataI  = (int            *)data;
     dataU  = (unsigned char  *)data;
     dataUS = (unsigned short *)data;
     dataUI = (unsigned int   *)data;}

            /*----- differentiate and check ----*/
 err = 0;
 if(vect->type == FR_VECT_C)
   {data[0] = vect->data[0];
    last    =       data[0];
    for(i=1; i<vect->nData; i++)
      {data[i] = vect->data[i] - vect->data[i-1];
       last   +=       data[i];
       if(last != vect->data[i]) err = 1;}}

 else if(vect->type == FR_VECT_2S)
   {dataS[0] = vect->dataS[0];
    lastS    =       dataS[0];
    for(i=1; i<vect->nData; i++)
      {dataS[i] = vect->dataS[i] - vect->dataS[i-1];
       lastS   +=       dataS[i];
       if(lastS != vect->dataS[i]) err = 1;}}

 else if(vect->type == FR_VECT_4S) 
   {dataI[0] = vect->dataI[0];
    lastI    =       dataI[0];
    for(i=1; i<vect->nData; i++)
      {dataI[i] = vect->dataI[i] - vect->dataI[i-1];
       lastI   +=       dataI[i];
       if(lastI != vect->dataI[i]) err = 1;}}

 else if(vect->type == FR_VECT_1U) 
   {dataU[0] = vect->dataU[0];
    lastU    =       dataU[0];
    for(i=1; i<vect->nData; i++)
      {dataU[i] = vect->dataU[i] - vect->dataU[i-1];
       lastU   +=       dataU[i];
       if(lastU != vect->dataU[i]) err = 1;}}

 else if(vect->type == FR_VECT_2U)
   {dataUS[0] = vect->dataUS[0];
    lastUS    =       dataUS[0];
    for(i=1; i<vect->nData; i++)
      {dataUS[i] = vect->dataUS[i] - vect->dataUS[i-1];
       lastUS   +=       dataUS[i];
       if(lastUS != vect->dataUS[i]) err = 1;}}

 else if(vect->type == FR_VECT_4U) 
   {dataUI[0] = vect->dataUI[0];
    lastUI    =       dataUI[0];
    for(i=1; i<vect->nData; i++)
      {dataUI[i] = vect->dataUI[i] - vect->dataUI[i-1];
       lastUI   +=       dataUI[i];
       if(lastUI != vect->dataUI[i]) err = 1;}}

 else  {err = 2;}

           /*------ set the compress flag if ok ------*/

 if(err == 0)  {return (data);}

return(NULL);}

/*----------------------------------------------------- FrVectDump----*/
void FrVectDump(struct FrVect *vect,
                FILE *fp,
                long debugLvl)
/*--------------------------------------------------------------------*/
{int i;
 char *dC;
 short  *dS;
 int    *dI;  
 long   *dL; 
 float  *dF, ratio;  
 double *dD;
 unsigned char *dU;
 unsigned short *dUS;
 unsigned int *dUI;
 unsigned long *dUL; 

 if(fp   == NULL) return;
 if(vect == NULL) return;
 if(debugLvl < 1) return;

 if(vect->name == NULL)
      {fprintf(fp,"  Vector:- ndata=%d nDim=%d",
                      vect->nData, vect->nDim);}
 else {fprintf(fp,"  Vector:%s ndata=%d nDim=%d",
          vect->name, vect->nData, vect->nDim);}

 if(vect->compress == 0)
    {if     (vect->type == FR_VECT_4R) 
      {dF = (float *) vect->data;
       fprintf(fp,"(F) %e %e %e ...\n", dF[0],dF[1],dF[2]);}
    else if(vect->type == FR_VECT_8R)  
      {dD = (double *) vect->data;
     fprintf(fp,"(D) %e %e %e ...\n", dD[0],dD[1],dD[2]);}
    else if(vect->type == FR_VECT_C)  
      {dC = vect->data;
       fprintf(fp,"(C) %d %d %d %d %d ...\n", 
                             dC[0],dC[1],dC[2],dC[3],dC[4]);}
    else if(vect->type == FR_VECT_2S)  
      {dS = (short *) vect->data;
       fprintf(fp,"(S) %d %d %d %d %d ...\n", 
                            dS[0],dS[1],dS[2],dS[3],dS[4]);}
    else if(vect->type == FR_VECT_8S)  
      {dL = (long *) vect->data;
       fprintf(fp,"(L) %ld %ld %ld ...\n", dL[0],dL[1],dL[2]);}
    else if(vect->type == FR_VECT_4S)  
      {dI = (int *) vect->data;
       fprintf(fp,"(I) %d %d %d ...\n", dI[0],dI[1],dI[2]);}
    else if(vect->type == FR_VECT_1U)  
      {dU = (unsigned char *)vect->dataU;
       fprintf(fp,"(C) %d %d %d ...\n", dU[0],dU[1],dU[2]);}
    else if(vect->type == FR_VECT_2U)  
      {dUS = (unsigned short *) vect->data;
       fprintf(fp,"(S) %d %d %d ...\n", dUS[0],dUS[1],dUS[2]);}
    else if(vect->type == FR_VECT_8U)  
      {dUL = (unsigned long *) vect->data;
       fprintf(fp,"(L) %ld %ld %ld ...\n", dUL[0],dUL[1],dUL[2]);}
    else if(vect->type == FR_VECT_4U)  
      {dUI = (unsigned int *) vect->data;
       fprintf(fp,"(I) %d %d %d ...\n", dUI[0],dUI[1],dUI[2]);}
    else if(vect->type == FR_VECT_C8) 
      {dF = (float *) vect->data;
       fprintf(fp,"(CF) (%e,%e) (%e,%e) ...\n", dF[0],dF[1],dF[2],dF[3]);}
    else if(vect->type == FR_VECT_C16) 
      {dD = (double *) vect->data;
       fprintf(fp,"(CD) (%e,%e) (%e,%e) ...\n", dD[0],dD[1],dD[2],dD[3]);}
    else 
      {fprintf(fp,"unknown type: %d \n",vect->type );}}
  else 
    {ratio = ((float) vect->nBytes) /(vect->nData*vect->wSize);
     fprintf(fp,"\n     the vector is %4.2f compressed (%x)"
                " nBytes=%d wSize=%d\n",
            ratio,vect->compress,vect->nBytes, vect->wSize);}

 if(vect->unitY != NULL) 
         {fprintf(fp,"vertica unit=%s", vect->unitY);}
 
 for(i=0; i<vect->nDim; i++)
   {fprintf(fp,"      dimension=%i nx=%10d dx=%f",
              i,vect->nx[i], vect->dx[i]);
    if(vect->unitX[i] != NULL)
        {fprintf(fp," unit=%s", vect->unitX[i]);}
    else{fprintf(fp," no unit");}
    fprintf(fp," startX=%f\n",vect->startX[i]);}

 if(vect->next != NULL)
   {fprintf(fp,"  Attached information:\n");
    FrVectDump(vect->next, fp, debugLvl) ;}

 return;}

/*---------------------------------------------------FrVectExpand-----*/
void FrVectExpand(struct FrVect *vect)
/*--------------------------------------------------------------------*/
{int err;
 unsigned int i, nData;
 unsigned char *buf, local0, local1, local2, local3, *uncompr;
 unsigned long uncomprLen;
 char *refC;
 short ref, swap;

 if(vect == NULL) return;
 if(vect->compress == 0) return;
 
   /*---- do we have to swap the bytes ?---*/

 refC = (char *)&ref;
 ref = 0x1234;

 swap = (refC[0] == 0x34 && vect->compress < 255) ||
        (refC[0] == 0x12 && vect->compress > 255);

   /*----------------------- first expand the data ---*/

 uncomprLen = vect->nData * vect->wSize;
 uncompr    = (unsigned char*)calloc((int)uncomprLen, 1);
 if(uncompr == NULL) 
    {FrError(3,"FrVectExpand","malloc failed");
     return;}

 if((vect->compress ==   6) || 
    (vect->compress == 0x600))
     {if(swap)
          {buf = vect->dataU;
           for(i=0; i<vect->nBytes-1; i=i+2)
              {local0   = buf[i];
               buf[i]   = buf[i+1];
               buf[i+1] = local0;}}
       FrVectZExpand((short *) uncompr,
                     (unsigned short *)vect->data, vect->nData);}
 else if((vect->compress !=   2) &&
         (vect->compress != 0x200))
      {err = uncompress(uncompr, &uncomprLen, 
		       (const Bytef*)vect->data, vect->nBytes);
       if(err != Z_OK) 
          {FrError(3,"FrVectExpand","uncompress failed");
	   return;}}
 else
   {FrError(3,"FrVectExpand","unknown compression level");
     return;}

 free(vect->data);
 vect->data = (char *) uncompr;
 FrVectMap(vect);

 vect->nBytes =  vect->nData * vect->wSize;

   /*---------------------- swap bytes if needed --------*/
       
 if(swap && (vect->compress != 6) && (vect->compress != 0x600))
   {nData = vect->nData;
    if(vect->type == FR_VECT_C8)  nData = 2*nData;
    if(vect->type == FR_VECT_C16) nData = 2*nData;
    buf = vect->dataU;

    if((vect->type == FR_VECT_2S) ||
       (vect->type == FR_VECT_2U))
          {for(i=0; i<2*nData; i=i+2)
              {local0   = buf[i];
               buf[i]   = buf[i+1];
               buf[i+1] = local0;}}

    else if((vect->type == FR_VECT_4S) ||
         (vect->type == FR_VECT_4U) ||
         (vect->type == FR_VECT_4R) ||
         (vect->type == FR_VECT_C8))
       {for(i=0; i<4*nData; i=i+4)
           {local0 = buf[i];
            local1 = buf[i+1];
            buf[i]   = buf[i+3];
            buf[i+1] = buf[i+2];
            buf[i+2] = local1;
            buf[i+3] = local0;}} 

    else if((vect->type == FR_VECT_8S) ||
         (vect->type == FR_VECT_8U) ||
         (vect->type == FR_VECT_8R) ||
         (vect->type == FR_VECT_C16))
       {for(i=0; i<8*nData; i=i+8)
           {local0 = buf[i];
            local1 = buf[i+1];
            local2 = buf[i+2];
            local3 = buf[i+3];
            buf[i]   = buf[i+7];
            buf[i+1] = buf[i+6];
            buf[i+2] = buf[i+5];
            buf[i+3] = buf[i+4];
            buf[i+4] = local3;
            buf[i+5] = local2;
            buf[i+6] = local1;
            buf[i+7] = local0;}}}

   /*------------integrate the data if needed -----*/

 if((vect->compress & 0x202) != 0) FrVectInt(vect);

 vect->compress = 0;

 return;}

/*----------------------------------------------------FrVectFillC-----*/
void FrVectFillC(struct FrVect *vect,
                 char value)
/*--------------------------------------------------------------------*/
{
   if(vect->type != FR_VECT_C) 
      {FrError(3,"FrVectFillC","type missmatch");
       return;}
   if(vect->compress != 0) 
      {FrError(3,"FrVectFillC","Cannot fill: the vector is compressed");
       return;}
         
   if(vect->nData > vect->size)
      {vect->size = 2*vect->size;
       if(vect->size == 0) vect->size = 16;
       vect->data = realloc(vect->data, vect->size*sizeof(char));}

   vect->data[vect->nData] = value;
   vect->nData++;
   vect->nx[0]++;

   return;}

/*----------------------------------------------------FrVectFillI-----*/
void FrVectFillI(struct FrVect *vect,
                int value)
/*--------------------------------------------------------------------*/
{
   if(vect->type != FR_VECT_4S) 
      {FrError(3,"FrVectFillI","type missmatch");
       return;}
   if(vect->compress != 0) 
      {FrError(3,"FrVectFillI","Cannot fill: the vector is compressed");
       return;}
         
   if(vect->nData > vect->size)
      {vect->size = 2*vect->size;
       if(vect->size == 0) vect->size = 16;
       vect->data = realloc(vect->data, vect->size*sizeof(int));}

   vect->dataI[vect->nData] = value;
   vect->nData++;
   vect->nx[0]++;

   return;}

/*----------------------------------------------------FrVectFillS-----*/
void FrVectFillS(struct FrVect *vect,
                 short value)
/*--------------------------------------------------------------------*/
{
   if(vect->type != FR_VECT_2S) 
      {FrError(3,"FrVectFillS","type missmatch");
       return;}
   if(vect->compress != 0) 
      {FrError(3,"FrVectFillS","Cannot fill: the vector is compressed");
       return;}
         
   if(vect->nData > vect->size)
      {vect->size = 2*vect->size;
       if(vect->size == 0) vect->size = 16;
       vect->data = realloc(vect->data, vect->size*sizeof(short));}

   vect->dataS[vect->nData] = value;
   vect->nData++;
   vect->nx[0]++;

   return;}

/*---------------------------------------------------FrVectFree-------*/
void FrVectFree(struct FrVect *vect)
/*--------------------------------------------------------------------*/
{long i;

   if(vect->next != NULL) FrVectFree(vect->next);

   if(vect->data != NULL) free(vect->data);
   free(vect->nx);
   free(vect->dx);
   if(vect->unitY) {free(vect->unitY);}
   if(vect->unitX)
     {for(i=0; i<vect->nDim; i++)
       {if(vect->unitX[i] != NULL) free(vect->unitX[i]);}
      free(vect->unitX);}
   if(vect->name != NULL) free(vect->name);
   free(vect->startX);
   if(vect->expName != NULL) {free(vect->expName);}
   free(vect);

   return;}
/*---------------------------------------------------FrVectInt--------*/
void FrVectInt(struct FrVect *vect)
/*--------------------------------------------------------------------*/
{int i;

 if(vect == NULL) return;

 else if(vect->type == FR_VECT_C)
     {for(i=1; i<vect->nData; i++)
          {vect->data[i] = vect->data[i] + vect->data[i-1];}}

 else if(vect->type == FR_VECT_2S)
     {for(i=1; i<vect->nData; i++)
          {vect->dataS[i] = vect->dataS[i] + vect->dataS[i-1];}}

 else if(vect->type == FR_VECT_4S)
     {for(i=1; i<vect->nData; i++)
          {vect->dataI[i] = vect->dataI[i] + vect->dataI[i-1];}}

 else if(vect->type == FR_VECT_1U) 
     {for(i=1; i<vect->nData; i++)
          {vect->dataU[i] = vect->data[i] + vect->data[i-1];}}

 else if(vect->type == FR_VECT_2U)
     {for(i=1; i<vect->nData; i++)
          {vect->dataUS[i] = vect->dataS[i] + vect->dataS[i-1];}}

 else if(vect->type == FR_VECT_4U) 
     {for(i=1; i<vect->nData; i++)
          {vect->dataUI[i] = vect->dataI[i] + vect->dataI[i-1];}}

return;}
/*----------------------------------------------------FrVectMap ------*/
void FrVectMap(struct FrVect *vect)
/*--------------------------------------------------------------------*/
{
   if(vect == NULL) return;

   vect->dataS  = (short          *) vect->data;
   vect->dataI  = (int            *) vect->data;
   vect->dataL  = (long           *) vect->data;
   vect->dataF  = (float          *) vect->data;
   vect->dataD  = (double         *) vect->data;
   vect->dataU  = (unsigned char  *) vect->data;
   vect->dataUS = (unsigned short *) vect->data;
   vect->dataUI = (unsigned int   *) vect->data;
   vect->dataUL = (unsigned long  *) vect->data;

   return;}
   
/*----------------------------------------------------FrVectNew------*/
struct FrVect *FrVectNew(long type,
                         long nDim,
                          ...)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 va_list ap;
 static long i,first=0;
 char *unit;
 static int wSize[FR_VECT_END];

 if(first == 0)
    {first = 1;
     wSize[FR_VECT_4R]  = sizeof(float);
     wSize[FR_VECT_8R]  = sizeof(double);
     wSize[FR_VECT_C]   = sizeof(char);
     wSize[FR_VECT_1U]  = sizeof(char);
     wSize[FR_VECT_2S]  = sizeof(short);
     wSize[FR_VECT_2U]  = sizeof(short);
     wSize[FR_VECT_4S]  = sizeof(int);
     wSize[FR_VECT_4U]  = sizeof(int);
     wSize[FR_VECT_8S]  = sizeof(long);
     wSize[FR_VECT_8U]  = sizeof(long);
     wSize[FR_VECT_C8]  = 2*sizeof(float);
     wSize[FR_VECT_C16] = 2*sizeof(double);}

   vect = (struct FrVect *) calloc(1,sizeof(struct FrVect));
   if(vect == NULL)  
        {return(NULL);}
   else {vect->classe = FrVectDef();}

   vect->compress = 0;
   vect->type = type;
   vect->nDim = nDim;
   vect->nData = 1;
   vect->nx    = malloc(nDim*sizeof(long));
   vect->unitX = malloc(nDim*sizeof(char *));
   vect->dx    = malloc(nDim*sizeof(double));
   vect->startX= malloc(nDim*sizeof(double));
   if(vect->nx    == NULL || 
      vect->unitX == NULL || 
      vect->dx    == NULL || 
      vect->startX== NULL) 
       {FrError(3,"FrVectNew","malloc failed");
        return(NULL);}

   va_start(ap,nDim);
   for(i=0; i<nDim; i++)
     {vect->nx[i] = va_arg(ap,long);
      vect->dx[i] = va_arg(ap,double);
      unit = va_arg(ap,char *);
      FrStrCpy(&vect->unitX[i], unit);
      vect->nData = vect->nData*vect->nx[i];
      vect->startX[i] = 0.;}
   va_end(ap);

   vect->wSize  = wSize[vect->type];
   vect->size   = vect->nData;
   vect->nBytes = vect->nData*vect->wSize;
   
   if(vect->nData > 0)
       {vect->data = calloc(vect->nData, vect->wSize);
        if(vect->data == NULL) 
           {FrError(3,"FrVectNew","calloc failed");
            return(NULL);}}
   else{vect->data = NULL;
   for(i=0; i<nDim; i++) /*- check that nData should be really 0 */
          {if(vect->nx[i] == 0) break;  
           FrError(3,"FrVectNew","nData is too big");
           return(NULL);}}

   FrVectMap(vect);
 
   vect->unitY = NULL;
   vect->next  = NULL;

   return(vect);
}
/*-------------------------------------------------FrVectNewTS--------*/
struct FrVect *FrVectNewTS(char *name, 
                           double sampleRate, 
                           long nData, 
                           long nBits)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 double dx;
 long type;
 
  if(nBits >16)       {type = FR_VECT_4S;}
  else if(nBits >  8) {type = FR_VECT_2S;}
  else if(nBits >  0) {type = FR_VECT_C;}
  else if(nBits >-33) {type = FR_VECT_4R;}
  else                {type = FR_VECT_8R;}

  if(sampleRate == 0.)
       {dx = 0.;}
  else {dx = 1./sampleRate;}

  vect = FrVectNew1D(name,type,nData,dx,"time (s)",NULL);
  
  return(vect);} 
/*-------------------------------------------------FrVectNew1D -------*/
struct FrVect *FrVectNew1D(char *name, 
                           long type, 
                           long nData, 
                           double dx,
                           char *unitx,
                           char *unity)
/*--------------------------------------------------------------------*/
{struct FrVect *vect;
 
 vect = FrVectNew(type,1,nData,dx,unitx);
 if(vect == NULL) return(NULL);

 if(name != NULL)
   {if(FrStrCpy(&vect->name,name) == NULL) return(NULL);}

 if(unity != NULL)
   {if(FrStrCpy(&vect->unitY,unity) == NULL) return(NULL);}
  
 return(vect);} 

/*---------------------------------------------------FrVectRead ------*/
void FrVectRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrVect *v;
 static long first=0;
 static int wSize[FR_VECT_END];
 int i;

  if(first == 0)
    {first = 1;
     wSize[FR_VECT_4R]  = sizeof(float);
     wSize[FR_VECT_8R]  = sizeof(double);
     wSize[FR_VECT_C]   = sizeof(char);
     wSize[FR_VECT_1U]  = sizeof(char);
     wSize[FR_VECT_2S]  = sizeof(short);
     wSize[FR_VECT_2U]  = sizeof(short);
     wSize[FR_VECT_4S]  = sizeof(int);
     wSize[FR_VECT_4U]  = sizeof(int);
     wSize[FR_VECT_8S]  = sizeof(long);
     wSize[FR_VECT_8U]  = sizeof(long);
     wSize[FR_VECT_C8]  = 2*sizeof(float);
     wSize[FR_VECT_C16] = 2*sizeof(double);}
 
 v = (struct FrVect *) calloc(1,sizeof(struct FrVect));
 if(v == NULL)  
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 else {v->classe = FrVectDef();}
 
 FrReadHeader(iFile,  v);
 FrReadSChar( iFile, &v->name);
 FrReadShortU(iFile, &v->compress);
 FrReadShortU(iFile, &v->type);
 FrReadIntU  (iFile, &v->nData);
 FrReadIntU  (iFile, &v->nBytes);
 v->size = v->nData;

 if     (v->compress != 0)  
        {FrReadVC (iFile, &v->data, v->nBytes);}
 else if(v->type == FR_VECT_4R)  
        {FrReadVF (iFile, &v->dataF, v->nData);
	 v->data = (char *)v->dataF;}
 else if(v->type == FR_VECT_8R)  
        {FrReadVD (iFile, &v->dataD, v->nData);
	 v->data = (char *)v->dataD;}
 else if((v->type == FR_VECT_C ) || (v->type == FR_VECT_1U)) 
        {FrReadVC (iFile, &v->data, v->nData);}
 else if((v->type == FR_VECT_2S) || (v->type == FR_VECT_2U))
        {FrReadVS (iFile, &v->dataS, v->nData);
	 v->data = (char *)v->dataS;}
 else if((v->type == FR_VECT_4S) || (v->type == FR_VECT_4U))
        {FrReadVI (iFile, &v->dataI, v->nData);
	 v->data = (char *)v->dataI;}
 else if((v->type == FR_VECT_8S) || (v->type == FR_VECT_8U)) 
        {FrReadVL (iFile, &v->dataL, v->nData);
	 v->data = (char *)v->dataL;}
 else if(v->type == FR_VECT_C8) 
        {FrReadVF (iFile, &v->dataF, v->nData*2);
	 v->data = (char *)v->dataF;}
 else 
        {FrReadVD (iFile, &v->dataD, v->nData*2);
	 v->data = (char *)v->dataD;}

 if(iFile->error == FR_ERROR_MALLOC_FAILED) return;

 FrVectMap(v);

 FrReadIntU  (iFile, &v->nDim);
 FrReadVI (iFile,(int **) &v->nx,  v->nDim);
 FrReadVD (iFile, &v->dx,    v->nDim);
 FrReadVQ (iFile, &v->unitX, v->nDim);
 FrReadSChar (iFile, &v->unitY);
 FrReadStruct(iFile, &v->next);
 
 v->wSize= wSize[v->type];

 v->startX= malloc(v->nDim*sizeof(double));
 if(v->startX== NULL) 
       {FrError(3,"FrVectRead","malloc failed");
        return;}
 for(i=0; i<v->nDim; i++) {v->startX[i] = 0.;}

 if(iFile->compress == 0 && v->compress != 0) {FrVectExpand(v);}
 
 return;}
/*------------------------------------------------------FrVectWrite---*/
void FrVectWrite(struct FrVect *v, 
                 struct FrFile *oFile)
/*--------------------------------------------------------------------*/
{unsigned short compress;
 unsigned char *data;
 unsigned int nBytes;

 if(v == NULL) return;

    /*----- compress only if the vector is not properly compress -----*/
 
 compress = 0;
 if((oFile->compress != v->compress) &&
    (oFile->compress != -1)) 
     {compress = FrVectCompData(v, oFile->compress, 
                                   oFile->gzipLevel,&data, &nBytes);}
 if(compress == 0)
    {compress = v->compress;
     data     = v->dataU;
     nBytes   = v->nBytes;}

 FrPutNewRecord(oFile, v);
 FrPutSChar (oFile, v->name);
 FrPutShortU(oFile, compress);
 FrPutShortU(oFile, v->type);
 FrPutIntU  (oFile, v->nData);
 FrPutIntU  (oFile, nBytes);
 v->inMemory = oFile->p;
 if(compress != 0)             
     {FrPutVC (oFile, (char *)data, nBytes);
      if(data != v->dataU) free(data);}
 else if(v->type == FR_VECT_4R)  {FrPutVF (oFile, v->dataF, v->nData);}
 else if(v->type == FR_VECT_8R)  {FrPutVD (oFile, v->dataD, v->nData);}
 else if(v->type == FR_VECT_C)   {FrPutVC (oFile, v->data,  v->nData);}
 else if(v->type == FR_VECT_1U)  {FrPutVC (oFile, v->data,  v->nData);}
 else if(v->type == FR_VECT_2S)  {FrPutVS (oFile, v->dataS, v->nData);}
 else if(v->type == FR_VECT_2U)  {FrPutVS (oFile, v->dataS, v->nData);}
 else if(v->type == FR_VECT_4S)  {FrPutVI (oFile, v->dataI, v->nData);}
 else if(v->type == FR_VECT_4U)  {FrPutVI (oFile, v->dataI, v->nData);}
 else if(v->type == FR_VECT_8S)  {FrPutVL (oFile, v->dataL, v->nData);}
 else if(v->type == FR_VECT_8U)  {FrPutVL (oFile, v->dataL, v->nData);}
 else if(v->type == FR_VECT_C8)  {FrPutVF (oFile, v->dataF, v->nData*2);}
 else                            {FrPutVD (oFile, v->dataD, v->nData*2);}
 FrPutIntU(oFile, v->nDim);
 FrPutVI (oFile,(int *) v->nx,   (long) v->nDim);
 FrPutVD (oFile,        v->dx,   (long) v->nDim);
 FrPutVQ (oFile,       v->unitX, (long) v->nDim);
 FrPutSChar(oFile,  v->unitY);
 FrPutStruct(oFile, v->next);
 FrPutWriteRecord(oFile); 
	
 if(v->next != NULL) FrVectWrite(v->next, oFile);

 return;}


/*------------------------------------------------------FrVectZComp---*/
int FrVectZComp(unsigned short *out, 
                unsigned long *compL,
                short *data,
                int nData,
                int bSize)
/*--------------------------------------------------------------------*/
{unsigned short nBits, uData, limit;
 short max, pOut;
 int  iIn, iOut, i, maxOut;
 short wMax[] = {0,0,1,3,7,0xf,0x1f,0x3f,0x7f,0xff,0x1ff,
                   0x3ff,0x7ff,0xfff,0x1fff,0x3fff,0x7fff};

  maxOut = *compL/2;

 /*---- store the bloc size -----*/

 out[0] = bSize;
 iOut = 0;
 pOut = 16;

 /*--------- store the data  --------------*/

 iIn = 0;
 while(iIn<nData)

   { /*-------- tune the size of the last bloc -----*/

     if(iIn + bSize > nData) {bSize = nData - iIn;}

      /*---- get the maximum amplitude --------------*/
      
     max = 0;
     for(i=0; i<bSize; i++)  
          {if(data[iIn+i] > 0)
                {max = max |  data[iIn + i];}
           else {max = max | -data[iIn + i];}}

     /*----- determine the number of bits needed -----*/
     /*          (2*(max-1)  < 2**nBits)              */

     if(max > 127) 
       {if(max > 2047) 
          {if(max > 8191)
               {if(max > 16383) {nBits = 16;}
                else            {nBits = 15;}}
           else{if(max > 4095)  {nBits = 14;}
                else            {nBits = 13;}}}
        else
          {if(max > 511)
               {if(max > 1023)  {nBits = 12;}
                else            {nBits = 11;}}
           else{if(max > 255)   {nBits = 10;}
                else            {nBits = 9;}}}}
     else
       {if(max > 7) 
          {if(max > 31)
               {if(max > 63)    {nBits = 8;}
                else            {nBits = 7;}}
           else{if(max > 15)    {nBits = 6;}
                else            {nBits = 5;}}}
        else
          {if(max > 1)
               {if(max > 3)     {nBits = 4;}
                else            {nBits = 3;}}
           else{if(max > 0)     {nBits = 2;}
                else            {nBits = 1;}}}}

       /*---- encode the data size ----------*/
       /*---- we store nBits - 1 in 4 bits---*/

     out[iOut] = out[iOut] | ((nBits-1) << pOut);
     if(pOut > 12)
        {iOut ++;
         if(iOut >= maxOut) return(-1);
        pOut = pOut - 16;
        out[iOut] = (nBits-1) >> - pOut;}
     pOut  = pOut +4;

       /*--- encode the data itself ------*/

     if(nBits > 1)
       {limit = 16 - nBits;
        for(i = 0; i<bSize; i++)
          {uData = (unsigned short) (data[iIn+i] + wMax[nBits]);

           out[iOut] = out[iOut] | (uData << pOut);
           if(pOut > limit)
             {iOut ++;
              if(iOut >= maxOut) return(-1);
              pOut = pOut - 16;
              out[iOut] = uData >> -pOut;}
           pOut  = pOut + nBits;
        }  } 


     /*-------- increase pointer -------*/
  
     iIn = iIn + bSize;}

  *compL = 2*(iOut+1);

return(0);}

/*--------------------------------------------------FrVectZExpand-----*/
void FrVectZExpand(short *out, 
                   unsigned short *data, 
                   int nData)
/*--------------------------------------------------------------------*/
{unsigned short nBits, pIn, uData, *buf, *alpha;
 unsigned short wMax[] = {0,0,1,3,7,0xf,0x1f,0x3f,0x7f,0xff,0x1ff,
                      0x3ff,0x7ff,0xfff,0x1fff,0x3fff,0x7fff};
 unsigned short mask[] = {0,1,3,7,0xf,0x1f,0x3f,0x7f,0xff,0x1ff,
                      0x3ff,0x7ff,0xfff,0x1fff,0x3fff,0x7fff,0xffff};
 unsigned int iBuf, iAlpha;
 int  i, iIn, iOut, bSize;

 /*----- check which indian --------*/

 iAlpha = 0x12345678;
 alpha = (unsigned short *) &iAlpha;

 /*---- retrieve the bloc size -----*/

 bSize = data[0];
 iIn = 1;
 pIn = 0;

 /*--------- retrieve the data  --------------*/

 buf = (unsigned short *) &iBuf; 
 iOut = 0;
 do
    {/*-------- extract nBits -------------
        -----(we check if data is in 1 or 2 words) ------*/
        
    if(pIn <= 12)
       {uData = data[iIn] >> pIn;
        pIn = pIn + 4;}
     else
       {buf[0] = data[iIn];
        iIn++;
        if(alpha[0] == 0x1234)
             {buf[1] = buf[0];
              buf[0] = data[iIn];}
        else {buf[1] = data[iIn];}
        uData = iBuf >> pIn;
        pIn = pIn - 12;}

    nBits = 1 + (mask[4] & uData);
    if(nBits == 1) nBits = 0;

     /*----extract data ----------*/

     for(i=0; i<bSize; i++)
       {if(iOut >= nData) break;

        if(pIn + nBits <= 16)
          {uData = data[iIn] >> pIn;
           pIn = pIn + nBits;}
        else
          {buf[0] = data[iIn];
           iIn++;
           if(alpha[0] == 0x1234)
                {buf[1] = buf[0];
                 buf[0] = data[iIn];}
           else {buf[1] = data[iIn];}  
           uData = iBuf >> pIn;
           pIn = pIn + nBits - 16;}

        out[iOut] = (mask[nBits] & uData) - wMax[nBits];
        iOut++;}}
 while(iOut<nData);

return;}

/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/*  Here is a set of function used for backward compatibility         */
/*    FrBackNxxx is used to read file written with format N           */
/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/*--------------------------------------------------------------------*/
/*----------------------------------------------- FrBack2ResetRead----*/
void FrBack2ResetRead(struct FrFile *file)
/*--------------------------------------------------------------------*/
{
 file->FrSHRead = FrBack2SHRead;

       FrameHDef()->objRead = FrBack2FrameHRead;
    FrAdcDataDef()->objRead = FrBack2AdcDataRead;
   FrDetectorDef()->objRead = FrBack2DetectorRead;
 FrEndOfFrameDef()->objRead = FrBack2EndOfFrameRead;
    FrHistoryDef()->objRead = FrBack2HistoryRead;
    FrSimDataDef()->objRead = FrBack2SimDataRead;
   FrStatDataDef()->objRead = FrBack2StatDataRead;
       FrVectDef()->objRead = FrBack2VectRead;                             
        FrMsgDef()->objRead = FrBack2MsgRead;
   FrProcDataDef()->objRead = FrBack2ProcDataRead;
    FrSerDataDef()->objRead = FrBack2SerDataRead;
 FrStrCpy(     &FrMsgDef()->name,"FrErrMsg");
 FrStrCpy(&FrProcDataDef()->name,"FrRecData");
 FrStrCpy( &FrSerDataDef()->name,"FrSmsData"); 
/*
 FrDicAddS("FrErrMsg",  FrBack2MsgRead);
 FrDicAddS("FrRecData", FrBack2ProcDataRead);
 FrDicAddS("FrSmsData", FrBack2SerDataRead);
*/
 return;}


/*----------------------------------------------- FrBack2FileOpen-----*/
void FrBack2FileOpen(struct FrFile *file)
/*--------------------------------------------------------------------*/
{unsigned char *h,l[32];

 file->fmtVersion = 2;
 if(FrDebugLvl > 0) fprintf(FrFOut,
      "FrBack2FileOpen: this is a OBSOLATE Binary file (version2)\n");
 if(FrRead(file, (char *) file->header+1, 31) != 31)  
      {FrError(3,"FrBack2FileOpen","read failled"); 
       file->error = FR_ERROR_READ_ERROR;
       return;}

     /*----- for binary files select check byte swaping and word lenght---*/

 FrBack2FileHeader(l);
 h = file->header;
 if(FrDebugLvl > 1)
       {fprintf(FrFOut,
          " Header(local): Sizeof=%d(%d) %d(%d) %d(%d) %d(%d) %d(%d)\n",
                    h[1],l[1],h[2],l[2],h[3],l[3],h[4],l[4],h[5],l[5]);
        fprintf(FrFOut,
          "         SwapS:%3x%3x(%3x%3x)  %3x%3x%3x%3x(%3x%3x%3x%3x)\n",
          h[6],h[7],l[6],l[7],h[8],h[9],h[10],h[11],l[8],l[9],l[10],l[11]);
        fprintf(FrFOut,"         FPi:%3x%3x%3x%3x(%3x%3x%3x%3x)\n",
                    h[16],h[17],h[18],h[19],l[16],l[17],l[18],l[19]);
        fprintf(FrFOut,"         DPi:%3x%3x%3x%3x%3x%3x%3x%3x"
                                   "(%3x%3x%3x%3x%3x%3x%3x%3x)\n",
                    h[24],h[25],h[26],h[27],h[28],h[29],h[30],h[31],
                    l[24],l[25],l[26],l[27],l[28],l[29],l[30],l[31]);}

 file->fmType = FRNATIVE;
 file->fmLong = FRNATIVE;
 if(memcmp(&h[1],&l[1],11) == 0)               
     {if(FrDebugLvl > 0) fprintf(FrFOut,
                 " No format conversion is needed\n");}
 else{if(FrDebugLvl > 0) fprintf(FrFOut,
                " Format conversion is needed\n");
      if(h[6] == l[7])
            {file->fmType = FRSWAP;
             file->fmLong = FRSWAP;
             if(FrDebugLvl > 0) fprintf(FrFOut," We will swap bytes\n");}
      if(FrSlong == 8 && h[3] == 4) 
            {if(file->fmLong == FRSWAP) 
                 {file->fmLong = FREXPAND_AND_SWAP;}
             else{file->fmLong = FREXPAND;}
             if(FrDebugLvl > 0) fprintf(FrFOut,
                " We will convert long from 4 bytes word to 8 bytes\n");}
      if(FrSlong == 4 && h[3] == 8) 
            {if(file->fmLong == FRSWAP) 
                 {file->fmLong = FRCONTRACT_AND_SWAP;}
             else{file->fmLong = FRCONTRACT;}
             if(FrDebugLvl > 0) fprintf(FrFOut,
                " We will convert long from 8 bytes word to 4 bytes\n");
      if(file->fmLong == FRNATIVE) 
           {if(FrDebugLvl > 0) fprintf(FrFOut," Strange format\n");
            FrError(3,"FrBack2FileOpen","Strange format");}
     }  }


  /*------ reset some read function for backward compatibility ---*/

 FrBack2ResetRead(file);
 h[9] = h[3];

 return;}
/*--------------------------------------------- FrBack2FileHeader-----*/
void FrBack2FileHeader(unsigned char *buf)
/*--------------------------------------------------------------------*/
{short swapS;
 int swapI;
 double dPi;
 float fPi;
 
 buf[0] = 2;
 buf[1] = FrSshort;
 buf[2] = FrSint;
 buf[3] = FrSlong;
 buf[4] = FrSfloat;
 buf[5] = FrSdouble;
 swapS = 0x1234;         
 swapI = 0x12345678;
 fPi = 3.1415926535897932384626; 
 dPi = 3.1415926535897932384626;
 memcpy(&buf[6],&swapS,2);
 memcpy(&buf[8],&swapI,FrSint);
 memcpy(&buf[16],&fPi,FrSfloat);
 memcpy(&buf[24],&dPi,FrSdouble);
   
 return;}
/*--------------------------------------------------- FrBack2SHRead---*/
void FrBack2SHRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSH *sh, *shDup;
 short id0;
 long id,i;
 char *name;

 if(iFile->error != FR_OK) return;
  
 FrReadShort(iFile, &id0);
 FrReadLong (iFile, &id); 
 FrReadSChar(iFile, &name); 

       /*--- check for existing sh structure ----*/
       
 for(i=0; i<iFile->maxSH; i++)
    {shDup = iFile->sh[i];
     if(shDup == NULL)       continue;
     if(shDup->name == NULL) continue;
     if(strcmp(name,shDup->name) == 0) 
       {FrError(3,"FrSHRead","Duplicate FrSH. Data may be corrupted");
        return;}}

      /*---- add it in the list --------*/

 if(id >= iFile->maxSH) 
      {FrFileIncSH(iFile,(unsigned int) id);
       if(iFile->error != FR_OK) return;}

 sh = iFile->sh[id];
 if(sh == NULL)
   {sh = FrSHNew(name,NULL);
    sh->id = id;
    iFile->sh[id] = sh;
    if(name    != NULL) free(name);}
 else
   {sh->name = name;}

 iFile->curSH = sh;

 return;}
/*------------------------------------------------FrBack2FrameHRead---*/
void FrBack2FrameHRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrameH *frameH;
 int i;
 long l;

  frameH = (struct FrameH *) calloc(1,sizeof(struct FrameH));
  if(frameH == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {frameH->classe = FrameHDef();}
    
  FrReadHeader(iFile,  frameH);
  FrReadSChar( iFile, &frameH->name);
  FrReadInt   (iFile, &i); frameH->run = i;
  FrReadInt   (iFile, &i); frameH->frame = i;
  FrReadLong  (iFile, &l); frameH->GTimeS = l-315964811;
  FrReadLong  (iFile, &l); frameH->GTimeN = l;
  FrReadLong  (iFile, &l); frameH->localTime = l;
  FrReadDouble(iFile, &frameH->dt);
  FrReadStruct(iFile, &frameH->type);
  FrReadStruct(iFile, &frameH->user);
  FrReadStruct(iFile, &frameH->detectSim);
  FrReadStruct(iFile, &frameH->detectProc);
  FrReadStruct(iFile, &frameH->history);
  FrReadStruct(iFile, &frameH->rawData);
  FrReadStruct(iFile, &frameH->procData);
  FrReadStruct(iFile, &frameH->simData);
  FrReadStruct(iFile, &frameH->trigData);
  FrReadStruct(iFile, &frameH->summaryData);
  FrReadStruct(iFile, &frameH->auxData);

  frameH->strain = NULL;

  if(FrDebugLvl > 0)
    {fprintf(FrFOut, " Start reading frame\n (run=%d frame=%d)\n",
               frameH->run,frameH->frame);}

  iFile->curFrame = frameH;
   
  return;}
/*---------------------------------------------- FrBack2AdcDataRead---*/
void FrBack2AdcDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrAdcData *adcData;
 int i;
 double b;

  adcData = (struct FrAdcData *) calloc(1,sizeof(struct FrAdcData));
  if(adcData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {adcData->classe = FrAdcDataDef();}

  FrReadHeader(iFile,  adcData);
  FrReadSChar( iFile, &adcData->name);
  FrReadSChar (iFile, &adcData->comment);
  FrReadIntU  (iFile, &adcData->crate);
  FrReadInt   (iFile, &i);
  FrReadIntU  (iFile, &adcData->channel);
  FrReadIntU  (iFile, &adcData->nBits);
  FrReadDouble(iFile, &b); adcData->bias = b;
  FrReadDouble(iFile, &adcData->sampleRate);
  FrReadIntU  (iFile, &adcData->timeOffsetS);
  FrReadIntU  (iFile, &adcData->timeOffsetN);
  FrReadDouble(iFile, &adcData->fShift);
  FrReadStruct(iFile, &adcData->data);
  FrReadStruct(iFile, &adcData->aux);
  FrReadStruct(iFile, &adcData->next);
    
return;}
/*--------------------------------------------- FrBack2DetectorRead---*/
void FrBack2DetectorRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrDetector *detector;
 double longitude, latitude, elevation, 
         armXazimuth, armYazimuth,armLength;
 
  detector = (struct FrDetector *) calloc(1,sizeof(struct FrDetector));
  if(detector == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {detector->classe = FrDetectorDef();}
  
  FrReadHeader(iFile,  detector);
  FrReadSChar( iFile, &detector->name);
  FrReadDouble(iFile, &longitude);
  FrReadDouble(iFile, &latitude);
  FrReadDouble(iFile, &elevation);
  FrReadDouble(iFile, &armXazimuth); 
  FrReadDouble(iFile, &armYazimuth); 
  FrReadDouble(iFile, &armLength);
  FrReadDouble(iFile, &armLength); 
  detector->latitudeD  = latitude  * 180./3.11416; 
  detector->longitudeD = longitude * 180./3.11416; 
  detector->elevation = elevation;
  detector->armXazimuth = armXazimuth;
  detector->armYazimuth = armYazimuth;
  detector->armLength   = armLength;
  FrReadStruct(iFile, &detector->more); 

  FrCurDetector = detector;

  return;}
 
/*------------------------------------------- FrBack2EndOfFrameRead---*/
void FrBack2EndOfFrameRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{long  run,frameNumber;
 unsigned short instance;

  FrReadShortU(iFile, &instance);
  FrReadLong(iFile, &run);
  FrReadLong(iFile, &frameNumber);

  if(FrDebugLvl > 0)
    {fprintf(FrFOut, "End reading frame\n  Run:%ld Frame:%ld\n",
               run,frameNumber);}

  /*------ check that the frame is not corrupted -----*/

  if(run != iFile->curFrame->run)
     {FrError(3,"FrEndOfFrameRead","run number missmatch");
      iFile->error = FR_ERROR_BAD_END_OF_FRAME;
      return;}

  if(frameNumber != iFile->curFrame->frame)
     {FrError(3,"FrEndOfFrameRead","frame number missmatch");
      iFile->error = FR_ERROR_BAD_END_OF_FRAME;
      return;}

  iFile->endOfFrame = FR_YES;

  return;}

/*---------------------------------------------- FrBack2HistoryRead---*/
void FrBack2HistoryRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrHistory *history;
 long l;

  history = (struct FrHistory *) calloc(1,sizeof(struct FrHistory));
  if(history == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {history->classe = FrHistoryDef();}
  
  FrReadHeader(iFile,  history);
  FrReadSChar( iFile, &history->name);
  FrReadLong  (iFile, &l); history->time = l-315964811;
  FrReadSChar (iFile, &history->comment);
  FrReadStruct(iFile, &history->next);
   
return;}


/*-------------------------------------------------- FrBack2MsgRead---*/
void FrBack2MsgRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrMsg *msg;
 long severity;

  msg = (struct FrMsg *) calloc(1,sizeof(struct FrMsg));
  if(msg == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {msg->classe = FrMsgDef();}

  FrReadHeader(iFile,  msg);
  FrReadSChar( iFile, &msg->alarm);
  FrReadSChar (iFile, &msg->message);
  FrReadLong  (iFile, &severity);
  msg->severity = severity;
  FrReadStruct(iFile, &msg->next);
    
return;}

/*--------------------------------------------- FrBack2ProcDataRead---*/
void FrBack2ProcDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrProcData *procData;

  procData = (struct FrProcData *) calloc(1,sizeof(struct FrProcData));
  if(procData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {procData->classe = FrProcDataDef();}
  
  FrReadHeader(iFile,  procData);
  FrReadSChar( iFile, &procData->name);
  FrReadSChar( iFile, &procData->comment);
  FrReadDouble(iFile, &procData->sampleRate);
  FrReadInt   (iFile,(int *) &procData->timeOffsetS);
  FrReadInt   (iFile,(int *) &procData->timeOffsetN);
  FrReadDouble(iFile, &procData->fShift);
  FrReadStruct(iFile, &procData->data);
  FrReadStruct(iFile, &procData->aux);
  FrReadStruct(iFile, &procData->next);

  return;}
  
/*---------------------------------------------- FrBack2SerDataRead---*/
void FrBack2SerDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSerData *smsData;
 long timeSec;

  smsData = (struct FrSerData *) calloc(1,sizeof(struct FrSerData));
  if(smsData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {smsData->classe = FrSerDataDef();}
  
  FrReadHeader(iFile,  smsData);
  FrReadSChar( iFile, &smsData->name);
  FrReadLong  (iFile, &timeSec);
  smsData->timeSec = timeSec;
  FrReadSChar (iFile, &smsData->data);
  FrReadStruct(iFile, &smsData->more);
  FrReadStruct(iFile, &smsData->next);
    
 return;} 


/*---------------------------------------------- FrBack2SimDataRead---*/
void FrBack2SimDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrSimData *simData;
 long dt;

  simData = (struct FrSimData *) calloc(1,sizeof(struct FrSimData));
  if(simData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {simData->classe = FrSimDataDef();}

  FrReadHeader(iFile,  simData);
  FrReadSChar( iFile, &simData->name);
  FrReadLong  (iFile, &dt); simData->sampleRate = dt;
  FrReadStruct(iFile, &simData->data);
  FrReadStruct(iFile, &simData->input);
  FrReadStruct(iFile, &simData->next);
    
return;}
/*--------------------------------------------- FrBack2StatDataRead---*/
void FrBack2StatDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;
 unsigned short id;
 long t;
 
  sData = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
  if(sData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {sData->classe = FrStatDataDef();}

  FrReadShortU(iFile, &id);  /*statData are not referenced by pointer*/
  FrReadSChar( iFile, &sData->name);
  FrReadSChar (iFile, &sData->comment); 
  FrReadLong  (iFile, &t); sData->timeStart = t-315964811; 
  FrReadLong  (iFile, &t); sData->timeEnd   = t-315964811; 
  FrReadLong  (iFile, &t); sData->version =t; 
  FrReadStruct(iFile, &sData->data); 

  sData->nFile = 0;
  sData->fileId = NULL;
  sData->maxFile = 0;

  sData->detector = FrCurDetector;
  sData->next = iFile->sDataCur;
  iFile->sDataCur = sData;

  return;}
 
 /*----------------------------------------------FrBack2VectRead ------*/
void FrBack2VectRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrVect *v;
 long i,type, nData, nDim, *nx;
 long first=0;
 int wSize[FR_VECT_END];

 if(first == 0)
    {first = 1;
     wSize[FR_VECT_4R]  = sizeof(float);
     wSize[FR_VECT_8R]  = sizeof(double);
     wSize[FR_VECT_C]   = sizeof(char);
     wSize[FR_VECT_1U]  = sizeof(char);
     wSize[FR_VECT_2S]  = sizeof(short);
     wSize[FR_VECT_2U]  = sizeof(short);
     wSize[FR_VECT_4S]  = sizeof(int);
     wSize[FR_VECT_4U]  = sizeof(int);
     wSize[FR_VECT_8S]  = sizeof(long);
     wSize[FR_VECT_8U]  = sizeof(long);
     wSize[FR_VECT_C8]  = 2*sizeof(float);
     wSize[FR_VECT_C16] = 2*sizeof(double);}
 
 v = (struct FrVect *) calloc(1,sizeof(struct FrVect));
 if(v == NULL)  
      {iFile->error = FR_ERROR_MALLOC_FAILED;
       return;}
 else {v->classe = FrVectDef();}

 FrReadHeader(iFile,  v);
 FrReadSChar( iFile, &v->name);
 FrReadLong  (iFile, &type);
 v->type = type;
 FrReadLong  (iFile, &nData);
 v->nData = nData;
 v->size = v->nData;

 if     (v->type == FR_VECT_4R)  
        {FrReadVF (iFile, &v->dataF, v->nData);
	 v->data = (char *)v->dataF;}
else if(v->type == FR_VECT_8R)  
        {FrReadVD (iFile, &v->dataD, v->nData);
	 v->data = (char *)v->dataD;}
 else if(v->type == FR_VECT_C)  
        {FrReadVC (iFile, &v->data, v->nData);}
 else if(v->type == FR_VECT_2S)  
        {FrReadVS (iFile, &v->dataS, v->nData);
	 v->data = (char *)v->dataS;}
 else if(v->type == FR_VECT_4S)  
        {FrReadVI (iFile, &v->dataI, v->nData);
	 v->data = (char *)v->dataI;}
 else if(v->type == FR_VECT_8S)  
        {FrReadVL (iFile, &v->dataL, v->nData);
	 v->data = (char *)v->dataL;}
 else if(v->type == FR_VECT_C8) 
        {FrReadVF (iFile, &v->dataF, v->nData*2);
	 v->data = (char *)v->dataF;}
 else 
        {FrReadVD (iFile, &v->dataD, v->nData*2);
	 v->data = (char *)v->dataD;}

 if(iFile->error == FR_ERROR_MALLOC_FAILED) return;

 FrVectMap(v);
 v->wSize = wSize[v->type];
 v->nBytes = v->wSize*v->nData;

 FrReadLong  (iFile, &nDim);
 v->nDim = nDim;
 v->nx = (unsigned int *) calloc(nDim,sizeof(int));
 FrReadVL (iFile, &nx,    (unsigned int) nDim);
 for(i=0; i<nDim; i++)
   {v->nx[i] = nx[i];}
 free(nx);
 FrReadVD (iFile, &v->dx,    (unsigned int)nDim);
 FrReadVQ (iFile, &v->unitX, (unsigned int)  nDim);

 v->startX= malloc(v->nDim*sizeof(double));
 if(v->startX== NULL) 
       {FrError(3,"FrVectRead","malloc failed");
        return;}
 for(i=0; i<v->nDim; i++) {v->startX[i] = 0.;}

 FrReadStruct(iFile, &v->next);
 
 return;}
/*------------------------------------------------FrBack3FrameHRead---*/
void FrBack3FrameHRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrameH *frameH;
 unsigned short id;

  frameH = (struct FrameH *) calloc(1,sizeof(struct FrameH));
  if(frameH == NULL) 
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {frameH->classe = FrameHDef();} 
  
  FrReadShortU(iFile, &id);  /*frameH are not referenced by pointer*/
  FrReadSChar (iFile, &frameH->name); 
  FrReadIntU  (iFile, &frameH->run);
  FrReadIntU  (iFile, &frameH->frame);
  FrReadIntU  (iFile, &frameH->GTimeS); 
  frameH->GTimeS -= 315964811;
  FrReadIntU  (iFile, &frameH->GTimeN);
  /*  FrReadShortU  (iFile, &frameH->ULeapS); only since version 3.30*/
  FrReadInt   (iFile, &frameH->localTime);
  FrReadDouble(iFile, &frameH->dt);
  FrReadStruct(iFile, &frameH->type);
  FrReadStruct(iFile, &frameH->user);
  FrReadStruct(iFile, &frameH->detectSim);
  FrReadStruct(iFile, &frameH->detectProc);
  FrReadStruct(iFile, &frameH->history);
  FrReadStruct(iFile, &frameH->rawData);
  FrReadStruct(iFile, &frameH->procData);
  FrReadStruct(iFile, &frameH->strain);
  FrReadStruct(iFile, &frameH->simData);
  FrReadStruct(iFile, &frameH->trigData);
  FrReadStruct(iFile, &frameH->summaryData);
  FrReadStruct(iFile, &frameH->auxData);

  if(FrDebugLvl > 0)
    {fprintf(FrFOut, "FrameHRead:      start reading frame (run=%d "
          "frame=%d)\n",frameH->run,frameH->frame);}

  iFile->curFrame = frameH;
   
  return;}
/*------------------------------------------- FrBack3FrStatDataRead---*/
void FrBack3FrStatDataRead(struct FrFile *iFile)
/*--------------------------------------------------------------------*/
{struct FrStatData *sData;
 unsigned short id;
 
  sData = (struct FrStatData *) calloc(1,sizeof(struct FrStatData));
  if(sData == NULL)  
       {iFile->error = FR_ERROR_MALLOC_FAILED;
        return;}
  else {sData->classe = FrStatDataDef();}

  FrReadShortU(iFile, &id);  /*statData are not referenced by pointer*/
  FrReadSChar( iFile, &sData->name);
  FrReadSChar (iFile, &sData->comment); 
  FrReadIntU  (iFile, &sData->timeStart);  
  FrReadIntU  (iFile, &sData->timeEnd);  
  sData->timeStart -= 315964811;
  sData->timeEnd   -= 315964811;
  FrReadIntU  (iFile, &sData->version); 
  FrReadStruct(iFile, &sData->data); 

  sData->nFile = 0;
  sData->fileId = NULL;
  sData->maxFile = 0;

  sData->next = iFile->sDataCur;
  iFile->sDataCur = sData;
  sData->detector = FrCurDetector;

  return;}



